/*
  $Id: config.h,v 1.2 2000/03/02 09:03:35 jacobs Exp jacobs $

  $Log: config.h,v $
  Revision 1.2  2000/03/02 09:03:35  jacobs
  3 new filters (MAX_PAUSE, SG_PLAYERDETAILS, PLAYERS_MINIMUM)

  Revision 1.1  2000/02/14 11:02:13  jacobs
  Initial revision

*/

#ifndef __CONFIG_HPP__
#define __CONFIG_HPP__


#include "tools/hpj_iarray.h"



#define NOF_FORMATS     26
#define FORMAT_NAME     0
#define FORMAT_TIME     1
#define FORMAT_GAMES    2
#define FORMAT_GAMESWON 3
#define FORMAT_KILLS    4
#define FORMAT_SUICIDES 5
#define FORMAT_TEAMKILLS 6
#define FORMAT_DEATHS   7
#define FORMAT_FRAGS    8
#define FORMAT_FPH      9
#define FORMAT_EFF      10
#define FORMAT_TTL      11
#define FORMAT_ITEMS    12
#define FORMAT_TALKS    13
#define FORMAT_SOS      14
#define FORMAT_CTFSCORE 15
#define FORMAT_FSTEALS  16
#define FORMAT_FPICKUPS 17
#define FORMAT_FLOSS    18
#define FORMAT_FSUICIDE 19
#define FORMAT_FAUTORET 20
#define FORMAT_FCAPTURE 21
#define FORMAT_FKILLS   22
#define FORMAT_FRETURN  23
#define FORMAT_CTFGAMES 24
#define FORMAT_CTFGAMESWON 25

/** This struct contains the configurable informations */
typedef struct {
  char *templdir, *outdir, *calculation, *mapfile, *lt_file;
  char  b_showall, b_puretext, b_kick, b_warmup;
  char  b_savestats, b_funname, b_ltstats;
  char  b_forcemyformat, b_sgpdetails, b_sgtalks;
  int   linelimit, zcompression, game_minimum, pause_maximum;
  int   time_minimum, time_ltminimum, player_minimum;

  hpj_iarray *tableformat, *templateformat;
}hpj_config;


/** Creates a new config-struct.*/
hpj_config *config_new();

/** Load a config */
hpj_config *config_new_load(char *filename);

/** Reads a format-string and sets the table-format internally*/
hpj_iarray *config_parseTableFormat(char *format);

/** Display the contents of the cfg-struct */
void config_show(hpj_config *cfg);

/** Deletes a config-file.*/
hpj_config *config_del(hpj_config *cfg);

#endif
