/*
  This file contains the constants and some functions for
  handling the structs.

  $Id: game.c,v 1.1 1999/12/28 22:34:38 jacobs Exp jacobs 

  $Log: game.c,v $
  Revision 2.7  2000/03/02 09:03:35  jacobs
  *** empty log message ***

  Revision 2.6  2000/02/14 11:02:13  jacobs
  *** empty log message ***

  Revision 2.5  2000/02/06 20:18:43  jacobs
  *** empty log message ***

  Revision 2.4  2000/01/29 21:41:00  jacobs
  *** empty log message ***

  Revision 2.3  2000/01/25 22:53:37  jacobs
  *** empty log message ***

  Revision 2.2  2000/01/22 22:32:47  jacobs
  *** empty log message ***

  Revision 2.1  2000/01/18 22:50:53  jacobs
  *** empty log message ***

  Revision 1.6  2000/01/14 21:49:15  jacobs
  *** empty log message ***

  Revision 1.5  2000/01/09 23:09:44  jacobs
  new option "-r"

  Revision 1.4  2000/01/09 02:32:17  jacobs
  *** empty log message ***

  Revision 1.3  2000/01/07 13:43:42  jacobs
  *** empty log message ***

  Revision 1.2  1999/12/30 01:26:21  jacobs
  *** empty log message ***

  Revision 1.1  1999/12/28 22:34:38  jacobs
  Initial revision


*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "tool.h"
#include "game.h"
#include "tools/hpj_string.h"

const char c_items[NOF_ITEMS][30]={
  "ammo_bullets", "ammo_shells", "ammo_rockets",
  "ammo_cells", "ammo_slugs", "ammo_grenades",
  "ammo_lightning", "ammo_bfg", "weapon_railgun",
  "weapon_rocketlauncher", "weapon_grenadelauncher",
  "weapon_shotgun", "weapon_plasmagun", "weapon_lightning",
  "weapon_bfg", "item_health_small", "item_health",
  "item_health_large", "item_health_mega", "item_armor_shard",
  "item_armor_body", "item_armor_combat", "item_haste",
  "item_regen", "item_quad", "item_invis", "item_enviro",
  "item_flight",
  "holdable_medkit", "holdable_teleporter", "weapon_grapplinghook",
  "weapon_gauntlet", "weapon_machinegun"};

const char c_items_nice[NOF_ITEMS][30]={
  "Bullets", "Shells", "Rockets",
  "Cells", "Slugs", "Grenades",
  "Light-ammo", "BFG-Ammo", "Railgun",
  "RocketLauncher", "GrenadeLauncher", //10
  "Shotgun", "Plasmagun", "Lightning Gun", //13
  "BFG 2K", "Health small", "Health", //16
  "Health large", "Health Mega", "Armor shard", //19
  "Body Armor", "Combat Armor", "Haste", //22
  "Regeneration", "Quad-Damage", "Invisibility", //25
  "Enviro Suit", "Flight-Item",
  "Holdable Medikit", "Holdable TPorter", "Grappling-Hook",
  "Gauntlet", "MachineGun"};

const char c_weaps[NOF_WEAPS][30]={
  "unknown", "Shotgun", "Gauntlet", "Machinegun",
  "Grenade", "Grenade Splash", //6
  "Rocket", "Rocket Splash", "Plasma",
  "Plasma Splash", "Railgun", "Lightning",
  "BFG", "BFG Splash", "Water", "Slime", "Lava",//17
  "Crush", "Telefrag", "Falling", "Suicide", "Target_Laser", "Trigger_Hurt", "Grapple"};

const char c_gamemodes[GAMETYPE_MAX+1][30]={
  "Death Match", "Tournament", "Unknown", "Team Deathmatch",
  "Capture the flag", "Custom game"};
const char c_gamemodes_s[GAMETYPE_MAX+1][4]={
  "dm", "tou", "sin", "tdm", "ctf", "cus"};




/*
 *
 *
 Event - stuff
 *
 *
 */
t_event  *new_event(void)
{
  t_event *event=(t_event *)malloc(sizeof(t_event));
  if (event==NULL) exit_error("Malloc failed\n");
  memset(event, 0, sizeof(event));
  return event;
}


t_event  *del_event(t_event *event)
{
  if (event!=NULL)
    {
      if (event->event != NULL) free(event->event);
      if (event->text != NULL) free(event->text);
      free(event);
    }
  return NULL;
}



/*
 *
 *
 Player - stuff
 *
 *
 */
t_player *new_player(void)
{
  t_player *player=(t_player *)malloc(sizeof(t_player));
  if (player==NULL) exit_error("Malloc failed\n");
  memset(player, 0, sizeof(t_player));

  player->tl_weaps=iarray_new(1);
  player->tl_whom=iarray_new(1);
  player->tl_frags=iarray_new(1);
  player->tl_fragsec=iarray_new(1);

  return player;
}

t_player *del_player(t_player *player)
{
  if (player==NULL) return NULL;

  if (player->name !=NULL)free(player->name);
  if (player->i_name!=NULL) free(player->i_name);
  
  iarray_del(player->tl_weaps);
  iarray_del(player->tl_whom);
  iarray_del(player->tl_frags);
  iarray_del(player->tl_fragsec);
  free(player);
  return NULL;
}

long int size_player(t_player *player)
{
  int sum=0;
  sum=sizeof(t_player);
  if (player->name) sum+=strlen(player->name)+1;
  if (player->i_name) sum+=strlen(player->i_name)+1;
  sum+=iarray_size(player->tl_weaps);
  sum+=iarray_size(player->tl_whom);
  sum+=iarray_size(player->tl_frags);
  sum+=iarray_size(player->tl_fragsec);
  return sum;
}



/*
 *
 *
 Game - stuff
 *
 *
 */
t_game   *new_game(void)
{
  int i;
  t_game *game=(t_game *)malloc(sizeof(t_game));
  if (game==NULL) exit_error("Malloc failed\n");
  memset(game, 0, sizeof(t_game));

  game->complete=0;
  for(i=0; i<MAX_TEAMS; i++)
    {
      game->tl_ctf[i]=iarray_new(4);
      game->tl_ctfsec[i]=iarray_new(4);
      game->tl_team[i]=iarray_new(4);
      game->tl_teamsec[i]=iarray_new(4);
    }
  game->chat_team=iarray_new(4);
  game->chat_secs=iarray_new(4);
  game->chat_skill=iarray_new(4);
  game->chat_name=parray_new(4);
  game->chat_message=parray_new(4);
  return game;
}


t_game   *del_game(t_game *game)
{
  int i;
  if (game==NULL) return NULL;

  if (game->mapname) free(game->mapname);
  if (game->servername) free(game->servername);
  if (game->gamename) free(game->gamename);
  if (game->fs_game) free(game->fs_game);
  for (i=0; i<game->nof_players; i++)
    if (game->player[i]!=NULL) 
      game->player[i]=del_player(game->player[i]);
  if (game->player) free(game->player);

  for(i=0; i<MAX_TEAMS; i++)
    {
      iarray_del(game->tl_ctf[i]);
      iarray_del(game->tl_ctfsec[i]);
      iarray_del(game->tl_team[i]);
      iarray_del(game->tl_teamsec[i]);
    }

  for(i=0; i<iarray_elements(game->chat_team); i++)
    {
      string_del(parray_get(game->chat_name, i));
      string_del(parray_get(game->chat_message, i));
    }
  game->chat_team=iarray_del(game->chat_team);
  game->chat_secs=iarray_del(game->chat_secs);
  game->chat_skill=iarray_del(game->chat_skill);
  game->chat_name=parray_del(game->chat_name);
  game->chat_message=parray_del(game->chat_message);
  free(game);
  return NULL;
}

long int size_game(t_game *game)
{
  long int sum=0, i;

  sum=sizeof(t_game);
  if (game->mapname!=NULL) sum+=strlen(game->mapname)+1;
  if (game->servername!=NULL) sum+=strlen(game->servername)+1;
  if (game->gamename!=NULL) sum+=strlen(game->gamename)+1;
  if (game->fs_game!=NULL) sum+=strlen(game->fs_game)+1;

  for(i=0; i<MAX_TEAMS; i++)
    {
      sum+=iarray_size(game->tl_ctf[i]);
      sum+=iarray_size(game->tl_ctfsec[i]);
      sum+=iarray_size(game->tl_team[i]);
      sum+=iarray_size(game->tl_teamsec[i]);
    }
  for(i=0; i<iarray_elements(game->chat_team); i++)
    {
      sum+=string_size(parray_get(game->chat_name,i));
      sum+=string_size(parray_get(game->chat_message,i));
    }
  sum += iarray_size(game->chat_team);
  sum += iarray_size(game->chat_secs);
  sum += iarray_size(game->chat_skill);
  sum += parray_size(game->chat_name);
  sum += parray_size(game->chat_message);


  sum+=sizeof(t_player **)*game->nof_players;
  for (i=0; i<game->nof_players; i++)
    sum+=size_player(game->player[i]);
  return sum;
}





int getPlayerID(t_game *game, int client_id)
{
  int i;
  for (i=0; i<game->nof_players; i++)
    {
      if (game->player[i]->c_id==client_id)
	return i;
    }
  return -1;
}


char check_winner(t_game *game, int pid)
{
  long int i, fragpid=0;

  /* STILL TO CHANGE
     If its a team-based game then there is no "winner" !!
   */
  if (game->type==GAMETYPE_CTF || game->type==GAMETYPE_TDM)
    return 0;

  if (game->nof_players<2)
    return 1;

  /* Currently the winner is the one with the highest frag-count, if equal
   then the efficency votes */
  for(i=1; i<game->nof_players; i++)
    if ( (game->player[fragpid]->nof_frags < game->player[i]->nof_frags) ||
	 ((game->player[fragpid]->nof_frags==game->player[i]->nof_frags) &&
	  (game->player[fragpid]->effect < game->player[i]->effect)) )
      fragpid=i;

  if (fragpid==pid) return 1;
  return 0;
}
