/*
  Here are all the structs for games and players are stored.

  $Id: game.h,v 2.7 2000/03/02 09:03:35 jacobs Exp jacobs $

  $Log: game.h,v $
  Revision 2.7  2000/03/02 09:03:35  jacobs
  *** empty log message ***

  Revision 2.6  2000/02/14 11:02:13  jacobs
  *** empty log message ***

  Revision 2.5  2000/02/06 20:18:43  jacobs
  *** empty log message ***

  Revision 2.4  2000/01/29 21:41:12  jacobs
  *** empty log message ***

  Revision 2.3  2000/01/25 22:53:37  jacobs
  *** empty log message ***

  Revision 2.2  2000/01/22 22:32:47  jacobs
  *** empty log message ***

  Revision 2.1  2000/01/18 22:50:53  jacobs
  *** empty log message ***

  Revision 1.10  2000/01/14 21:49:15  jacobs
  *** empty log message ***

  Revision 1.9  2000/01/11 23:25:53  jacobs
  *** empty log message ***

  Revision 1.8  2000/01/09 23:09:44  jacobs
  new option "-r"

  Revision 1.7  2000/01/09 02:32:17  jacobs
  *** empty log message ***

  Revision 1.6  2000/01/07 13:43:42  jacobs
  *** empty log message ***

  Revision 1.5  2000/01/05 03:43:25  jacobs
  *** empty log message ***

  Revision 1.4  2000/01/03 16:04:02  jacobs
  *** empty log message ***

  Revision 1.3  1999/12/31 02:21:41  jacobs
  *** empty log message ***

  Revision 1.2  1999/12/30 01:26:21  jacobs
  *** empty log message ***

  Revision 1.1  1999/12/28 22:34:38  jacobs
  Initial revision


*/

#ifndef __GAME_H__
#define __GAME_H__

#include "tools/hpj_iarray.h"
#include "tools/hpj_parray.h"

#ifndef DEBUG_LEVEL
#define DEBUG_LEVEL   0
#endif


#define GAMETYPE_MAX  5
#define GAMETYPE_CTF  4
#define GAMETYPE_TDM  3
#define GAMETYPE_SIN  2
#define GAMETYPE_TOU  1
#define GAMETYPE_DM   0

#define EXIT_NOT      0
#define EXIT_CAPTURE  1
#define EXIT_FRAG     2
#define EXIT_TIME     3
#define EXIT_WARMUP   4

#define MAXGAMES      4096
#define MAXPLAYER     64 //per game :-)
#define MAX_TEAMS     5
#define MAXLINELENGTH 4096

#define CTF_BASE      -2
#define CTF_LEVEL     -1

/* CONSTANT VALUES - DO NOT TOUCH */
#define NOF_ITEMS     33
#define NOF_WEAPS     24

extern const char c_items[NOF_ITEMS][30];
extern const char c_items_nice[NOF_ITEMS][30];
extern const char c_weaps[NOF_WEAPS][30];
extern const char c_gamemodes[GAMETYPE_MAX+1][30];
extern const char c_gamemodes_s[GAMETYPE_MAX+1][4];

/* I call an event a single line in the Q3 -  games.log */
typedef struct {
  int   time;
  char *event, *text;
}t_event;


/* Here we go -> main-struct for a player */
typedef struct {
  char *name;  //internal-name, changed for bots  killer -> killer_[3]
  char *i_name;//id-name , used in-game
  char  b_red, //is member of red team
    b_blue,    //is member of the blue team
    b_active,  //is still playing
    b_winner,  //is the winner of the game
    b_fresh;   //first uinfo-call after connect (used for playername-check)

  int   c_id, pid;   /* client-id, used for parsing */
  int   team, oldteam;
  int   startsec, secs, max_tal, avg_ttl, handicap, skill, ping, score;
  int   nof_kills, nof_suicides, nof_frags, nof_items, nof_says, nof_deaths;
  int   nof_tkills;

  long int   ctf_steals, ctf_captures;
  long int   ctf_pickups, ctf_returns, ctf_autoret;
  long int   ctf_loss, ctf_suic, ctf_kills;

  long int   lst_kills[MAXPLAYER], lst_weapon[NOF_WEAPS];
  long int   lst_items[NOF_ITEMS];
  long int   weaps[NOF_WEAPS], wsui[NOF_WEAPS];
  long int   wtkill[NOF_WEAPS], wdeath[NOF_WEAPS];

  /* used for the timelines*/
  hpj_iarray *tl_weaps, *tl_whom, *tl_frags, *tl_fragsec;

  double effect, ttl, fph;
}t_player;


/*
  A game contains several players.
  "Complete" games are games with the "Exit" - event,
  i.e. a limit was hit (capture, frag, time).*/
typedef struct {
  char      *mapname, *servername, *gamename, *fs_game;
  char       type, complete, exit_state, warmup;

  long int   gid;  /* game-id in the games.log */
  long int   secs, startsec, timelimit, fraglimit, capturelimit;
  long int   nof_kills, nof_suicides, nof_frags, nof_items, nof_deaths;
  long int   nof_players, nof_says, nof_tkills;

  /* Teams are 1 or 2, 0 is not used(?), so we allocate mem for 0..2 */
  long int   flag_carrier[MAX_TEAMS];
  long int   ctf_captures[MAX_TEAMS], ctf_kills[MAX_TEAMS];
  long int   ctf_loss[MAX_TEAMS];
  long int   ctf_pickups[MAX_TEAMS];
  long int   ctf_steals[MAX_TEAMS], ctf_suic[MAX_TEAMS];
  long int   ctf_returns[MAX_TEAMS], ctf_autoret[MAX_TEAMS];

  long int   team_score[MAX_TEAMS], team_tkills[MAX_TEAMS];
  long int   team_kills[MAX_TEAMS];

  long int   team_suic[MAX_TEAMS], team_frags[MAX_TEAMS];

  long int   lst_items[NOF_ITEMS];
  long int   weaps[NOF_WEAPS], wsui[NOF_WEAPS], wtkill[NOF_WEAPS];

  t_player **player;

  // Some informations about chatting
  hpj_iarray *chat_team, *chat_secs, *chat_skill;
  hpj_parray *chat_name, *chat_message;

  /* finally some timelines */
  hpj_iarray *tl_ctf[MAX_TEAMS], *tl_ctfsec[MAX_TEAMS];
  hpj_iarray *tl_team[MAX_TEAMS], *tl_teamsec[MAX_TEAMS];
}t_game;



/*
 *
 *
 now we export some functions
 *
 *
 */
/* creates a t_event - struct, returns the pointer to it,
   all vars will be set to zero*/
t_event  *new_event(void);
// frees the allocated memory, returns a NULL-pointer
t_event  *del_event(t_event *event);

// creates a t_player - struct, returns the pointer to it, all vars set to zero
t_player *new_player(void);
// frees the allocated memory, returns a NULL-pointer
t_player *del_player(t_player *player);
long int  size_player(t_player *player);

t_game   *new_game(void);
t_game   *del_game(t_game *game);
long int  size_game(t_game *game);
int       getPlayerID(t_game *game, int client_id);

char      check_winner(t_game *game, int pid);
#endif
