/*
  Lets see if it gets a little bit more readable.
  starting with a given filename, the HTML_creator runs with a stack
  of "Todo"-files.

  $Id: html_creator_tpl.c,v 2.7 2000/03/02 09:03:35 jacobs Exp jacobs $

  $Log: html_creator_tpl.c,v $
  Revision 2.7  2000/03/02 09:03:35  jacobs
  Chat-Viewer builtin

  Revision 2.6  2000/02/14 11:02:13  jacobs
  *** empty log message ***

  Revision 2.5  2000/02/06 20:18:43  jacobs
  *** empty log message ***

  Revision 2.4  2000/01/29 21:41:12  jacobs
  *** empty log message ***

  Revision 2.3  2000/01/25 22:53:37  jacobs
  *** empty log message ***

  Revision 2.2  2000/01/22 22:32:47  jacobs
  *** empty log message ***

  Revision 2.1  2000/01/18 22:50:53  jacobs
  *** empty log message ***

  Revision 1.7  2000/01/14 21:49:15  jacobs
  *** empty log message ***

  Revision 1.6  2000/01/11 23:25:53  jacobs
  *** empty log message ***

  Revision 1.5  2000/01/09 23:09:44  jacobs
  new option "-r"

  Revision 1.4  2000/01/09 02:32:17  jacobs
  *** empty log message ***

  Revision 1.3  2000/01/07 13:43:42  jacobs
  *** empty log message ***

  Revision 1.2  2000/01/05 03:43:25  jacobs
  *** empty log message ***

  Revision 1.1  2000/01/03 16:04:02  jacobs
  Initial revision


*/

#include <stdlib.h>
#include <string.h>
#include <time.h>
#ifdef GNU_C
#include <unistd.h>
#else
#include <direct.h>
#endif

#include "lt_stats.h"
#include "html_creator_tpl.h"
#include "html_writers.h"
#include "tool.h"
#include "tools/hpj_string.h"
#include "png_io.h"

#ifndef MAXIFCOND
#define MAXIFCOND 128
#endif

/* Global vars for the map-images (levelshots) */
hpj_parray *mapname=NULL, *mapimg=NULL;

/* This stores all loaded images, so we dont load the png everytime from the
   Tempaltes-dir*/
hpj_parray *images=NULL;

/* palimage contains the global palette (no data !)
   palette can be overwritten by source*/
hpj_image  *palimage=NULL;



const char html_weaps[NOF_WEAPS][20]={
  "UNKNOWN", "SHOTGUN", "GAUNTLET", "MACHINEGUN",
  "GRENADE", "GRENADESPLASH",
  "ROCKET", "ROCKETSPLASH", "PLASMA",
  "PLASMASPLASH", "RAILGUN", "LIGHTNING",
  "BFG", "BFGSPLASH", "WATER", "SLIME", "LAVA",
  "CRUSH", "TELEFRAG", "FALLING", "SUICIDE", "LASER", "TRIGGERHURT", "GRAPPLE"};


const char html_items[NOF_ITEMS][30]={
  "BULLETS", "SHELLS", "ROCKETS",
  "CELLS", "SLUGS", "GRENADES",
  "LIGHT_AMMO", "BFG_AMMO", "RAILGUN",
  "ROCKETLAUNCHER", "GRENADELAUNCHER", //11
  "SHOTGUN", "PLASMAGUN", "LIGHTNING_GUN",
  "BFG2K", "HEALTH_SMALL", "HEALTH",
  "HEALTH_LARGE", "HEALTH_MEGA", "ARMOR_SHARD", //20
  "ARMOR_BODY", "ARMOR_COMBAT", "HASTE",
  "REGENERATION", "QUAD_DAMAGE", "INVISIBILITY", //26
  "ENVIRONMENTSUITE", "FLIGHT",
  "HOLDABLE_MEDIKIT", "HOLDABLE_TELEPORTER", "GRAPPLE",
  "GAUNTLET", "MACHINEGUN"};


/*
 *
 *
 File - tools
 *
 *
 */
int read_to_next_tag(FILE *fp, char *mem, int maxlen)
{
  unsigned char c;
  int           pos;

  c=32;
  pos=0;
  while(c!='<' && pos<maxlen && !feof(fp))
    {
      fread(&c,1,1,fp);
      mem[pos]=c;
      pos++;
    }
  if (c=='<')
    {
      pos--;
      fseek(fp,-1,1);
    }
  mem[pos]=0;
  return pos;
}


int read_tag(FILE *fp, char *mem, int maxlen)
{
  unsigned char c;
  int pos;

  pos=0;
  c=32;
  while(c!='>' && !feof(fp) && pos<maxlen)
    {
      fread(&c,1,1,fp);
      mem[pos]=c;
      pos++;
    }
  mem[pos]=0;
  if (c!='>')
    {
      fprintf(stderr, "tag-error (not closed or to long)\n");
      fprintf(stderr, "%s\n", mem);
      exit(-1);
    }
  return pos;
}




/*
 *
 *
 IMAGE - TOOLS
 *
 *
 */
hpj_image *load_img(char *fname, char *tdir, int dx, int dy)
{
  int        i,j,k;
  hpj_image *img;
  char       fn[MAXDIRLENGTH];
  
  for(i=0; i<parray_elements(images); i++)
    {
      img=parray_get(images, i);
      //fprintf(stderr, "->file: %s\n", img->filename);
      if (img->width==dx && img->height==dy)
	if ((img->filename==NULL && fname==NULL) ||
	    strcmp(img->filename, fname)==0)
	return img;
    }

  img=image_new();
  if (fname==NULL)
    {
      image_getPal(img, palimage);
      image_createData(img, dx, dy);
    }
  else
    {
      sprintf(fn, "%s/%s", tdir, fname);
      read_png(fn, &img->mem,img->palmem,&img->width,&img->height,
	       &img->palnums);
      if (img->mem==NULL)
	{
	  image_getPal(img, palimage);
	  image_createData(img, dx, dy);
	  fprintf(stderr, "  file \"%s\" not opened\n", fn);
	} else {
	  /* this is funny -> we move the palette up, so we have space for
	     our custom palette :-) */
	  for(i=0; i<palimage->palnums; i++)
	    {
	      k=img->palnums+i;
	      for(j=0; j<img->width*img->height; j++)
		if (img->mem[j]==i) img->mem[j]=k;
	      img->palmem[k*3  ]=img->palmem[i*3  ];
	      img->palmem[k*3+1]=img->palmem[i*3+1];
	      img->palmem[k*3+2]=img->palmem[i*3+2];

	      img->palmem[i*3  ]=palimage->palmem[i*3  ];
	      img->palmem[i*3+1]=palimage->palmem[i*3+1];
	      img->palmem[i*3+2]=palimage->palmem[i*3+2];	      
	    }
	}
    }
  image_setFilename(img,fname);
  parray_append(images, img);
  /*
    fprintf(stderr, "  created entry in images for : %s (%i x %i)\n",\
    fname, dx,dy);
  */
  return img;
}


/*
 *
 *
 Tag - tools (get params from tags)
 *
 *
 */
int get_param_int(char *mem, char *string)
{
  int   p;
  char *t;

  t=strstr(mem, string);
  if (t==NULL) return -1;
  while(*t!=0 && (*t<'0' || *t>'9'))
    t++;
  if (*t==0) return -1;

  p=0;
  while (*t>='0' && *t<='9')
    {
      p*=10;
      p+=*t-'0';
      t++;
    }
  //fprintf(stderr, "PARAMETER : %s -> %i\n", mem, p);
  return p;
}


char *get_param_string(char *mem, char *string)
{
  int   s, e;
  char *t;

  t=strstr(mem, string);
  if (t==NULL) return NULL;
  s=t-mem;
  s+=strlen(string)+1;
  e=s;
  while(mem[e]!='>' && mem[e]!=32 && mem[e]!=0)
    e++;
  if (mem[e]==0) return NULL;
  t=my_strndup(&mem[s], e-s);
  return t;
}








/*
 *
 *
 Main-stuff
 *
 *
 */

/*
 *
 *
 Simple vars - i.e. just writing a number, called from "write_q3tag"
 *
 *
 */
int check_var(FILE *fp, char *tag, int cg, int cp, t_game **games,\
	      int nof_games, t_lts *lts)
{
  long int  *weaps=NULL, *items=NULL;
  int   i, sum=-100;
  char *s,*e, *t=NULL, *u=NULL;

  /* Weapons */
  if (strstr(tag, "_VW_")!=NULL)
    {
      if (strstr(tag, "_AG_")!=NULL)
	weaps=lts->weaps;
      if (strstr(tag, "_AP_")!=NULL && cp>=0)
	weaps=lts->ltplayers[cp]->weaps;
      if ((strstr(tag, "_SG_")!=NULL) && cg>=0)
	weaps=games[cg]->weaps;
      if ((strstr(tag, "_SP_")!=NULL) && cg>=0 && cp>=0)
	weaps=games[cg]->player[cp]->weaps;

      if (strstr(tag, "_AGT_")!=NULL)
	weaps=lts->wtkill;
      if (strstr(tag, "_APT_")!=NULL && cp>=0)
	weaps=lts->ltplayers[cp]->wtkill;
      if ((strstr(tag, "_SGT_")!=NULL) && cg>=0)
	weaps=games[cg]->wtkill;
      if ((strstr(tag, "_SPT_")!=NULL) && cg>=0 && cp>=0)
	weaps=games[cg]->player[cp]->wtkill;

      if (strstr(tag, "_AGS_")!=NULL)
	weaps=lts->wsui;
      if (strstr(tag, "_APS_")!=NULL && cp>=0)
	weaps=lts->ltplayers[cp]->wsui;
      if ((strstr(tag, "_SGS_")!=NULL) && cg>=0)
	weaps=games[cg]->wsui;
      if ((strstr(tag, "_SPS_")!=NULL) && cg>=0 && cp>=0)
	weaps=games[cg]->player[cp]->wsui;

      if (weaps==NULL) return 0;

      s=strstr(tag, "_VW_");
      s+=4;
      e=s;
      while(*e!='>' && *e!=32 && *e!=0)
	e++;

      if (e-s > 20) return 0;
      t=(char *)malloc(1+e-s);
      memset(t,0,1+e-s);
      strncpy(t, s, e-s);

      //fprintf(stderr, "------>%s\n", t);
      /* special case -> splash */
      if (strcmp(t, "SPLASH")==0)
	{
	  sum=weaps[5]+weaps[7]+weaps[9]+weaps[13];
	} else {
	  for (i=0; i<NOF_WEAPS; i++)
	    if (strcmp(t, html_weaps[i])==0)
	      break;
	  if (i==NOF_WEAPS) return 0;
	  sum=weaps[i];
	  if ((strstr(tag, "ALL")!=NULL) && (i==4 || i==6 || i==8 || i==12))
	    sum+=weaps[i+1];
	}

      if (t!=NULL) free(t);
      t=NULL;
    }

  /* ITEMS picked up */
  if (strstr(tag, "_VI_")!=NULL)
    {
      if (strstr(tag, "_AG_")!=NULL)
	items=lts->items;
      if (strstr(tag, "_AP_")!=NULL && cp>=0)
	items=lts->ltplayers[cp]->items;
      if ((strstr(tag, "_SG_")!=NULL) && cg>=0)
	items=games[cg]->lst_items;
      if ((strstr(tag, "_SP_")!=NULL) && cg>=0 && cp>=0)
	items=games[cg]->player[cp]->lst_items;

      if (items==NULL) return 0;

      s=strstr(tag, "_VI_");
      s+=4;
      e=s;
      while(*e!='>' && *e!=32 && *e!=0)
	e++;

      if (e-s > 20) return 0;
      t=(char *)malloc(1+e-s);
      memset(t,0,1+e-s);
      strncpy(t, s, e-s);

      //fprintf(stderr, "------>%s\n", t);      
      if (strcmp(t, "ALL_AMMO")==0)
	sum=items[0]+items[1]+items[2]+items[3]+items[4]+\
	  items[5]+items[6]+items[7];
      if (strcmp(t, "ALL_WEAPONS")==0)
	sum=items[8]+items[9]+items[10]+items[11]+items[12]+\
	  items[13]+items[14];
      if (strcmp(t, "ALL_HEALTH")==0)
	sum=items[15]+items[16]+items[17]+items[18];
      if (strcmp(t, "ALL_ARMOR")==0)
	sum=items[19]+items[20]+items[21];
      if (strcmp(t, "ALL_POWERUPS")==0)
	sum=items[22]+items[23]+items[24]+items[25];

      if (sum<0)
	{
	  for (i=0; i<NOF_ITEMS; i++)
	    if (strcmp(t, html_items[i])==0)
	  break;
	  if (i==NOF_ITEMS) return 0;
	  
	  sum=items[i];
	}
      if (t!=NULL) free(t);
      t=NULL;
    }

  /* General Vars */
  if (strstr(tag, "_VG_")!=NULL)
    {
      if (strstr(tag, "_FRAGCOUNTER")!=NULL)
	{
	  if ((strstr(tag, "_AG_")!=NULL) ||\
	      (strstr(tag, "_AP_")!=NULL))
	    sum=lts->nof_frags;
	  if (strstr(tag, "_SG_")!=NULL)
	    if (cg>=0) sum=games[cg]->nof_frags;
	  if (strstr(tag, "_SP_")!=NULL)
	    if (cg>=0 && cp>=0) sum=games[cg]->player[cp]->nof_frags;
	}

      if (strstr(tag, "_FRAGMASTERCOUNT")!=NULL)
	{
	  if ((strstr(tag, "_SG_")!=NULL) ||\
	      (strstr(tag, "_SP_")!=NULL))
	    {
	      sum=0;
	      for(i=0; i<games[cg]->nof_players; i++)
		if (games[cg]->player[i]->nof_frags>sum)
		  sum=games[cg]->player[i]->nof_frags;
	    }
	  if ((strstr(tag, "_AG_")!=NULL) ||\
	      (strstr(tag, "_AP_")!=NULL))
	    {
	      sum=0;
	      for(i=0; i<lts->nof_players; i++)
		if (lts->ltplayers[i]->nof_frags>sum)
		  sum=lts->ltplayers[i]->nof_frags;
	    }
	}
      if (strstr(tag, "_KILLMASTERCOUNT")!=NULL)
	{
	  if ((strstr(tag, "_SG_")!=NULL) ||\
	      (strstr(tag, "_SP_")!=NULL))
	    {
	      sum=0;
	      for(i=0; i<games[cg]->nof_players; i++)
		if (games[cg]->player[i]->nof_kills>sum)
		  sum=games[cg]->player[i]->nof_kills;
	    }
	  if ((strstr(tag, "_AG_")!=NULL) ||\
	      (strstr(tag, "_AP_")!=NULL))
	    {
	      sum=0;
	      for(i=0; i<lts->nof_players; i++)
		if (lts->ltplayers[i]->nof_kills>sum)
		  sum=lts->ltplayers[i]->nof_kills;
	    }
	}

      if (strstr(tag, "_FOOLCOUNT")!=NULL)
	{
	  if ((strstr(tag, "_SG_")!=NULL) ||\
	      (strstr(tag, "_SP_")!=NULL))
	    {
	      sum=0;
	      for(i=0; i<games[cg]->nof_players; i++)
		if (games[cg]->player[i]->nof_suicides>sum)
		  sum=games[cg]->player[i]->nof_suicides;
	    }
	  if ((strstr(tag, "_AG_")!=NULL) ||\
	      (strstr(tag, "_AP_")!=NULL))
	    {
	      sum=0;
	      for(i=0; i<lts->nof_players; i++)
		if (lts->ltplayers[i]->nof_suicides>sum)
		  sum=lts->ltplayers[i]->nof_suicides;
	    }
	}

      if (strstr(tag, "_EASYPREYCOUNT")!=NULL)
	{
	  if ((strstr(tag, "_SG_")!=NULL) ||\
	      (strstr(tag, "_SP_")!=NULL))
	    {
	      sum=0;
	      for(i=0; i<games[cg]->nof_players; i++)
		if (games[cg]->player[i]->nof_deaths<sum)
		  sum=games[cg]->player[i]->nof_deaths;
	    }
	  if ((strstr(tag, "_AG_")!=NULL) ||\
	      (strstr(tag, "_AP_")!=NULL))
	    {
	      sum=0;
	      for(i=0; i<lts->nof_players; i++)
		if (lts->ltplayers[i]->nof_deaths>sum)
		  sum=lts->ltplayers[i]->nof_deaths;
	    }
	}

      if (strstr(tag, "_LONGTIMECOUNT")!=NULL)
	{
	  if ((strstr(tag, "_SG_")!=NULL) ||\
	      (strstr(tag, "_SP_")!=NULL))
	    {
	      sum=0;
	      for(i=0; i<games[cg]->nof_players; i++)
		if (games[cg]->player[i]->secs<sum)
		  sum=games[cg]->player[i]->secs;
	    }
	  if ((strstr(tag, "_AG_")!=NULL) ||\
	      (strstr(tag, "_AP_")!=NULL))
	    {
	      sum=0;
	      for(i=0; i<lts->nof_players; i++)
		if (lts->ltplayers[i]->secs>sum)
		  sum=lts->ltplayers[i]->secs;
	    }
	  if (strstr(tag, " GFX")==NULL)
	    {
	      fprintf(fp, "%02i:%02i:%02i", sum/3600, (sum%3600)/60, sum%60);
	      return 1;
	    }
	}

      if (strstr(tag, "_EFFECTIVENESSCOUNT")!=NULL)
	{
	  if ((strstr(tag, "_SG_")!=NULL) ||\
	      (strstr(tag, "_SP_")!=NULL))
	    {
	      sum=0;
	      for(i=0; i<games[cg]->nof_players; i++)
		if (games[cg]->player[i]->effect<sum)
		  sum=games[cg]->player[i]->effect;
	    }
	  if ((strstr(tag, "_AG_")!=NULL) ||\
	      (strstr(tag, "_AP_")!=NULL))
	    {
	      sum=0;
	      for(i=0; i<lts->nof_players; i++)
		if (lts->ltplayers[i]->effect>sum)
		  sum=lts->ltplayers[i]->effect;
	    }
	}

      if (strstr(tag, "_ROBUSTNESSCOUNT")!=NULL)
	{
	  if ((strstr(tag, "_SG_")!=NULL) ||\
	      (strstr(tag, "_SP_")!=NULL))
	    {
	      sum=0;
	      for(i=0; i<games[cg]->nof_players; i++)
		if (games[cg]->player[i]->ttl<sum)
		  sum=games[cg]->player[i]->ttl;
	    }
	  if ((strstr(tag, "_AG_")!=NULL) ||\
	      (strstr(tag, "_AP_")!=NULL))
	    {
	      sum=0;
	      for(i=0; i<lts->nof_players; i++)
		if (lts->ltplayers[i]->ttl>sum)
		  sum=lts->ltplayers[i]->ttl;
	    }
	}

      if (strstr(tag, "_HERCULESCOUNT")!=NULL)
	{
	  if ((strstr(tag, "_SG_")!=NULL) ||\
	      (strstr(tag, "_SP_")!=NULL))
	    {
	      sum=0;
	      for(i=0; i<games[cg]->nof_players; i++)
		if (games[cg]->player[i]->nof_items<sum)
		  sum=games[cg]->player[i]->nof_items;
	    }
	  if ((strstr(tag, "_AG_")!=NULL) ||\
	      (strstr(tag, "_AP_")!=NULL))
	    {
	      sum=0;
	      for(i=0; i<lts->nof_players; i++)
		if (lts->ltplayers[i]->nof_items>sum)
		  sum=lts->ltplayers[i]->nof_items;
	    }
	}

      if (strstr(tag, "_HORMONBOOSTEDCOUNT")!=NULL)
	{
	  sum=0;
	  if ((strstr(tag, "_SG_")!=NULL) ||\
	      (strstr(tag, "_SP_")!=NULL))
	    {
	      for(i=0; i<games[cg]->nof_players; i++)
		if (games[cg]->player[i]->lst_items[24] > sum)
		  sum=games[cg]->player[i]->lst_items[24];
	    }
	  if ((strstr(tag, "_AG_")!=NULL) ||\
	      (strstr(tag, "_AP_")!=NULL))
	    {
	      for(i=0; i<lts->nof_players; i++)
		if (lts->ltplayers[i]->items[24] > sum)
		  sum=lts->ltplayers[i]->items[24];
	    }
	}

      if (strstr(tag, "_CTFSCORECOUNT")!=NULL)
	{
	  sum=0;
	  if ((strstr(tag, "_SG_")!=NULL) ||\
	      (strstr(tag, "_SP_")!=NULL))
	    {
	      for(i=0; i<games[cg]->nof_players; i++)
		if (games[cg]->player[i]->score > sum)
		  sum=games[cg]->player[i]->score;
	    }
	  if ((strstr(tag, "_AG_")!=NULL) ||\
	      (strstr(tag, "_AP_")!=NULL))
	    {
	      for(i=0; i<lts->nof_players; i++)
		if (lts->ltplayers[i]->ctf_score > sum)
		  sum=lts->ltplayers[i]->ctf_score;
	    }
	}

    }

  if (sum<-100) return 0;
  if (strstr(tag, " GFX")==NULL)
    fprintf(fp, "%i", sum);
  else {
    s=strstr(tag, " PRE=");
    if (s!=NULL)
      {
	s+=5;
	e=s;
	while(*e!='>' && *e!=32 && *e!=0)
	  e++;
	t=(char *)malloc(1+e-s);
	memset(t,0,1+e-s);
	strncpy(t, s, e-s);
      }
    s=strstr(tag, " POST=");
    if (s!=NULL)
      {
	s+=6;
	e=s;
	while(*e!='>' && *e!=32 && *e!=0)
	  e++;
	u=(char *)malloc(1+e-s);
	memset(u,0,1+e-s);
	strncpy(u, s, e-s);
      }
    
    write_counter_gfx(fp, sum, t, u);
    
    if (t!=NULL) free(t);
    if (u!=NULL) free(u);
  }
  return 1;
}














/*
 *
 *
 Tags (more complicated)
 *
 *
 */
void write_q3tag(FILE    *fp, char *tag, char *calc_string,
		 t_game **games, int nof_games, char *t, char *t_p,
		 char   **todo, char **todo_t, char **todo_p, int *sp,
		 t_lts   *lts, hpj_config *cfg)
{
  int  p1, p2, p3, p4, p5, p6, exist, i, j, cg=-1, cp=-1;
  char *c1=NULL, *c2=NULL, *c3=NULL, *c4=NULL, *c5=NULL, b_done=0;
  hpj_image *bgimage;

  if (t_p!=NULL)
    {
      cg=get_param_int(t_p, "GAMEID");
      cp=get_param_int(t_p, "PLAYERID");
    }

  /* single-game tags */
  if (cg>=0)
    {
      //printf("%s\n", tag);
      /* Single-game stats */
      if (strstr(tag, "Q3L_SG_STATS")!=NULL)
	{
	  b_done=1;
	  c1=get_param_string(tag, "HEADC");
	  if (strstr(tag, "ALL")==NULL)
	    write_sg_stats(fp, games[cg], c1);
	  else
	    write_sg_stats_all(fp, games[cg], c1, cfg->b_sgtalks,
			       todo, todo_t, todo_p, sp);
	}

      if (strstr(tag, "Q3L_SG_CHATTABLE")!=NULL)
	{
	  c1=get_param_string(tag, "REDC");
	  c2=get_param_string(tag, "BLUEC");
	  c3=get_param_string(tag, "HEADC");
	  if (strstr(tag,"HUMANONLY"))
	    p1=1; else p1=0;
	  write_sg_chattable(fp, games[cg], c1, c2, c3, p1);
	  b_done=1;
	}

      /* Timeline for CTF - events */
      if (strstr(tag, "Q3L_CTFTIMELINE")!=NULL)
	{
	  p1=get_param_int(tag, "WIDTH");
	  p2=get_param_int(tag, "HEIGHT");
	  p3=get_param_int(tag, "OFFSETX");
	  p4=get_param_int(tag, "OFFSETY");
	  if (strstr(tag,"STEPS"))
	    p5=1; else p5=0;
	  c1=get_param_string(tag, "SOURCE");
	  bgimage=load_img(c1, cfg->templdir,p1,p2);
	  if (p1<0 || p1>1024) p1=400;
	  if (p2<0 || p2>1024) p2=150;
	  if (p3>=p1) p3=0;
	  if (p4>=p2) p4=0;
	  if (p3<0) p3=0;
	  if (p4<0) p4=0;
	  write_sg_ctftimeline(fp, games[cg], p3,p4,1,1, cfg->outdir, bgimage,
			       cfg->zcompression,p5);
	  b_done=1;
	}

      /* Team-results within a game */
      if (strstr(tag, "Q3L_SG_CTFSTATS")!=NULL)
	{
	  c1=get_param_string(tag, "REDC");
	  c2=get_param_string(tag, "BLUEC");
	  c3=get_param_string(tag, "HEADC");
	  write_sg_ctfstats(fp, games[cg], c1, c2, c3);
	  b_done=1;
	}

      /* CTF-details */
      if (strstr(tag, "Q3L_SG_CTFDETAILS")!=NULL)
	{
	  c1=get_param_string(tag, "REDC");
	  c2=get_param_string(tag, "BLUEC");
	  c3=get_param_string(tag, "NEUTRALC");
	  c4=get_param_string(tag, "HEADC");
	  if (strstr(tag,"HUMANONLY"))
	    p1=1; else p1=0;
	  write_sg_ctfdetails(fp, games[cg], c1, c2, c3, c4, cfg->b_kick, p1);
	  b_done=1;
	}

      /* Timeline for Team - events */
      if (strstr(tag, "Q3L_TEAMTIMELINE")!=NULL)
	{
	  p1=get_param_int(tag, "WIDTH");
	  p2=get_param_int(tag, "HEIGHT");
	  p3=get_param_int(tag, "OFFSETX");
	  p4=get_param_int(tag, "OFFSETY");
	  c1=get_param_string(tag, "SOURCE");
	  if (strstr(tag,"STEPS"))
	    p5=1; else p5=0;
	  bgimage=load_img(c1,cfg->templdir,p1,p2);
	  if (p1<0 || p1>1024) p1=400;
	  if (p2<0 || p2>1024) p2=150;
	  if (p3>=p1) p3=0;
	  if (p4>=p2) p4=0;
	  if (p3<0) p3=0;
	  if (p4<0) p4=0;
	  write_sg_teamtimeline(fp, games[cg], p3,p4,1,1,cfg->outdir, bgimage,
				cfg->zcompression, p5);
	  b_done=1;
	}

      /* Team-results within a game */
      if (strstr(tag, "Q3L_SG_TEAMSTATS")!=NULL)
	{
	  c1=get_param_string(tag, "REDC");
	  c2=get_param_string(tag, "BLUEC");
	  c3=get_param_string(tag, "HEADC");
	  write_sg_teamstats(fp, games[cg], c1, c2, c3);
	  b_done=1;
	}

      /* Timeline for Kill - events */
      if (strstr(tag, "Q3L_TIMELINE")!=NULL)
	{
	  p1=get_param_int(tag, "WIDTH");
	  p2=get_param_int(tag, "HEIGHT");
	  p3=get_param_int(tag, "OFFSETX");
	  p4=get_param_int(tag, "OFFSETY");
	  c1=get_param_string(tag, "SOURCE");
	  if (strstr(tag,"STEPS"))
	    p5=1; else p5=0;
	  if (strstr(tag,"HUMANONLY"))
	    p6=1; else p6=0;
	  bgimage=load_img(c1, cfg->templdir,p1,p2);
	  if (p1<0 || p1>1024) p1=400;
	  if (p2<0 || p2>1024) p2=150;
	  if (p3>=p1) p3=0;
	  if (p4>=p2) p4=0;
	  if (p3<0) p3=0;
	  if (p4<0) p4=0;
	  write_sg_fragtimeline(fp, games[cg], p3,p4,1,1,cfg->outdir, bgimage,
				cfg->zcompression, p5,p6, cfg->b_kick);
	  b_done=1;
	}
      
      /* All player-stats within a game */
      if (strstr(tag, "Q3L_SG_RANKS")!=NULL)
	{
	  c1=get_param_string(tag, "REDC");
	  c2=get_param_string(tag, "BLUEC");
	  c3=get_param_string(tag, "NEUTRALC");
	  c4=get_param_string(tag, "HEADC");
	  if (strstr(tag,"HUMANONLY"))
	    p6=1; else p6=0;
	  if (strstr(tag, "NOCOLORS"))
	    write_sg_ranks(fp, games[cg], todo, todo_t, todo_p, sp,\
			   c1, c2, c3, c4, NULL, p6, cfg);
	  else
	    write_sg_ranks(fp, games[cg], todo, todo_t, todo_p, sp,\
			   c1, c2, c3, c4, palimage, p6, cfg);
	  b_done=1;
	}

      /* who killed who */
      if (strstr(tag, "Q3L_SG_KILLTABLE")!=NULL)
	{
	  c1=get_param_string(tag, "REDC");
	  c2=get_param_string(tag, "BLUEC");
	  c3=get_param_string(tag, "NEUTRALC");
	  c4=get_param_string(tag, "SUICIDEC");
	  write_sg_killtab(fp, games[cg], c1, c2, c3, c4, cfg->b_kick,cfg->time_minimum);
	  b_done=1;
	}

      /* Weapons used */
      if (strstr(tag, "Q3L_SG_WEAPONS")!=NULL)
	{
	  p1=get_param_int(tag, "COLS");
	  if (strstr(tag, "SHOWALL")!=NULL)
	    p2=1; else p2=0;
	  if (strstr(tag, "COMPACT")!=NULL)
	    p3=1; else p3=0;
	  write_any_weapons(fp, games[cg]->weaps,p1,p2,p3);
	  b_done=1;
	}

      if (strstr(tag, "Q3L_SG_WEAPGRAPH")!=NULL)
	{
	  p1=get_param_int(tag, "WIDTH");
	  p2=get_param_int(tag, "HEIGHT");
	  p3=get_param_int(tag, "COLS");
	  if (strstr(tag, "COMPACT")!=NULL)
	    p4=1; else p4=0;
	  if (strstr(tag, "SHOWALL")!=NULL)
	    p5=1; else p5=0;
	  c1=get_param_string(tag, "PRE");
	  write_any_weapons_graph(fp, games[cg]->weaps,c1,
				  p4,p5,p3, p1,p2);
	  b_done=1;
	}

      /* Single Game Suicides */
      if (strstr(tag, "Q3L_SG_SUICIDEWEAPONS")!=NULL)
	{
	  p1=get_param_int(tag, "COLS");
	  if (strstr(tag, "SHOWALL")!=NULL)
	    p2=1; else p2=0;
	  if (strstr(tag, "COMPACT")!=NULL)
	    p3=1; else p3=0;
	  write_any_weapons(fp, games[cg]->wsui,p1,p2,p3);
	  b_done=1;
	}
      if (strstr(tag, "Q3L_SG_SUICIDEGRAPH")!=NULL)
	{
	  p1=get_param_int(tag, "WIDTH");
	  p2=get_param_int(tag, "HEIGHT");
	  p3=get_param_int(tag, "COLS");
	  if (strstr(tag, "COMPACT")!=NULL)
	    p4=1; else p4=0;
	  if (strstr(tag, "SHOWALL")!=NULL)
	    p5=1; else p5=0;
	  c1=get_param_string(tag, "PRE");
	  write_any_weapons_graph(fp, games[cg]->wsui,c1,
				  p4,p5,p3, p1,p2);
	  b_done=1;
	}

      /* Single Game TeamKills */
      if (strstr(tag, "Q3L_SG_TEAMKILLWEAPONS")!=NULL)
	{
	  p1=get_param_int(tag, "COLS");
	  if (strstr(tag, "SHOWALL")!=NULL)
	    p2=1; else p2=0;
	  if (strstr(tag, "COMPACT")!=NULL)
	    p3=1; else p3=0;
	  write_any_weapons(fp, games[cg]->wtkill,p1,p2,p3);
	  b_done=1;
	}
      if (strstr(tag, "Q3L_SG_TEAMKILLGRAPH")!=NULL)
	{
	  p1=get_param_int(tag, "WIDTH");
	  p2=get_param_int(tag, "HEIGHT");
	  p3=get_param_int(tag, "COLS");
	  if (strstr(tag, "COMPACT")!=NULL)
	    p4=1; else p4=0;
	  if (strstr(tag, "SHOWALL")!=NULL)
	    p5=1; else p5=0;
	  c1=get_param_string(tag, "PRE");
	  write_any_weapons_graph(fp, games[cg]->wtkill,c1,
				  p4,p5,p3, p1,p2);
	  b_done=1;
	}

      /* Items used */
      if (strstr(tag, "Q3L_SG_ITEMS")!=NULL)
	{
	  p1=get_param_int(tag, "COLS");
	  if (strstr(tag, "SHOWALL")!=NULL)
	    p2=1; else p2=0;
	  write_any_items(fp, games[cg]->lst_items, p1, p2);
	  b_done=1;
	}

      /* NOW some strings for SG */
      if (strstr(tag, "Q3L_SG_DURATION")!=NULL)
	{
	  p1=games[cg]->secs;
	  fprintf(fp, "%02i:%02i", p1/60, p1%60);
	  b_done=1;
	}

      if (strstr(tag, "Q3L_SG_TIMELIMIT")!=NULL)
	{
	  fprintf(fp, "%li", games[cg]->timelimit);
	  b_done=1;
	}

      if (strstr(tag, "Q3L_SG_FRAGLIMIT")!=NULL)
	{
	  fprintf(fp, "%li", games[cg]->fraglimit);
	  b_done=1;
	}

      if (strstr(tag, "Q3L_SG_CAPTURELIMIT")!=NULL)
	{
	  fprintf(fp, "%li", games[cg]->capturelimit);
	  b_done=1;
	}

      if (strstr(tag, "Q3L_SG_GAMEEND")!=NULL)
	{
	  switch(games[cg]->exit_state){
	  case EXIT_FRAG:
	    fprintf(fp, "fraglimit hit");
	    break;
	  case EXIT_CAPTURE:
	    fprintf(fp, "capturelimit hit");
	    break;
	  case EXIT_TIME:
	    fprintf(fp, "timelimit hit");
	    break;
	  default:
	    fprintf(fp, "game was aborted");
	  }
	  b_done=1;
	}

      if (strstr(tag, "Q3L_SG_GAMETYPE")!=NULL)
	  {
	    if (games[cg]->type<GAMETYPE_MAX)
	      fprintf(fp, "%s", c_gamemodes[(int)games[cg]->type]);
	    else
	      fprintf(fp, "%s", c_gamemodes[GAMETYPE_MAX]);
	    b_done=1;
	  }

      if (strstr(tag, "Q3L_SG_MAPNAME")!=NULL)
	{
	  fprintf(fp, "%s", games[cg]->mapname);
	  b_done=1;
	}

      if (strstr(tag, "Q3L_SG_MAPIMAGE")!=NULL)
	{
	  for(i=0; i<parray_elements(mapname); i++)
	    if (string_compare_charptr(parray_get(mapname, i),
				       games[cg]->mapname, true)==0)
	      break;
	  if (i<parray_elements(mapname))
	    {
	      fprintf(fp, "<img src=\"pix/maps/%s\" %s",
		      string_charptr(parray_get(mapimg, i)),
		      &tag[strlen("Q3L_SG_MAPIMAGE")+1]);
	    }
	  b_done=1;
	}

      if (strstr(tag, "Q3L_SG_MAPFULLNAME")!=NULL)
	{
	  fprintf(fp, "%s (%s)", mapname_generate(games[cg]->mapname),\
		  games[cg]->mapname);
	  b_done=1;
	}

      if (strstr(tag, "Q3L_SG_MAPLONGNAME")!=NULL)
	{
	  fprintf(fp, "%s", mapname_generate(games[cg]->mapname));
	  b_done=1;
	}

      if (strstr(tag, "Q3L_SG_SERVERNAME")!=NULL)
	{
	  fprintf(fp, "%s", games[cg]->servername);
	  b_done=1;
	}

      if (strstr(tag, "Q3L_SG_FRAGMASTERNAME")!=NULL)
	{
	  j=0;
	  for(i=1; i<games[cg]->nof_players; i++)
	    if (games[cg]->player[i]->nof_frags>
		games[cg]->player[j]->nof_frags)
	      j=i;
	  b_done=1;
	  fprintf(fp,"%s", make_funname(games[cg]->player[j]->name, 1));
	}

      if (strstr(tag, "Q3L_SG_KILLMASTERNAME")!=NULL)
	{
	  j=0;
	  for(i=1; i<games[cg]->nof_players; i++)
	    if (games[cg]->player[i]->nof_kills>
		games[cg]->player[j]->nof_kills)
	      j=i;
	  b_done=1;
	  fprintf(fp,"%s", make_funname(games[cg]->player[j]->name,1));
	}

      if (strstr(tag, "Q3L_SG_EASYPREYNAME")!=NULL)
	{
	  j=0;
	  for(i=1; i<games[cg]->nof_players; i++)
	    if (games[cg]->player[i]->nof_deaths>
		games[cg]->player[j]->nof_deaths)
	      j=i;
	  b_done=1;
	  fprintf(fp,"%s", make_funname(games[cg]->player[j]->name,1));
	}
      if (strstr(tag, "Q3L_SG_FOOLNAME")!=NULL)
	{
	  j=0;
	  for(i=1; i<games[cg]->nof_players; i++)
	    if (games[cg]->player[i]->nof_suicides>
		games[cg]->player[j]->nof_suicides)
	      j=i;
	  b_done=1;
	  fprintf(fp,"%s", make_funname(games[cg]->player[j]->name,1));
	}
      if (strstr(tag, "Q3L_SG_EFFECTIVENESSNAME")!=NULL)
	{
	  j=0;
	  for(i=1; i<games[cg]->nof_players; i++)
	    if (games[cg]->player[i]->effect>
		games[cg]->player[j]->effect)
	      j=i;
	  b_done=1;
	  fprintf(fp,"%s", make_funname(games[cg]->player[j]->name,1));
	}
      if (strstr(tag, "Q3L_SG_FASTKILLERNAME")!=NULL)
	{
	  j=0;
	  for(i=1; i<games[cg]->nof_players; i++)
	    if (games[cg]->player[i]->fph >
		games[cg]->player[j]->fph)
	      j=i;
	  b_done=1;
	  fprintf(fp,"%s", make_funname(games[cg]->player[j]->name,1));
	}
      if (strstr(tag, "Q3L_SG_ROBUSTNESSNAME")!=NULL)
	{
	  j=0;
	  for(i=1; i<games[cg]->nof_players; i++)
	    if (games[cg]->player[i]->ttl>
		games[cg]->player[j]->ttl)
	      j=i;
	  b_done=1;
	  fprintf(fp,"%s", make_funname(games[cg]->player[j]->name,1));
	}


      /*
       *
       *
       the stats for player in single-game follow
       *
       *
       */
      if (cp>=0)
	{
	  if (strstr(tag, "Q3L_SP_PLAYERNAME")!=NULL)
	    {
	      write_sp_playername(fp, games[cg], cp);
	      b_done=1;
	    }

	  if (strstr(tag, "Q3L_SP_WEAPON")!=NULL)
	    {
	      p1=get_param_int(tag, "COLS");
	      if (strstr(tag, "SHOWALL")!=NULL)
		p2=1; else p2=0;
	      if (strstr(tag, "COMPACT")!=NULL)
		p3=1; else p3=0;
	      write_any_weapons(fp, games[cg]->player[cp]->weaps, p1, p2, p3);
	      b_done=1;
	    }

	  if (strstr(tag, "Q3L_SP_TEAMKILLWEAPON")!=NULL)
	    {
	      p1=get_param_int(tag, "COLS");
	      if (strstr(tag, "SHOWALL")!=NULL)
		p2=1; else p2=0;
	      if (strstr(tag, "COMPACT")!=NULL)
		p3=1; else p3=0;
	      write_any_weapons(fp, games[cg]->player[cp]->wtkill, p1, p2, p3);
	      b_done=1;
	    }

	  if (strstr(tag, "Q3L_SP_SUICIDEWEAPON")!=NULL)
	    {
	      p1=get_param_int(tag, "COLS");
	      if (strstr(tag, "SHOWALL")!=NULL)
		p2=1; else p2=0;
	      if (strstr(tag, "COMPACT")!=NULL)
		p3=1; else p3=0;
	      write_any_weapons(fp, games[cg]->player[cp]->wsui, p1, p2, p3);
	      b_done=1;
	    }

	  if (strstr(tag, "Q3L_SP_DEATHWEAPON")!=NULL)
	    {
	      p1=get_param_int(tag, "COLS");
	      if (strstr(tag, "SHOWALL")!=NULL)
		p2=1; else p2=0;
	      if (strstr(tag, "COMPACT")!=NULL)
		p3=1; else p3=0;
	      write_any_weapons(fp, games[cg]->player[cp]->wdeath, p1, p2, p3);
	      b_done=1;
	    }
	  
	  if (strstr(tag, "Q3L_SP_ITEMS")!=NULL)
	    {
	      p1=get_param_int(tag, "COLS");
	      if (strstr(tag, "SHOWALL")!=NULL)
		p2=1; else p2=0;
	      write_any_items(fp, games[cg]->player[cp]->lst_items, p1, p2);
	      b_done=1;
	    }

	  if (strstr(tag, "Q3L_SP_KILLTABLE")!=NULL)
	    {
	      c1=get_param_string(tag, "REDC");
	      c2=get_param_string(tag, "BLUEC");
	      c3=get_param_string(tag, "NEUTRALC");
	      c4=get_param_string(tag, "HEADC");
	      if (strstr(tag, "SHOWALL"))
		p1=1; else p1=0;
	      write_sp_killtable(fp, games[cg], cp, c1, c2, c3, c4, p1);
	      b_done=1;
	    }

	}
      if (b_done)
	{
	  if (c1!=NULL) free(c1);
	  if (c2!=NULL) free(c2);
	  if (c3!=NULL) free(c3);
	  if (c4!=NULL) free(c4);
	  if (c5!=NULL) free(c5);
	  return;
	}
    }



  /*
   *
   *
   all-time tags
   *
   *
   */
  if (strstr(tag, "Q3L_GAMETABLE")!=NULL)
    {
      p1=get_param_int(tag, "COLS");
      if (p1<0) p1=3;
      if (strstr(tag, "NOGAMETYP")!=NULL)
	p2=0;
      else p2=1;
      write_sg_table(fp, games, nof_games, todo, todo_t, todo_p, sp, p1, p2,\
		     cfg->player_minimum);
      b_done=1;
    }
  if (strstr(tag, "Q3L_CALCULATIONSTRING")!=NULL)
    {
      fprintf(fp, "%s", calc_string);
      b_done=1;
    }


  /*
   *
   *
   All-game stats
   *
   *
   */
  /* General stats for all game played */
  if (strstr(tag, "Q3L_AG_STATS")!=NULL)
    {
      c1=get_param_string(tag, "HEADC");
      write_ag_stats(fp, lts, c1);
      b_done=1;
    }
  if (strstr(tag, "Q3L_AG_CTFSTATS")!=NULL)
    {
      c1=get_param_string(tag, "HEADC");
      write_ag_ctfstats(fp, lts, c1);
      b_done=1;
    }

  /* Weapons used */
  if (strstr(tag, "Q3L_AG_WEAPONS")!=NULL)
    {
      p1=get_param_int(tag, "COLS");
      if (strstr(tag, "SHOWALL")!=NULL)
	p2=1; else p2=0;
      if (strstr(tag, "COMPACT")!=NULL)
	p3=1; else p3=0;
      write_any_weapons(fp, lts->weaps, p1, p2, p3);
      b_done=1;
    }

  if (strstr(tag, "Q3L_AG_WEAPGRAPH")!=NULL)
    {
      p1=get_param_int(tag, "WIDTH");
      p2=get_param_int(tag, "HEIGHT");
      p3=get_param_int(tag, "COLS");
      if (strstr(tag, "COMPACT")!=NULL)
	p4=1; else p4=0;
      if (strstr(tag, "SHOWALL")!=NULL)
	p5=1; else p5=0;
      c1=get_param_string(tag, "PRE");
      write_any_weapons_graph(fp, lts->weaps,c1,
			      p4,p5,p3, p1,p2);
      b_done=1;
    }

  /* Weapons used TEAMKILL*/
  if (strstr(tag, "Q3L_AG_TEAMKILLWEAPONS")!=NULL)
    {
      p1=get_param_int(tag, "COLS");
      if (strstr(tag, "SHOWALL")!=NULL)
	p2=1; else p2=0;
      if (strstr(tag, "COMPACT")!=NULL)
	p3=1; else p3=0;
      write_any_weapons(fp, lts->wtkill, p1, p2, p3);
      b_done=1;
    }

  if (strstr(tag, "Q3L_AG_TEAMKILLGRAPH")!=NULL)
    {
      p1=get_param_int(tag, "WIDTH");
      p2=get_param_int(tag, "HEIGHT");
      p3=get_param_int(tag, "COLS");
      if (strstr(tag, "COMPACT")!=NULL)
	p4=1; else p4=0;
      if (strstr(tag, "SHOWALL")!=NULL)
	p5=1; else p5=0;
      c1=get_param_string(tag, "PRE");
      write_any_weapons_graph(fp, lts->wtkill,c1,
			      p4,p5,p3, p1,p2);
      b_done=1;
    }

  /* Weapons used SUICIDE*/
  if (strstr(tag, "Q3L_AG_SUICIDEWEAPONS")!=NULL)
    {
      p1=get_param_int(tag, "COLS");
      if (strstr(tag, "SHOWALL")!=NULL)
	p2=1; else p2=0;
      if (strstr(tag, "COMPACT")!=NULL)
	p3=1; else p3=0;
      write_any_weapons(fp, lts->wsui, p1, p2, p3);
      b_done=1;
    }
  if (strstr(tag, "Q3L_AG_SUICIDEGRAPH")!=NULL)
    {
      p1=get_param_int(tag, "WIDTH");
      p2=get_param_int(tag, "HEIGHT");
      p3=get_param_int(tag, "COLS");
      if (strstr(tag, "COMPACT")!=NULL)
	p4=1; else p4=0;
      if (strstr(tag, "SHOWALL")!=NULL)
	p5=1; else p5=0;
      c1=get_param_string(tag, "PRE");
      write_any_weapons_graph(fp, lts->wsui,c1,
			      p4,p5,p3, p1,p2);
      b_done=1;
    }

  /* Items taken */
  if (strstr(tag, "Q3L_AG_ITEMS")!=NULL)
    {
      p1=get_param_int(tag, "COLS");
      if (strstr(tag, "SHOWALL")!=NULL)
	p2=1; else p2=0;
      write_ag_pickups(fp, lts, p1, p2);
      b_done=1;
    }
  if (b_done)
    {
      if (c1!=NULL) free(c1);
      if (c2!=NULL) free(c2);
      if (c3!=NULL) free(c3);
      if (c4!=NULL) free(c4);
      if (c5!=NULL) free(c5);
      return;
    }
  if (strstr(tag, "Q3L_AG_FRAGMASTERNAME")!=NULL)
    {
      j=0;
      for(i=1; i<lts->nof_players; i++)
	if (lts->ltplayers[j]->nof_frags<lts->ltplayers[i]->nof_frags)
	  j=i;
      fprintf(fp,"%s", make_funname(lts->ltplayers[j]->name,1));
      b_done=1;
    }
  if (strstr(tag, "Q3L_AG_KILLMASTERNAME")!=NULL)
    {
      j=0;
      for(i=1; i<lts->nof_players; i++)
	if (lts->ltplayers[j]->nof_kills<lts->ltplayers[i]->nof_kills)
	  j=i;
      fprintf(fp,"%s", make_funname(lts->ltplayers[j]->name,1));
      b_done=1;
    }
  if (strstr(tag, "Q3L_AG_EASYPREYNAME")!=NULL)
    {
      j=0;
      for(i=1; i<lts->nof_players; i++)
	if (lts->ltplayers[j]->nof_deaths<lts->ltplayers[i]->nof_deaths)
	  j=i;
      fprintf(fp,"%s", make_funname(lts->ltplayers[j]->name,1));
      b_done=1;
    }
  if (strstr(tag, "Q3L_AG_FOOLNAME")!=NULL)
    {
      j=0;
      for(i=1; i<lts->nof_players; i++)
	if (lts->ltplayers[j]->nof_suicides<lts->ltplayers[i]->nof_suicides)
	  j=i;
      fprintf(fp,"%s", make_funname(lts->ltplayers[j]->name,1));
      b_done=1;
    }
  if (strstr(tag, "Q3L_AG_EFFECTIVENESSNAME")!=NULL)
    {
      j=0;
      for(i=1; i<lts->nof_players; i++)
	if (lts->ltplayers[j]->effect<lts->ltplayers[i]->effect)
	  j=i;
      fprintf(fp,"%s", make_funname(lts->ltplayers[j]->name,1));
      b_done=1;
    }
  if (strstr(tag, "Q3L_AG_FASTKILLERNAME")!=NULL)
    {
      j=0;
      for(i=1; i<lts->nof_players; i++)
	if (lts->ltplayers[j]->fph < lts->ltplayers[i]->fph)
	  j=i;
      fprintf(fp,"%s", make_funname(lts->ltplayers[j]->name,1));
      b_done=1;
    }
  if (strstr(tag, "Q3L_AG_LONGTIMENAME")!=NULL)
    {
      j=0;
      for(i=1; i<lts->nof_players; i++)
	if (lts->ltplayers[j]->secs<lts->ltplayers[i]->secs)
	  j=i;
      fprintf(fp,"%s", make_funname(lts->ltplayers[j]->name,1));
      b_done=1;
    }
  if (strstr(tag, "Q3L_AG_ROBUSTNESSNAME")!=NULL)
    {
      j=0;
      for(i=1; i<lts->nof_players; i++)
	if (lts->ltplayers[j]->ttl<lts->ltplayers[i]->ttl)
	  j=i;
      fprintf(fp,"%s", make_funname(lts->ltplayers[j]->name,1));
      b_done=1;
    }
  if (strstr(tag, "Q3L_AG_HERCULESNAME")!=NULL)
    {
      j=0;
      for(i=1; i<lts->nof_players; i++)
	if (lts->ltplayers[j]->nof_items < lts->ltplayers[i]->nof_items)
	  j=i;
      fprintf(fp,"%s", make_funname(lts->ltplayers[j]->name,1));
      b_done=1;
    }
  if (strstr(tag, "Q3L_AG_HORMONBOOSTEDNAME")!=NULL)
    {
      j=0;
      for(i=1; i<lts->nof_players; i++)
	if (lts->ltplayers[j]->items[24] < lts->ltplayers[i]->items[24])
	  j=i;
      fprintf(fp,"%s", make_funname(lts->ltplayers[j]->name,1));
      b_done=1;
    }
  if (strstr(tag, "Q3L_AG_CTFSCORENAME")!=NULL)
    {
      j=0;
      for(i=1; i<lts->nof_players; i++)
	if (lts->ltplayers[j]->ctf_score < lts->ltplayers[i]->ctf_score)
	  j=i;
      fprintf(fp,"%s", make_funname(lts->ltplayers[j]->name,1));
      b_done=1;
    }





  /*
   *
   *
   All Game - Player
   *
   *
   */
  /* Stats for all players ever played */
  if (strstr(tag, "Q3L_AP_ALLSTATS")!=NULL)
    {
      p1=0;
      c1=get_param_string(tag, "HEADC");
      c2=get_param_string(tag, "SORTC");
      c3=get_param_string(tag, "TABLEFORMAT");
      if (strstr(tag, "SORTDEATHS"))
	  p1=SORT_DEATHS;
      if (strstr(tag, "SORTKILLS"))
	  p1=SORT_KILLS;
      if (strstr(tag, "SORTTIME"))
	  p1=SORT_TIME;
      if (strstr(tag, "SORTSUICIDES"))
	  p1=SORT_SUICIDES;
      if (strstr(tag, "SORTFPH"))
	  p1=SORT_FPH;
      if (strstr(tag, "SORTNAME"))
	  p1=SORT_NAME;
      if (strstr(tag, "SORTEFFICENCY"))
	  p1=SORT_EFFICENCY;
      if (strstr(tag, "SORTTTL"))
	  p1=SORT_TTL;
      if (strstr(tag, "SORTCTFSCORE"))
	  p1=SORT_CTFSCORE;
      if (strstr(tag, "HUMANONLY"))
	  p2=1;
      else p2=0;
      p3=get_param_int(tag, "LINELIMIT");
      if (p3==-1) p3=cfg->linelimit;
      cfg->templateformat=config_parseTableFormat(c3);
      write_agp_allstats(fp, lts, c1, c2, todo, todo_t, todo_p, sp,\
			 p1, p2, p3, cfg);
      if (cfg->templateformat)
	cfg->templateformat=iarray_del(cfg->templateformat);
      b_done=1;
    }

  /* All-time player stats can just be written if cp is set*/
  if (cp>=0)
    {
      if (strstr(tag,"Q3L_AP_PLAYERNAME")!=NULL)
	{
	  fprintf(fp, "%s", make_funname(lts->ltplayers[cp]->name,1));
	  b_done=1;
	}
      
      if (strstr(tag,"Q3L_AP_PLAYERSTATS")!=NULL)
	{
	  c1=get_param_string(tag, "HEADC");
	  write_ap_stats(fp, lts->ltplayers[cp], c1);
	  b_done=1;
	}
      if (strstr(tag,"Q3L_AP_CTFSTATS")!=NULL)
	{
	  c1=get_param_string(tag, "HEADC");
	  write_ap_ctfstats(fp, lts->ltplayers[cp], c1);
	  b_done=1;
	}
      
      /* All Game Player - Weapons */
      if (strstr(tag, "Q3L_AP_WEAPONS")!=NULL)
	{
	  p1=get_param_int(tag, "COLS");
	  if (strstr(tag, "SHOWALL")!=NULL)
	    p2=1; else p2=0;
	  if (strstr(tag, "COMPACT")!=NULL)
	    p3=1; else p3=0;
	  write_any_weapons(fp, lts->ltplayers[cp]->weaps, p1, p2, p3);
	  b_done=1;
	}
      
      /* All Game Player - Single Player - Suicides */
      if (strstr(tag, "Q3L_AP_SUICIDEWEAPONS")!=NULL)
	{
	  p1=get_param_int(tag, "COLS");
	  if (strstr(tag, "SHOWALL")!=NULL)
	    p2=1; else p2=0;
	  if (strstr(tag, "COMPACT")!=NULL)
	    p3=1; else p3=0;
	  write_any_weapons(fp, lts->ltplayers[cp]->wsui, p1, p2, p3);
	  b_done=1;
	}
      
      /* All Game Player - Single Player - TeamKills */
      if (strstr(tag, "Q3L_AP_TEAMKILLWEAPONS")!=NULL)
	{
	  p1=get_param_int(tag, "COLS");
	  if (strstr(tag, "SHOWALL")!=NULL)
	    p2=1; else p2=0;
	  if (strstr(tag, "COMPACT")!=NULL)
	    p3=1; else p3=0;
	  write_any_weapons(fp, lts->ltplayers[cp]->wtkill, p1, p2, p3);
	  b_done=1;
	}

      /* All Game Player - Single Player - Died by WEAP */
      if (strstr(tag, "Q3L_AP_DEATHWEAPONS")!=NULL)
	{
	  p1=get_param_int(tag, "COLS");
	  if (strstr(tag, "SHOWALL")!=NULL)
	    p2=1; else p2=0;
	  if (strstr(tag, "COMPACT")!=NULL)
	    p3=1; else p3=0;
	  write_any_weapons(fp, lts->ltplayers[cp]->wdeath, p1, p2, p3);
	  b_done=1;
	}
      
      /* All Game Player - Single Player - Items */
      if (strstr(tag, "Q3L_AP_ITEMS")!=NULL)
	{
	  p1=get_param_int(tag, "COLS");
	  if (strstr(tag, "SHOWALL")!=NULL)
	    p2=1; else p2=0;
	  write_any_items(fp, lts->ltplayers[cp]->items, p1, p2);
	  b_done=1;
	}
    }

  /*
   *
   *
   SPECIAL TAGS
   *
   *
   */
  if (strstr(tag, "Q3L_DATE")!=NULL){
    write_date(fp);
    b_done=1;}
  if (strstr(tag, "Q3L_TIME")!=NULL){
    write_time(fp);
    b_done=1;}
  if (strstr(tag, "Q3L_IF")!=NULL)
    b_done=1; // parsed especially
  if (strstr(tag, "Q3L_ENDIF")!=NULL)
    b_done=1; // parsed especially

  /* special tag for linking files */
  if (strstr(tag, "Q3L_HTML")!=NULL)
    {
      c1=get_param_string(tag, "FILE");
      if (c1==NULL)
	return;
      exist=0;
      for(i=0; i<*sp; i++)
	if (strcmp(todo[i], c1)==0)
	  exist=1;
      if (!exist)
	{
	  todo[*sp]=strdup(c1);
	  todo_t[*sp]=strdup(c1);
	  todo_p[*sp]=strdup(tag);
	  (*sp)++;
	}
      b_done=1;
    }

  if ((strstr(tag, "_VW_")!=NULL) || (strstr(tag, "_VI_")!=NULL) ||\
      (strstr(tag, "_VG_")!=NULL))
    {
      b_done=check_var(fp, tag, cg, cp, games, nof_games, lts);
    }

  if (c1!=NULL) free(c1);
  if (c2!=NULL) free(c2);
  if (c3!=NULL) free(c3);
  if (c4!=NULL) free(c4);
  if (c5!=NULL) free(c5);
  if (!b_done)
    fprintf(stderr, "Unknown Q3L-Tag -> %s\n", tag);
}








/*
 *
 *
 simple BOOLean operation
 *
 *
 */
int check_if(char *source, char *key, t_lts *lts,\
	     t_game **games, int nof_games, char *t_p)
{
  char *s, *e, t_key[MAXIFCOND], b_true;
  int   cg=-1, cp=-1, i, j;
  char  b_done=0;

  if (t_p!=NULL)
    {
      cg=get_param_int(t_p, "GAMEID");
      cp=get_param_int(t_p, "PLAYERID");
    }
  //if (strstr(source, "<Q3L_ENDIF");
  s=strstr(source, "<Q3L_");
  while(*s!=32)
    s++;
  while(*s==32)
    s++;
  e=s;
  while(*e!=32 && *e!='>' && *e!=0)
    e++;
  *e=0;
  b_true=0;
  memset(t_key,0,MAXIFCOND);
  strncpy(t_key, s, e-s);
  //printf("--> IF - %s   (last : %s)\n",source, key);
  if (strstr(source, "Q3L_IF")!=NULL)
    {
      if (cg>=0)
	{
	  if (strstr(t_key, "SG_TEAMGAME")!=NULL)
	    {b_done=1;
	    if (games[cg]->type==GAMETYPE_CTF ||
		games[cg]->type==GAMETYPE_TDM) b_true=1;}
	  if (strstr(t_key, "SG_SINGLEGAME")!=NULL)
	    {b_done=1; if (games[cg]->type==GAMETYPE_DM) b_true=1;}
	  if (strstr(t_key, "SG_SUICIDE")!=NULL)
	    {b_done=1; if (cg>=0 && games[cg]->nof_suicides) b_true=1;}
	  if (strstr(t_key, "SG_CTF")!=NULL)
	    {b_done=1; if (games[cg]->type==GAMETYPE_CTF) b_true=1;}
	  if (strstr(t_key, "SG_TEAMDEATHMATCH")!=NULL)
	    {b_done=1; if (games[cg]->type==GAMETYPE_TDM) b_true=1;}

	  if (cp>=0)
	    {
	      if (strstr(t_key, "SP_SUICIDE")!=NULL)
		{b_done=1; if (games[cg]->player[cp]->nof_suicides) b_true=1;}
	      if (strstr(t_key, "SP_DIED")!=NULL)
		{b_done=1; if (games[cg]->player[cp]->nof_deaths) b_true=1;}
	      if (strstr(t_key, "SP_TEAMKILL")!=NULL)
		{b_done=1; if (games[cg]->player[cp]->nof_tkills) b_true=1;}

	      if ( (strstr(t_key,"SP_FRAGMASTER")!=NULL) ||
		   (strstr(t_key,"SG_FRAGMASTER")!=NULL) )
		{
		  j=0;
		  b_done=1;
		  for(i=1; i<games[cg]->nof_players; i++)
		    if (games[cg]->player[i]->nof_frags>
			games[cg]->player[j]->nof_frags)
		      j=i;
		  if (j==cp) b_true=1;
		}
	      if ( (strstr(t_key,"SP_FOOL")!=NULL) ||
		   (strstr(t_key,"SG_FOOL")!=NULL) )
		{
		  j=0;
		  b_done=1;
		  for(i=1; i<games[cg]->nof_players; i++)
		    if (games[cg]->player[i]->nof_suicides>
			games[cg]->player[j]->nof_suicides)
		      j=i;
		  if (j==cp) b_true=1;
		}
	      if ( (strstr(t_key,"SP_ROBUSTNESS")!=NULL) ||
		   (strstr(t_key,"SG_ROBUSTNESS")!=NULL) )
		{
		  j=0;
		  b_done=1;
		  for(i=1; i<games[cg]->nof_players; i++)
		    if (games[cg]->player[i]->ttl >
			games[cg]->player[j]->ttl)
		      j=i;
		  if (j==cp) b_true=1;
		}
	      if ( (strstr(t_key,"SP_EFFECTIVENESS")!=NULL) ||
		   (strstr(t_key,"SG_EFFECTIVENESS")!=NULL) )
		{
		  j=0;
		  b_done=1;
		  for(i=1; i<games[cg]->nof_players; i++)
		    if (games[cg]->player[i]->effect >
			games[cg]->player[j]->effect)
		      j=i;
		  if (j==cp) b_true=1;
		}
	      if ( (strstr(t_key,"SP_FASTKILLER")!=NULL) ||
		   (strstr(t_key,"SG_FASTKILLER")!=NULL) )
		{
		  j=0;
		  b_done=1;
		  for(i=1; i<games[cg]->nof_players; i++)
		    if (games[cg]->player[i]->fph >
			games[cg]->player[j]->fph)
		      j=i;
		  if (j==cp) b_true=1;
		}
	      if ( (strstr(t_key,"SP_EASYPREY")!=NULL) ||
		   (strstr(t_key,"SG_EASYPREY")!=NULL) )
		{
		  j=0;
		  b_done=1;
		  for(i=1; i<games[cg]->nof_players; i++)
		    if (games[cg]->player[i]->nof_deaths >
			games[cg]->player[j]->nof_deaths)
		      j=i;
		  if (j==cp) b_true=1;
		}
	      if ( (strstr(t_key,"SP_HERCULES")!=NULL) ||
		   (strstr(t_key,"SG_HERCULES")!=NULL) )
		{
		  j=0;
		  b_done=1;
		  for(i=1; i<games[cg]->nof_players; i++)
		    if (games[cg]->player[i]->nof_items >
			games[cg]->player[j]->nof_items)
		      j=i;
		  if (j==cp) b_true=1;
		}
	      if ( (strstr(t_key,"SP_HORMONBOOSTED")!=NULL) ||
		   (strstr(t_key,"SG_HORMONBOOSTED")!=NULL) )
		{
		  j=0;
		  b_done=1;
		  for(i=1; i<games[cg]->nof_players; i++)
		    if (games[cg]->player[i]->lst_items[24] >
			games[cg]->player[j]->lst_items[24])
		      j=i;
		  if (j==cp && games[cg]->player[j]->lst_items[24] > 0) b_true=1;
		}
	      if ( (strstr(t_key,"SP_CTFSCORE")!=NULL) ||
		   (strstr(t_key,"SG_CTFSCORE")!=NULL) )
		{
		  j=0;
		  b_done=1;
		  for(i=1; i<games[cg]->nof_players; i++)
		    if (games[cg]->player[i]->score >
			games[cg]->player[j]->score)
		      j=i;
		  if (j==cp && games[cp]->player[j]->score>0) b_true=1;
		}
	    }
	} 
      if (cp>=0)
	{
	  if ( (strstr(t_key,"AP_FRAGMASTER")!=NULL) ||
	       (strstr(t_key,"AG_FRAGMASTER")!=NULL) )
	    {
	      j=0;
	      b_done=1;
	      for(i=1; i<lts->nof_players; i++)
		if (lts->ltplayers[j]->nof_frags<lts->ltplayers[i]->nof_frags)
		  j=i;
	      if (j==cp) b_true=1;
	    }
	  if ( (strstr(t_key,"AP_KILLMASTER")!=NULL) ||
	       (strstr(t_key,"AG_KILLMASTER")!=NULL) )
	    {
	      j=0;
	      b_done=1;
	      for(i=1; i<lts->nof_players; i++)
		if (lts->ltplayers[j]->nof_kills<lts->ltplayers[i]->nof_kills)
		  j=i;
	      if (j==cp) b_true=1;
	    }

	  if ( (strstr(t_key,"AP_EASYPREY")!=NULL) ||
	       (strstr(t_key,"AG_EASYPREY")!=NULL) )
	    {
	      j=0;
	      b_done=1;
	      for(i=1; i<lts->nof_players; i++)
		if (lts->ltplayers[j]->nof_deaths <
		    lts->ltplayers[i]->nof_deaths)
		  j=i;
	      if (j==cp) b_true=1;
	    }
	  if ( (strstr(t_key,"AP_LONGTIME")!=NULL) ||
	       (strstr(t_key,"AG_LONGTIME")!=NULL) )
	    {
	      j=0;
	      b_done=1;
	      for(i=1; i<lts->nof_players; i++)
		if (lts->ltplayers[j]->secs < lts->ltplayers[i]->secs)
		  j=i;
	      if (j==cp) b_true=1;
	    }
	  if ( (strstr(t_key,"AP_FOOL")!=NULL) ||
	       (strstr(t_key,"AG_FOOL")!=NULL) )
	    {
	      j=0;
	      b_done=1;
	      for(i=1; i<lts->nof_players; i++)
		if (lts->ltplayers[j]->nof_suicides <
		    lts->ltplayers[i]->nof_suicides)
		  j=i;
	      if (j==cp) b_true=1;
	    }
	  if ( (strstr(t_key,"AP_EFFECTIVENESS")!=NULL) ||
	       (strstr(t_key,"AG_EFFECTIVENESS")!=NULL) )
	    {
	      j=0;
	      b_done=1;
	      for(i=1; i<lts->nof_players; i++)
		if (lts->ltplayers[i]->effect >
		    lts->ltplayers[j]->effect)
		  j=i;
	      if (j==cp) b_true=1;
	    }
	  if ( (strstr(t_key,"AP_FASTKILLER")!=NULL) ||
	       (strstr(t_key,"AG_FASTKILLER")!=NULL) )
	    {
	      j=0;
	      b_done=1;
	      for(i=1; i<lts->nof_players; i++)
		if (lts->ltplayers[i]->fph >
		    lts->ltplayers[j]->fph)
		  j=i;
	      if (j==cp) b_true=1;
	    }
	  if ( (strstr(t_key,"AP_ROBUSTNESS")!=NULL) ||
	       (strstr(t_key,"AG_ROBUSTNESS")!=NULL) )
	    {
	      j=0;
	      b_done=1;
	      for(i=1; i<lts->nof_players; i++)
		if (lts->ltplayers[i]->ttl >
		    lts->ltplayers[j]->ttl)
		  j=i;
	      if (j==cp) b_true=1;
	    }
	  if ( (strstr(t_key,"AP_HERCULES")!=NULL) ||
	       (strstr(t_key,"AG_HERCULES")!=NULL) )
		{
		  j=0;
		  b_done=1;
		  for(i=1; i<lts->nof_players; i++)
		    if (lts->ltplayers[i]->nof_items >
			lts->ltplayers[j]->nof_items)
		      j=i;
		  if (j==cp) b_true=1;
		}
	      if ( (strstr(t_key,"AP_HORMONBOOSTED")!=NULL) ||
		   (strstr(t_key,"AG_HORMONBOOSTED")!=NULL) )
		{
		  j=0;
		  b_done=1;
		  for(i=1; i<lts->nof_players; i++)
		    if (lts->ltplayers[i]->items[24] >
			lts->ltplayers[j]->items[24])
		      j=i;
		  if (j==cp) b_true=1;
		}
	      if ( (strstr(t_key,"AP_CTFSCORE")!=NULL) ||
		   (strstr(t_key,"AG_CTFSCORE")!=NULL) )
		{
		  j=0;
		  b_done=1;
		  for(i=1; i<lts->nof_players; i++)
		    if (lts->ltplayers[i]->ctf_score >
			lts->ltplayers[j]->ctf_score)
		      j=i;
		  if (j==cp) b_true=1;
		}
	}

      if (!b_done)
	{fprintf(stderr,"Unknown tag : %s (game:%i, player:%i)\n",\
		 source,cg,cp); return 1;}
      
      if (!b_true)
	{
	  memset(key,0,MAXIFCOND);
	  strcpy(key, t_key);
	  return 0;
	} else {
	  memset(key,0,MAXIFCOND);
	  return 1;
	}
    }
  /* IF - branch already returned 0 or 1, so just ENDIF left */
  if (strcmp(t_key, key)==0)
    {
      memset(key,0,MAXIFCOND);
      return 1;
    }
  return 0;
}





int generate_HTML_TPL(t_game **games, int  nof_games,
		      t_lts   *lts,   hpj_config *cfg)
{
  char   fname[MAXDIRLENGTH], mem[MAXLINELENGTH], s_if[MAXIFCOND];
  char  *t=NULL, *t_t=NULL, *t_p=NULL, b_write, b_hpjw=0, *tmp;
  int    len, sp, dsp, i, sp_act, b_todo, b_done;

  FILE  *fp_i=NULL, *fp_o=NULL;
  char **todo, **todo_t, **todo_p, **done;

  todo=(char **)malloc(sizeof(char *)*MAXHTML);
  memset(todo,0,sizeof(char *)*MAXHTML);
  todo_t=(char **)malloc(sizeof(char *)*MAXHTML);
  memset(todo_t,0,sizeof(char *)*MAXHTML);
  todo_p=(char **)malloc(sizeof(char *)*MAXHTML);
  memset(todo_p,0,sizeof(char *)*MAXHTML);
  done=(char **)malloc(sizeof(char *)*MAXHTML);
  memset(done,0,sizeof(char *)*MAXHTML);

  sprintf(fname, "%s/colors.txt", cfg->templdir);
  palimage=image_new();
  image_loadPal(palimage, fname);

  mapname=parray_new(4);
  mapimg=parray_new(4);
  sprintf(fname, "%s/pix/maps", cfg->outdir);
  parse_dir(fname, "jpg", mapname, mapimg);

  images=parray_new(4);

  dsp=0;
  sp=1;
  b_write=1;
  s_if[0]=0;
  todo[0]=strdup("index.html");  
  todo_t[0]=strdup("index.html");  
  todo_p[0]=NULL;
  done[0]=NULL;
  while(sp>0)
    {
      /* expand stack, if subroutines added something,
	 take current file from stack, reduce SP */
      while(todo[sp]!=NULL)
	sp++;

      /* If this file was already written we do not do the job twice. */
      b_done=1;
      while(b_done)
	{
	  b_done=0;
	  sp--;
	  sp_act=sp;
	  if (sp_act<0) break;

	  for(i=0; i<dsp; i++)
	    if (strcmp(done[i], todo_t[sp])==0) {b_done=1;break;}

	  //fprintf(stderr,"done : %s -> %s\n", todo[sp], done[0]);

	  if (b_done)
	    {
	      //fprintf(stderr,"done : %s -> %s\n", todo_t[sp], done[i]);
	      free(todo[sp]); todo[sp]=NULL;
	      free(todo_t[sp]); todo_t[sp]=NULL;
	      free(todo_p[sp]); todo_p[sp]=NULL;
	    }
	}
      if (sp_act<0) break;
      b_todo=0;

      tmp=strdup(todo_t[sp_act]);
      done[dsp]=tmp;
      t=todo[sp_act];
      todo[sp_act]=NULL;
      t_t=todo_t[sp_act];
      todo_t[sp_act]=NULL;
      t_p=todo_p[sp_act];
      todo_p[sp_act]=NULL;
      b_todo=1;
      dsp++;
      if (dsp>=MAXHTML)
	{
	  fprintf(stderr, "MAXHTML exceeded, to many written files\n");
	  dsp--;
	}

      if (t==NULL || sp<0) break;

#ifdef GNU_C
      sprintf(fname, "%s/%s", cfg->templdir, t);
#else
      sprintf(fname, "%s\\%s", cfg->templdir, t);
#endif
      fp_i=fopen(fname, "rb");
      if (fp_i==NULL)
	{
	  fprintf(stderr, "ERROR opening template-file \"%s\" -> %s, %s\n",\
		  fname, t, t_p);
	  return -1;
	}
#ifdef GNU_C
      sprintf(fname, "%s/%s", cfg->outdir, t_t);
#else
      sprintf(fname, "%s\\%s", dir, t_t);
#endif
      fp_o=fopen(fname, "wb");
      if (fp_o==NULL)
	{
	  fprintf(stderr, "ERROR opening file \"%s\" -> %s, %s\n",\
		  fname, t, t_p);
	  return -1;
	}

      //fprintf(stderr, "\n  writing \"%s\" -> \"%s\"\n", t, t_t);
      while (!feof(fp_i))
	{
	  len=read_to_next_tag(fp_i, mem, MAXLINELENGTH);
	  if (len && b_write)
	    fwrite(mem,1,len,fp_o);
	  if (len<MAXLINELENGTH && !feof(fp_i))
	    {
	      len=read_tag(fp_i, mem, MAXLINELENGTH);
	      if (strstr(mem, "</body>")!=NULL || strstr(mem,"</BODY>")!=NULL)
		{write_HPJ(fp_o); b_hpjw=1;}
	      if (b_write)
		{
		  if (strstr(mem, "<Q3L_IF")!=NULL)
		    b_write=check_if(mem, s_if, lts, games, nof_games, t_p);
		  else
		    {
		      if (strstr(mem, "<Q3L_")!=NULL)
			{
			  //fprintf(stderr, "\n  found a q3-tag : %s\n", mem);
			  write_q3tag(fp_o, mem, cfg->calculation,\
				      games, nof_games, t, t_p,
				      todo,todo_t,todo_p,
				      &sp,lts,cfg);
			} else {
			  fwrite(mem,1,len,fp_o);
			}
		    }
		} else {
		  if ((strstr(mem, "<Q3L_ENDIF")!=NULL))
		      //|| (strstr(mem,"<Q3L_IF")!=NULL))
		    b_write=check_if(mem, s_if, lts, games, nof_games, t_p);
		}
	    } 
	}

      if (t_p) free(t_p);
      t_p=NULL;
      if (t_t) free(t_t);
      t_t=NULL;
      if (t) free(t);
      t=NULL;

      if (!b_hpjw)
	write_HPJ(fp_o);
      fclose(fp_i);
      fclose(fp_o);
    }

  if (todo)   free(todo);
  if (todo_t) free(todo_t);
  if (todo_p) free(todo_p);
  palimage=image_del(palimage);

  for (i=0; i<parray_elements(images); i++)
    image_del(parray_get(images,i));
  parray_del(images);

  for (i=0; i<parray_elements(mapimg); i++)
    string_del(parray_get(mapimg,i));
  parray_del(mapimg);
  for (i=0; i<parray_elements(mapname); i++)
    string_del(parray_get(mapname,i));
  parray_del(mapname);

  for (i=0; i<MAXHTML; i++)
    if (done[i]!=NULL)
      free(done[i]);
  free(done);
  return 1;
}
