/*
  The functions within this file can be used for writing the
  statistics to a HTML-file.
  There is no formating used within the functions !!

  $Id: html_writers.c,v 2.7 2000/03/02 09:03:35 jacobs Exp jacobs $

  $Log: html_writers.c,v $
  Revision 2.7  2000/03/02 09:03:35  jacobs
  Chat-Viewer builtin

  Revision 2.6  2000/02/14 11:02:13  jacobs
  *** empty log message ***

  Revision 2.5  2000/02/06 20:18:43  jacobs
  *** empty log message ***

  Revision 2.4  2000/01/29 21:41:12  jacobs
  *** empty log message ***

  Revision 2.3  2000/01/25 22:53:37  jacobs
  *** empty log message ***

  Revision 2.2  2000/01/22 22:32:47  jacobs
  *** empty log message ***

  Revision 2.1  2000/01/18 22:50:53  jacobs
  *** empty log message ***

  Revision 1.7  2000/01/14 21:49:15  jacobs
  *** empty log message ***

  Revision 1.6  2000/01/11 23:25:53  jacobs
  *** empty log message ***

  Revision 1.5  2000/01/09 23:09:44  jacobs
  new option "-r"

  Revision 1.4  2000/01/09 02:32:17  jacobs
  *** empty log message ***

  Revision 1.3  2000/01/07 13:43:42  jacobs
  *** empty log message ***

  Revision 1.2  2000/01/05 03:43:25  jacobs
  *** empty log message ***

  Revision 1.1  2000/01/03 16:04:02  jacobs
  Initial revision


*/

#ifdef GNU_C
 #include <sys/stat.h>
 #include <sys/types.h>
 #include <fcntl.h>
 #include <unistd.h>
#else
 #include <direct.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "html_writers.h"
#include "tool.h"
#include "lt_stats.h"
#include "png_io.h"
#include "tools/hpj_string.h"



#ifndef MAXDIRLENGTH
#define MAXDIRLENGTH  2048
#define MAXNAMELENGTH 2048
#endif



char html_apth[NOF_FORMATS][30]={
  "Name", "Time", "G", "GW", "K", "S", "TK", "D", "F", "FPH",\
  "Eff", "TTL", "Item", "Talk", "SOS",\
  "CTF", "FSteal", "FPick", "FLoss", "FSuic", "Fautoret", "FCapt", "FKill", "FRet", "CGames", "CGwon"};




/*
 *
 *
 write simple infos
 *
 *
 */
/* a nice message, so all know who did this piece of .... and who to blame*/
void write_HPJ(FILE *fp)
{
  fprintf(fp, "\n\n\n<br><br><br>\n");
  fprintf(fp, "<small><small><center>Q3_LogGen (%s), <a href=\"mailto:hanspete@cs.tu-berlin.de\">Hans-Peter Jacobs</a>, <a href=\"http://www.cs.tu-berlin.de/~hanspete/Quake3/index.html\">WWW</a></center></small></small><br>\n", Q3L_MAIN_VERSION);
}

void write_date(FILE *fp)
{
  struct tm *s_tm;
  time_t     s_time;

  s_time=time(NULL);
  s_tm=localtime(&s_time);
  fprintf(fp, "%02i.%02i.%s%02i", s_tm->tm_mday,
	  s_tm->tm_mon+1, (s_tm->tm_year>99)?"20":"19", s_tm->tm_year%100);
  //if (s_tm!=NULL) free(s_tm);
}

void write_time(FILE *fp)
{
  struct tm *s_tm;
  time_t     s_time;
  s_time=time(&s_time);
  s_tm=localtime(&s_time);
  fprintf(fp, "%02i:%02i:%02i", s_tm->tm_hour, s_tm->tm_min, s_tm->tm_sec);
  //if (s_tm!=NULL) free(s_tm);
}

void write_counter_gfx(FILE *fp, int frags, char *pre, char *post)
{
  int i, j, k, t, a;

  /* we display them with a image-counter */
  i=frags;
  for (j=8; j>=0; j--)
    {

      /* NOW THE ULTIMATE POW-FUNCTION...
	 I have to do this, because the WINDOWS-POW is messed up !!!*/
      t=1;
      for(a=0; a<j;a++)
	t*=10;

      k=i/t;
      if ( ((k<10) && (t<=frags)) || (frags==0 && j==0)) 
	{
	  fprintf(fp, "<img src=\"pix/%s%i.%s\">",(pre==NULL)?(""):(pre),k,\
		  (post==NULL)?("jpg"):(post));
	  i-=k*t;
	}
    }
}

void write_counter(FILE *fp, int frags)
{
  fprintf(fp, "%i", frags);
}














/*
 *
 *
 *
 *
 *
 *
 FUNCTIONS for a single game
 *
 *
 */
void write_sg_table(FILE *fp, t_game **games, int nof_games,
		    char   **todo, char **todo_t, char **todo_p, int *sp,
		    int cols, int gt, int plimit)
{
  char *fname;
  int   i, c, w=1;

  fname=(char *)malloc(MAXDIRLENGTH);
  c=cols;
  if (cols<0) cols=3;
  if (cols>0) w=100/cols;
  for (i=0; i<nof_games; i++)
    {
      if (games[i]->nof_players < plimit)
	continue;

      //fprintf(stderr, "%02i ", i);
      sprintf(fname, "game_%03i.html", i);
      if (cols>0) fprintf(fp,"<td width=%i%%>", w);
      fprintf(fp, "<a href=\"%s\">Game %i</a> on %s",
	      fname, i, games[i]->mapname);

      if (gt) fprintf(fp, " (%s)", c_gamemodes_s[(int)games[i]->type]);
      if (cols>0) fprintf(fp,"</td>");
      else fprintf(fp,"<br>");
      fprintf(fp, "\n");

      //fprintf(stderr,"  added %s\n", fname);
      todo  [*sp]=strdup("sg_game.html");
      todo_t[*sp]=strdup(fname);
      sprintf(fname, "GAMEID=%04i", i);
      todo_p[*sp]=strdup(fname);
      sp[0]++;
      
      //write_sg_html(fname, games[i], i);
      c--;
      if (c<1) {
	c=cols;
	if (cols>0) fprintf(fp, "</tr>\n<tr>\n");
      }
    }
  if (cols>0) fprintf(fp, "</tr>\n");
  free(fname);
}



/* writes the initial table with a overview of the game*/
void write_sg_stats(FILE *fp, t_game *game, char *hc)
{
  if (hc!=NULL)
    fprintf(fp, "<tr><td bgcolor=\"%s\" width=25%%>", hc);
  else
    fprintf(fp, "<tr><td width=25%%>");
  fprintf(fp, "Game-Name</td><td width=25%%>%s</td>\n", (game->fs_game)?
	  game->fs_game : game->gamename);
  if (hc!=NULL)
    fprintf(fp, "<td bgcolor=\"%s\" width=25%%>", hc);
  else
    fprintf(fp, "<td width=25%%>");
  fprintf(fp, "Map-Name</td><td>%s</td></tr>\n",\
	  mapname_generate(game->mapname));

  if (hc!=NULL)
    fprintf(fp, "<tr><td bgcolor=\"%s\">", hc);
  else
    fprintf(fp, "<tr><td>");
  if (game->type<GAMETYPE_MAX)
    fprintf(fp, "Game-Type</td><td>%s</td>\n", c_gamemodes[(int)game->type]);
  else
    fprintf(fp, "Game-Type</td><td>%s</td>\n", c_gamemodes[GAMETYPE_MAX]);
  if (hc!=NULL)
    fprintf(fp, "<td bgcolor=\"%s\">", hc);
  else
    fprintf(fp, "<td>");
  fprintf(fp, "Duration</td><td>%li min %li sec</td></tr>\n",
	  game->secs/60, game->secs%60);

  if (hc!=NULL)
    fprintf(fp, "<tr><td bgcolor=\"%s\">", hc);
  else
    fprintf(fp, "<tr><td>");
  fprintf(fp, "Time-Limit</td><td>%li</td>\n", game->timelimit);
  if (hc!=NULL)
    fprintf(fp, "<td bgcolor=\"%s\">", hc);
  else
    fprintf(fp, "<td>");
  fprintf(fp, "Frag-Limit</td><td>%li</td></tr>\n", game->fraglimit);

  if (game->type==GAMETYPE_CTF)
    {
      if (hc!=NULL)
	fprintf(fp, "<tr><td bgcolor=\"%s\">", hc);
      else
	fprintf(fp, "<tr><td>");
      fprintf(fp, "Capture-Limit</td><td>%li</td></tr>\n",
	      game->capturelimit);
    }

  if (hc!=NULL)
    fprintf(fp, "<tr><td bgcolor=\"%s\">", hc);
  else
    fprintf(fp, "<tr><td>");
  fprintf(fp, "End of game</td><td>");
  switch(game->exit_state){
  case EXIT_FRAG:
    fprintf(fp, "fraglimit hit");
    break;
  case EXIT_CAPTURE:
    fprintf(fp, "capturelimit hit");
    break;
  case EXIT_TIME:
    fprintf(fp, "timelimit hit");
    break;
  case EXIT_WARMUP:
    fprintf(fp, "warmup");
    break;
  default:
    fprintf(fp, "game was aborted");
  }
  fprintf(fp, "</td></tr>\n");
}



/* writes the stats for all players in the game*/
void write_sg_stats_all(FILE *fp, t_game *game, char *hc, char b_sgtalks,
			char **todo, char **todo_t, char **todo_p, int *sp)
{
  double fph;
  char   fname[MAXDIRLENGTH];

  fph=(3600.0/game->secs) * (double)game->nof_frags;
  if (hc!=NULL) fprintf(fp, "<tr bgcolor=%s>", hc);
  else fprintf(fp, "<tr>");

  fprintf(fp, "<th>Players</th><th>Kills</th>");
  if (game->type==GAMETYPE_CTF || game->type==GAMETYPE_TDM)
    fprintf(fp, "<th>TKills</th>");
  fprintf(fp, "<th>Suicides</th><th>Frags</th><th>FPH</th>");
  fprintf(fp, "<th>Pickups</th>");
  if (b_sgtalks)
    {
      sprintf(fname, "%02li_chat.html", game->gid);
      todo  [*sp]=strdup("sg_chat.html");
      todo_t[*sp]=strdup(fname);
      fprintf(fp, "<th><a href=\"%s\">Talks</a></th>\n</tr><tr>\n", fname);

      memset(fname, 0, MAXDIRLENGTH);
      sprintf(fname, "<GAMEID=%04li>", game->gid);
      todo_p[*sp]=strdup(fname);
      *sp=sp[0]+1;
    }
  else
    fprintf(fp, "<th>Talks</th>\n</tr><tr>\n");

  fprintf(fp, "<td align=center>%li</td>", game->nof_players);
  fprintf(fp, "<td align=center>%li</td>", game->nof_kills);
  if (game->type==GAMETYPE_CTF || game->type==GAMETYPE_TDM)
    fprintf(fp,"<td align=center>%li</td>", game->nof_tkills);
  fprintf(fp, "<td align=center>%li</td>", game->nof_suicides);
  fprintf(fp, "<td align=center>%li</td>", game->nof_frags);
  fprintf(fp, "<td align=center>%2.2f</td>", fph);
  fprintf(fp, "<td align=center>%li</td>", game->nof_items);
  fprintf(fp, "<td align=center>%li</td>\n", game->nof_says);
  fprintf(fp, "</tr>\n");
}


/* Writes a table full with chat-messages */
void write_sg_chattable(FILE *fp, t_game *game, char *rc, char *bc, char *hc, char b_humanonly)
{
  int i, j;

  if (hc)
    fprintf(fp, "<tr bgcolor=%s>", hc);
  else
    fprintf(fp, "<tr>");
  fprintf(fp, "<td align=center>Time</td><td>Name</td><td>Message</td></tr>\n");

  for (i=0; i<iarray_elements(game->chat_team); i++)
    {
      if (b_humanonly && iarray_get(game->chat_skill,i)!=-1)
	continue;
      j=iarray_get(game->chat_team, i);
      if (j==1 && rc!=NULL)
	fprintf(fp, "<tr bgcolor=\"%s\">", rc);
      else if (j==2 && bc!=NULL)
	fprintf(fp, "<tr bgcolor=\"%s\">", bc);
      else fprintf(fp, "<tr>");

      j=iarray_get(game->chat_secs, i);
      fprintf(fp, "<td align=center>%02i:%02i</td>", j/60, j%60);

      fprintf(fp, "<td>%s</td>", make_funname(string_charptr(parray_get(game->chat_name, i)), 1));
      fprintf(fp, "<td>%s</td>", string_charptr(parray_get(game->chat_message, i)));
      fprintf(fp, "</tr>\n");	    
    }
}


/* Writes the winning-team to the file */
void write_sg_teamwinner(FILE *fp, t_game *game)
{
  if (game->team_score[1]>game->team_score[2])
    {
      fprintf(fp, "Red Team wins %li to %li",
	      game->team_score[1], game->team_score[2]);
    } else {
      fprintf(fp, "Blue Team wins %li to %li",
	      game->team_score[2], game->team_score[1]);
    }
}

/* If teamplay is on, the stats for the teams will be displayed*/
void write_sg_teamstats(FILE *fp, t_game *game, char *rc, char *bc, char *hc)
{
  int   i, start, add, ende;
  char *bgc;

  /* Header an win-info*/
  if (game->team_score[1]>game->team_score[2])
    {start=1;add=1; ende=3;}
  else
    {start=2;add=-1; ende=0;}


  if (hc!=NULL) fprintf(fp, "<tr bgcolor=%s>", hc);
  else fprintf(fp, "<tr>");
  fprintf(fp, "<th width=100>Team</th><th>Kills</th><th>Team-Kills</th><th>Suicides</th>");
  if (game->type==GAMETYPE_CTF) fprintf(fp, "<th width=60>Frags</th>");
  fprintf(fp, "<th width=60>Score</th></tr>\n");

  for (i=start; i!=ende; i+=add)
    {
      if (i==2) bgc=bc;
      else bgc=rc;

      if (bgc!=NULL) fprintf(fp, "<tr bgcolor=\"%s\">", bgc);
      else fprintf(fp, "<tr>");
      fprintf(fp, "<td valign=top>%s</td><td align=center valign=top>%li</td><td align=center valign=top>%li</td><td align=center valign=top>%li</td>",
	      team_name[i], game->team_kills[i], game->team_tkills[i],
	      game->team_suic[i]);
      if (game->type==GAMETYPE_CTF)
	fprintf(fp, "<td align=center valign=top>%li</th>",
		game->team_frags[i]);
      fprintf(fp, "<td align=center valign=top>%li</td></tr>\n",
	      game->team_score[i]);
    }
  fprintf(fp,"</tr>\n");
}

/* CTF-results (if CTF played at all)*/
void write_sg_ctfstats(FILE *fp, t_game *game, char *rc, char *bc, char *hc)
{
  int   i, add, start, ende;
  char *bgc;

  /* Table - header */
  if (hc!=NULL) fprintf(fp, "<tr bgcolor=\"%s\">\n", hc);
  else fprintf(fp, "<tr>\n");
  fprintf(fp, "<th>Team</th>");
  fprintf(fp, "<th>Steals</th>");
  fprintf(fp, "<th>Pickups</th>");
  fprintf(fp, "<th>Loss</th>");
  fprintf(fp, "<th>Suicides</th>");
  fprintf(fp, "<th>Captures</th>");
  fprintf(fp, "<th>FlagKills</th>");
  fprintf(fp, "<th>Returns</th>");
  fprintf(fp, "<th>Auto-Return</th>");
  fprintf(fp, "</tr>\n");

  /* Sort for results */
  if (game->team_score[1] > game->team_score[2])
    {add=1;start=1;ende=3;} else {add=-1; start=2;ende=0;}

  for (i=start; i!=ende; i+=add)
    {
      if (i==1) bgc=rc;
      else bgc=bc;

      if (bgc) fprintf(fp, "<tr bgcolor=\"%s\">", bgc);
      else fprintf(fp, "<tr>");
      fprintf(fp, "<td>%s</td>", team_name[i]);
      fprintf(fp, "<td align=center>%li</td>", game->ctf_steals[i]);
      fprintf(fp, "<td align=center>%li</td>", game->ctf_pickups[i]);
      fprintf(fp, "<td align=center>%li</td>", game->ctf_loss[i]);
      fprintf(fp, "<td align=center>%li</td>", game->ctf_suic[i]);
      fprintf(fp, "<td align=center>%li</td>", game->ctf_captures[i]);
      fprintf(fp, "<td align=center>%li</td>", game->ctf_kills[i]);
      fprintf(fp, "<td align=center>%li</td>", game->ctf_returns[i]);
      fprintf(fp, "<td align=center>%li</td></tr>\n", game->ctf_autoret[i]);
    }
}

/* Detailed CTF-stats */
void write_sg_ctfdetails(FILE *fp, t_game *game, char *rc, char *bc, char *hc,
			  char *nc, char b_kick, char b_humanonly)
{
  int         i, j, *sort, color, pcol=0;
  char       *bgc=NULL;
  double      ctfeff;
  t_player   *sip;
  hpj_iarray *ia_frags, *ia_sort;

  if (game->nof_players<1)
    return;

  ia_frags=iarray_new(4);
 
  /* prepare sorting the players */
  for(i=0; i<game->nof_players; i++)
    iarray_append(ia_frags, game->player[i]->score);

  ia_sort=iarray_bubblesortIndex(ia_frags, false);
  sort=iarray_getIntPtr(ia_sort);

  /* Table output start here */
  if (hc!=NULL) fprintf(fp, "<tr bgcolor=\"%s\">", hc);
  else fprintf(fp, "<tr>");
  fprintf(fp, "<th>Name</th>");
  /*
    fprintf(fp, "<th>Handicap</th><th>Ping</th>");
    fprintf(fp, "<th>Time</th>");
  */

  /* check for team-game */
  fprintf(fp, "<th>FSteal</th>\n");
  fprintf(fp, "<th>FPickup</th>\n");
  fprintf(fp, "<th>FLoss</th>\n");
  fprintf(fp, "<th>FSuicide</th>\n");
  fprintf(fp, "<th>FCapture</th>\n");
  fprintf(fp, "<th>FKill</th>\n");
  fprintf(fp, "<th>FReturn</th>\n");
  fprintf(fp, "<th>FAutoRet</th>\n");
  fprintf(fp, "<th>Eff.</th>\n");
  fprintf(fp, "<th>Score</th>\n");
  fprintf(fp, "</tr>\n");

  for (j=0; j<game->nof_players; j++)
    {
      i=sort[j];
      sip=game->player[i];

      /* if tournament check for observers */
      if ((game->type==GAMETYPE_TOU || b_kick) && sip->nof_frags+sip->nof_deaths == 0 )
	continue;

      /* if bot and humanonly, kick it out */
      if (b_humanonly && sip->skill>=0)
	continue;

      pcol++;

      /* Now we set the bgcolor according to the team of the player*/
      if (game->type==GAMETYPE_CTF || game->type==GAMETYPE_TDM)
	{
	  color=2*sip->b_blue;
	  color+=sip->b_red;

	  if (color==1) bgc=rc;
	  if (color==2) bgc=bc;
	  if (color>2) bgc=nc;

	  if (bgc) fprintf(fp, "<tr bgcolor=\"%s\">", bgc);
	  else fprintf(fp, "<tr>");
	}else{
	  if (nc) fprintf(fp, "<tr bgcolor=\"%s\">\n", nc);
	  else fprintf(fp, "<tr>");
	}

      fprintf(fp, "<td align=center>%s</td>",
	      make_funname(sip->name, 1));
      /*
	fprintf(fp, "<td align=center>%i</td>\n", sip->handicap);
	fprintf(fp, "<td align=center>%i</td>\n", sip->ping);
	fprintf(fp, "<td align=center>%i:%02i</td>\n",
	sip->secs/60, sip->secs%60);
      */
      fprintf(fp, "<td align=center>%li</td>\n", sip->ctf_steals);
      fprintf(fp, "<td align=center>%li</td>\n", sip->ctf_pickups);
      fprintf(fp, "<td align=center>%li</td>\n", sip->ctf_loss);
      fprintf(fp, "<td align=center>%li</td>\n", sip->ctf_suic);
      fprintf(fp, "<td align=center>%li</td>\n", sip->ctf_captures);
      fprintf(fp, "<td align=center>%li</td>\n", sip->ctf_kills);
      fprintf(fp, "<td align=center>%li</td>\n", sip->ctf_returns);
      fprintf(fp, "<td align=center>%li</td>\n", sip->ctf_autoret);
      if (sip->ctf_pickups+sip->ctf_steals)
	{
	  ctfeff = 100.0  * (double)sip->ctf_captures /\
	    (double)(sip->ctf_pickups+sip->ctf_steals);
	} else ctfeff = 0.0;
      fprintf(fp, "<td align=center>%02.2f</td>\n", ctfeff);
      fprintf(fp, "<td align=center>%i</td>\n", sip->score);
      fprintf(fp, "</tr>\n");
    }
  iarray_del(ia_sort);
  iarray_del(ia_frags);
}










/*
 *
 *
 TIMELINES for 3 different counters
 *
 *
 */
/* draws a direct line from first x,y-coords to the secons x,y coords*/
void draw_line(char *data, int width, int height,
	       int x1, int y1,
	       int x2, int y2, unsigned char color)
{
  double sy, rx, ry, xstep;
  int mempos, xpos, ypos;

  if (x1==x2)
    {
      if (y1==y2) return;
      if (y1>y2) sy=-1;
      else sy=1;
      for(ry=y1; ry!=y2; ry+=sy)
	{
	  xpos=x1;
	  ypos=ry;
	  mempos=(height-1-ypos) * width +xpos;
	  if (mempos>=0 && mempos<height*width)
	    {
	      data[mempos]=color;
	    }
	  else
	    {
	      fprintf(stderr,"_png_bound_");
	      return;
	    }
	}
    }
  else
    {
      //if (oldy-y == 0) continue;
      sy=(double)(y1-y2)/(double)(x2-x1);
      ry=y1;
      //if (abs(sy)<0.001) continue;
      if (abs(sy)>1.0) xstep=0.3;
      else xstep=1.0;
      for(rx=x1; rx<x2; rx+=xstep)
	{
	  ry-=sy*xstep;
	  xpos=rx;
	  ypos=ry;
	  mempos=(height-1-ypos)*width + xpos;
	  if (mempos>=0 && mempos<height*width)
	    {
	      data[mempos]=color;
	      if (abs(sy)>1.0 && mempos<(height*width-width))
		data[mempos+width]=color;
	    }
	  else
	    {
	      fprintf(stderr,"_png_bound_");
	      return;
	    }
	}
    }
}



/* this draws first the x-level, afterwards it levels the y-values*/
void draw_linesteps(char *data, int width, int height,
	       int x1, int y1,
	       int x2, int y2, unsigned char color)
{
  int mempos, rx, ry, sy;

  if (x1<=x2)
    {
      for (rx=x1; rx<x2; rx++)
	{
	  mempos=(height-1-y1)*width + rx;
	  if (mempos>=0 && mempos<height*width)
	    {
	      data[mempos]=color;
	    } else {
	      fprintf(stderr, "_png_bound_stepped_"); return;
	    }
	}
      if (y1==y2) return;
      if (y1>y2) sy=-1;
      else sy=1;
      for (ry=y1;ry!=y2; ry+=sy)
	{
	  mempos=(height-1-ry)*width + x2;
	  if (mempos>=0 && mempos<height*width)
	    {
	      data[mempos]=color;
	    } else {
	      fprintf(stderr, "_png_bound_stepped_"); return;
	    }
	}
    }
}


/* creates an image with the timeline and writes this to a png*/
void write_timeline(char *filename,
		    hpj_parray *tlx, hpj_parray *tly,
		    int offx, int offy,
		    int deltax, int deltay, hpj_image *img,
		    int zcompression, char steps)
{
  char          *data;
  int            oldx, oldy, maxx, maxy, y0;
  int            i, j, maxf, maxt, minf, temp;
  int            width=img->width, height=img->height;
  double         x,y, dx, dy;
  hpj_iarray    *ix, *iy;

  data=(char *)image_copyData(img);
  if (data==NULL) return;

  /* IF empty(iarray) THEN write a black image */
  if (parray_elements(tlx)==0 || parray_elements(tly)==0)
    {
      write_png(filename, (unsigned char *)data, width, height,
		img->palmem, zcompression);
      free(data);
      return;
    }

  maxf=0;
  maxt=0;
  minf=0;
  maxx=width-deltax;
  maxy=height-deltay;
  y0=0;
  for (i=0; i<parray_elements(tly); i++)
    {
      iy=V2IARRAYP(parray_get(tly,i));
      temp=iarray_getMax(iy);
      if (temp>maxf)
	maxf=temp;
      temp=iarray_getMin(iy);
      if (temp<minf)
	minf=temp;
    }
  for (i=0; i<parray_elements(tlx); i++)
    {
      ix=V2IARRAYP(parray_get(tlx,i));
      temp=iarray_getMax(ix);
      if (temp>maxt)
	maxt=temp;
    }

  //fprintf(stderr, "\n%i <-> %i\n", minf, maxf);
  //dx=((double)(maxx-offx))/(double)(iarray_getMax(ix)+1);
  dx=((double)(maxx-offx))/(double)(maxt+1);
  dy=(double)(maxy-offy) / (double)((maxf-minf)+1);
  y0=(int)(dy*(-minf) + 1);
  //fprintf(stderr, "Offset : %i\n", (int)offy);

  draw_linesteps(data,width,height,offx,offy+y0,maxx,offy+y0,8);

  for (i=0; i<parray_elements(tlx); i++)
    {
      iy=V2IARRAYP(parray_get(tly,i));
      ix=V2IARRAYP(parray_get(tlx,i));
      //if (iarray_elements(ix)<1) continue;
      oldx=offx+1;
      oldy=offy+y0;
      for(j=1; j<iarray_elements(ix); j++)
	{
	  y=dy * iarray_get(iy, j) + offy +y0;
	  x=dx * iarray_get(ix, j) + offx;
	  if (steps>0) draw_linesteps(data, width, height, oldx,oldy,x,y, i+1);
	  else draw_line(data, width, height, oldx,oldy,x,y, i+1);
	  oldx=x;
	  oldy=y;
	}
    }

  write_png(filename, (unsigned char *)data, width, height,
	    img->palmem, zcompression);
  free(data);
}



/* creates an image with the timeline and writes this to a png*/
void write_sg_ctftimeline(FILE *fp, t_game *game,\
			   int offx, int offy,\
			   int deltax, int deltay,
			   char *outdir, hpj_image *img,
			  int zcompression, char steps)
{
  char           fname[MAXDIRLENGTH];
  hpj_parray    *p1=parray_new(3), *p2=parray_new(3);

  memset(fname,0,MAXDIRLENGTH);
  sprintf(fname, "%02li_ctftimeline.png", game->gid);
  fprintf(fp, "<img src=\"%s\">", fname);
  sprintf(fname, "%s/%02li_ctftimeline.png", outdir, game->gid);

  parray_append(p1, game->tl_ctf[1]);
  parray_append(p1, game->tl_ctf[2]);

  parray_append(p2, game->tl_ctfsec[1]);
  parray_append(p2, game->tl_ctfsec[2]);
  write_timeline(fname, p2, p1, offx, offy, deltax, deltay,
		 img, zcompression, steps);
  parray_del(p1);
  parray_del(p2);
  //fprintf(stderr, "c%02i ", game->gid);
  return ;
}

/* creates an image with the timeline and writes this to a png*/
void write_sg_teamtimeline(FILE *fp, t_game *game,\
			   int   offx, int offy,\
			   int   deltax, int deltay,
			   char *outdir, hpj_image *img,
			   int   zcompression, char steps)
{
  char           fname[MAXDIRLENGTH];
  hpj_parray    *p1=parray_new(4), *p2=parray_new(4);

  memset(fname,0,MAXDIRLENGTH);
  sprintf(fname, "%02li_teamtimeline.png", game->gid);
  fprintf(fp, "<img src=\"%s\">", fname);
  sprintf(fname, "%s/%02li_teamtimeline.png", outdir, game->gid);

  parray_append(p1, game->tl_team[1]);
  parray_append(p1, game->tl_team[2]);

  parray_append(p2, game->tl_teamsec[1]);
  parray_append(p2, game->tl_teamsec[2]);
  write_timeline(fname, p2, p1, offx, offy, deltax, deltay,
		 img, zcompression, steps);
  parray_del(p1);
  parray_del(p2);
  //fprintf(stderr, "t%02i ", game->gid);
  return ;
}

/* creates an image with the timeline and writes this to a png*/
void write_sg_fragtimeline(FILE *fp, t_game *game,\
			   int   offx, int offy,\
			   int   deltax, int deltay,
			   char *outdir, hpj_image *img,
			   int   zcompression, char steps,
			   int   humanonly, char b_kick)
{
  char           fname[MAXDIRLENGTH];
  int            i, *sort;
  hpj_parray    *p1, *p2;
  t_player      *p;
  hpj_iarray    *ia_frags, *ia_sort;
  
  if (game->nof_players<1)
    return;

  p1=parray_new(4);
  p2=parray_new(4);
  ia_frags=iarray_new(4);
  memset(fname,0,MAXDIRLENGTH);
  sprintf(fname, "%02li_fragtimeline.png", game->gid);
  fprintf(fp, "<img src=\"%s\">", fname);
  sprintf(fname, "%s/%02li_fragtimeline.png", outdir, game->gid);


  for(i=0; i<game->nof_players; i++)
    iarray_append(ia_frags, game->player[i]->nof_frags);

  ia_sort=iarray_bubblesortIndex(ia_frags, false);
  sort=iarray_getIntPtr(ia_sort);

  for (i=0; i<game->nof_players; i++)
    {
      if (humanonly && game->player[sort[i]]->skill>=0)
	continue;
      p=game->player[sort[i]];
      if ( (game->type!=GAMETYPE_TOU && !b_kick) || p->nof_kills+p->nof_deaths > 0 )
	{
	  parray_append(p1, p->tl_frags);
	  parray_append(p2, p->tl_fragsec);
	}
    }
  write_timeline(fname, p2, p1, offx, offy, deltax, deltay,
		 img, zcompression, steps);
  parray_del(p1);
  parray_del(p2);
  iarray_del(ia_sort);
  iarray_del(ia_frags);
  //fprintf(stderr, "f%02i ", game->gid);
  return ;
}





/* Writes the ranks, depending on the number of frags*/
void write_sg_ranks(FILE *fp, t_game *game,
		    char **todo, char **todo_t, char **todo_p, int *sp,
		    char *rc, char *bc, char *nc, char *hc,
		    hpj_image *img, int humanonly, hpj_config *cfg)
{
  int     i, j, *sort, color, pcol=0;
  char   *fname;
  char   *bgc=NULL;
  t_player *sip;
  hpj_iarray *ia_frags, *ia_sort;

  if (game->nof_players<1)
    return;

  ia_frags=iarray_new(4);
  fname=(char *)malloc(MAXDIRLENGTH);

  /* prepare sorting the players */
  for(i=0; i<game->nof_players; i++)
    iarray_append(ia_frags, game->player[i]->nof_frags);

  ia_sort=iarray_bubblesortIndex(ia_frags, false);
  sort=iarray_getIntPtr(ia_sort);

  /* Table output start here */
  if (hc!=NULL) fprintf(fp, "<tr bgcolor=\"%s\">", hc);
  else fprintf(fp, "<tr>");
  fprintf(fp, "<th>Name</th><th>Handic.</th><th>Ping</th>");
  fprintf(fp, "<th>Time</th><th>Kills</th>");


  if (game->type==GAMETYPE_CTF || game->type==GAMETYPE_TDM)
    fprintf(fp, "<th>TKills</th>");
  fprintf(fp, "<th>Deaths</th><th>Suic.</th><th>Items</th>");
  fprintf(fp, "<th>TTL</th>");
  fprintf(fp, "<th>Frags</th>");
  fprintf(fp, "<th>FPH</th>");
  fprintf(fp, "<th>Eff.</th>");
  fprintf(fp, "</tr>\n");

  for (j=0; j<game->nof_players; j++)
    {
      i=sort[j];
      sip=game->player[i];

      /* if tournament check for observers */
      if ((game->type==GAMETYPE_TOU || cfg->b_kick) && sip->nof_frags+sip->nof_deaths == 0 )
	continue;

      /* if bot and humanonly, kick it out */
      if ((humanonly && sip->skill>=0) ||
	  (sip->secs < cfg->time_minimum))
	continue;

      pcol++;
      sprintf(fname, "%02li_%02i.html", game->gid, j);

      /* Now we set the bgcolor according to the team of the player*/
      if (game->type==GAMETYPE_CTF || game->type==GAMETYPE_TDM)
	{
	  color=2*sip->b_blue;
	  color+=sip->b_red;

	  if (color==1) bgc=rc;
	  if (color==2) bgc=bc;
	  if (color>2) bgc=nc;

	  if (bgc) fprintf(fp, "<tr bgcolor=\"%s\">", bgc);
	  else fprintf(fp, "<tr>");
	}else{
	  if (nc) fprintf(fp, "<tr bgcolor=\"%s\">\n", nc);
	  else fprintf(fp, "<tr>");
	}

      fprintf(fp, "<td align=center>");
      if (cfg->b_sgpdetails) fprintf(fp, "<a href=\"%s\">", fname);
      if (img) fprintf(fp, "<font color=\"#%s\">",\
		       image_palRefToRRGGBB(img,pcol));//j+1
      fprintf(fp, "%s",make_funname(sip->name, 1));
      if (img) fprintf(fp, "</font>");
      if (!cfg->b_sgpdetails) fprintf(fp, "</a></td>\n");
      fprintf(fp, "<td align=center>%i</td>\n", sip->handicap);
      fprintf(fp, "<td align=center>%i</td>\n", sip->ping);
      fprintf(fp, "<td align=center>%i:%02i</td>\n",
	      sip->secs/60, sip->secs%60);
      fprintf(fp, "<td align=center>%i</td>\n", sip->nof_kills);
      if (game->type==GAMETYPE_CTF || game->type==GAMETYPE_TDM)
	fprintf(fp, "<td align=center>%i</td>\n", sip->nof_tkills);
      fprintf(fp, "<td align=center>%i</td>\n", sip->nof_deaths);
      fprintf(fp, "<td align=center>%i</td>", sip->nof_suicides);
      fprintf(fp, "<td align=center>%i</td>", sip->nof_items);
      fprintf(fp, "<td align=center>%2.2f</td>\n", sip->ttl);
      fprintf(fp, "<td align=center>%i</td>\n", sip->nof_frags);
      fprintf(fp, "<td align=center>%2.2f</td>\n", sip->fph);
      fprintf(fp, "<td align=center>%2.2f</td>\n", sip->effect);

      fprintf(fp, "</tr>\n");

      //fprintf(stderr, "adding (%i)  player %s  with ", *sp, fname);
      if (cfg->b_sgpdetails)
	{
	  todo  [*sp]=strdup("sp_player.html");
	  todo_t[*sp]=strdup(fname);
	  memset(fname, 0, MAXDIRLENGTH);
	  sprintf(fname, "<GAMEID=%04li PLAYERID=%03i>", game->gid, i);
	  todo_p[*sp]=strdup(fname);
	  *sp=sp[0]+1;
	}
    }
  fprintf(stderr, " %02li", game->gid);
  iarray_del(ia_sort);
  iarray_del(ia_frags);
  free(fname);
}



/* Kill-table for direct compares with the opponents
   If playing team-games the team-color will be used as the background.*/
void write_sg_killtab(FILE *fp, t_game *game, char *rc, char *bc,\
		      char *nc, char *sc, char b_kick, int time_minimum)
{
  int         i, j, color, w, *sort;
  char       *bgc;
  t_player   *player;
  hpj_iarray *ia_frags, *ia_sort;

  if (game->nof_players<1)
    return;

  ia_frags=iarray_new(4);
  for(i=0; i<game->nof_players; i++)
    iarray_append(ia_frags, game->player[i]->nof_frags);

  ia_sort=iarray_bubblesortIndex(ia_frags, false);
  sort=iarray_getIntPtr(ia_sort);

  fprintf(fp, "<td> </td>\n");
  w=100/(game->nof_players+1);
  for (i=0; i<game->nof_players; i++)
    {
      player=game->player[sort[i]];
      if ( ( (game->type==GAMETYPE_TOU || b_kick)
	     && (player->nof_frags+player->nof_deaths==0) )
	   || (player->secs < time_minimum) )
	continue;
      
      color=2*player->b_blue;
      color+=player->b_red;
      if (color==1)
	bgc=rc;
      else if (color==2)
	bgc=bc;
      else bgc=nc;
      fprintf(fp, "<td valign=bottom align=center width=%i%%", w);
      if (bgc)
	fprintf(fp, " bgcolor=\"%s\">\n", bgc);
      else fprintf(fp, ">\n");

      fprintf(fp, "<small><small>");
      fprintf(fp,"%s", make_funname(player->name, 0));
      fprintf(fp, "</small></small></td>\n");
    }
  for (i=0; i<game->nof_players; i++)
    {
      player=game->player[sort[i]];
      if ( ( (game->type==GAMETYPE_TOU || b_kick)
	     && (player->nof_frags + player->nof_deaths==0) )
	   || (player->secs < time_minimum) )
	continue;

      color=2*player->b_blue;
      color+=player->b_red;
      if (color==1)
	bgc=rc;
      else if (color==2)
	bgc=bc;
      else bgc=nc;
      fprintf(fp, "</tr><tr><td align=right height=30");
      if (bgc)
	fprintf(fp, " bgcolor=\"%s\">\n", bgc);
      else fprintf(fp, ">\n");

      fprintf(fp, "<small>%s</small></td>",\
	      make_funname(player->name,1));
      for (j=0; j<game->nof_players; j++)
	{
	  if ( ( (game->type==GAMETYPE_TOU || b_kick)
		 && (game->player[sort[j]]->nof_frags +
		     game->player[sort[j]]->nof_deaths==0) )
	       || (game->player[sort[j]]->secs < time_minimum) )
	    continue;

	  if (i==j)
	    fprintf(fp, "<td align=center bgcolor=\"%s\">%li</td>",
		    sc, player->lst_kills[sort[j]]);
	  else
	    fprintf(fp, "<td align=center>%li</td>",
		    player->lst_kills[sort[j]]);
	}
    }
  iarray_del(ia_sort);
  iarray_del(ia_frags);
  fprintf(fp, "</tr>\n");
}

/* writes the pickup-table into the file*/
void write_sg_pickups(FILE *fp, t_game *game, int cols)
{
  int      i,j,c,w=1;
  long int sort[NOF_ITEMS], items[NOF_ITEMS];

  for (i=0; i<NOF_ITEMS; i++)
    {
      items[i]=0;
      for(j=0; j<game->nof_players; j++)
	items[i]+=game->player[j]->lst_items[i];
    }
  
  sort_items(items, sort);
  if (items[sort[0]]<1)
    {
      fprintf(fp, "No pickups during battle");
      return ;
    }
  if (cols<0) cols=3;
  c=cols;
  if (cols) w=100/cols;
  for (i=0; i<NOF_ITEMS; i++)
    {
      if (items[sort[i]]<1) break;
      fprintf(fp, "<td width=%i%%>%s</td><td width=%i%%>%li</td>\n",
	      w-5, c_items_nice[sort[i]], 5, items[sort[i]]);
      c--;
      if (c<1) {
	c=cols;
	fprintf(fp, "</tr><tr>\n");
      }
    }
  fprintf(fp, "</tr>\n");
}


















/*
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *
 FUNCTIONS for SINGLE-GAME_PLAYER
 *
 *
 */
void write_sp_playername(FILE *fp, t_game *game, int pid)
{
  fprintf(fp, "%s", make_funname(game->player[pid]->name,1));
}

void write_sp_killtable(FILE *fp, t_game *game, int pid, char *rc,\
			char *bc, char *nc, char *hc, int showall)
{
  int       i,j,k,sum, color, *sort;
  char     *bgc=NULL;
  t_player *pl;
  hpj_iarray *ia_frags, *ia_sort;

  if (game->nof_players<1)
    return;

  ia_frags=iarray_new(4);
  for(i=0; i<game->nof_players; i++)
    iarray_append(ia_frags, game->player[i]->nof_frags);

  ia_sort=iarray_bubblesortIndex(ia_frags, false);
  sort=iarray_getIntPtr(ia_sort);

  pl=game->player[pid];


  if (hc) fprintf(fp, "<tr bgcolor=\"%s\">", hc);
  else fprintf(fp, "<tr>\n");

  fprintf(fp, "<td> </td>");
  for (i=1; i<14; i++)
    if (showall ||\
	(iarray_occurence(pl->tl_weaps,i)>0 ||\
	 ( (i==4 || i==6 || i==8 || i==12) &&
	   (iarray_occurence(pl->tl_weaps,i+1)>0) ) ) )
	if (i!=5 && i!=7 && i!=9 && i!=13)
	fprintf(fp, "<td align=center>%s</td>", c_weaps[i]);

  fprintf(fp, "</tr><tr>\n");
  for (i=0; i<game->nof_players; i++)
    {
      if (game->type==GAMETYPE_TOU && (game->player[sort[i]]->nof_frags+\
				       game->player[sort[i]]->nof_deaths+\
				       game->player[sort[i]]->nof_items==0))
	continue;

      color=2*game->player[sort[i]]->b_blue;
      color+=game->player[sort[i]]->b_red;
      if (color==1)
	bgc=rc;
      else if (color==2)
	bgc=bc;
      else bgc=nc;
      if (bgc) fprintf(fp, "<tr bgcolor=\"%s\">\n", bgc);
      else fprintf(fp,"<tr>\n");
      if (hc) fprintf(fp, "<td bgcolor=\"%s\" align=right>", hc);
      else fprintf(fp, "<td align=right>");
      fprintf(fp, "%s</td>", make_funname(game->player[sort[i]]->name,1));
      for(j=1; j<14; j++)
	{
	  if (!showall &&\
	      ( (iarray_occurence(pl->tl_weaps,j)<1) ||
		( (j==4 || j==6 || j==8 || j==12) &&
		  (iarray_occurence(pl->tl_weaps,j+1)<1) &&
		  (iarray_occurence(pl->tl_weaps,j)<1)
		  ) ) )
	    continue;

	  sum=0;
	  for(k=0; k<iarray_elements(pl->tl_frags); k++)
	    {
	      if (iarray_get(pl->tl_whom,k)==sort[i])
		{
		  if (iarray_get(pl->tl_weaps,k)==j)
		    sum++;
		  else if ((j==4 || j==6 || j==8 || j==12) 
			    && (iarray_get(pl->tl_weaps,k)==j+1) )
		    sum++;
		}
	    }
	  if (j==4 || j==6 || j==8 || j==12) j++;
	  fprintf(fp, "<td align=center>%i</td>", sum);
	}
      fprintf(fp,"</tr>");
    }
  iarray_del(ia_sort);
  iarray_del(ia_frags);
}









/*
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *
 FUNCTIONS for ALL-GAMES - stuff
 *
 *
 */
void write_ag_pickups(FILE *fp, t_lts *lts, int cols, int a)
{
  int      i,j, k, c, w=1, b_todo;
  long int sort[NOF_ITEMS];

  for(i=0; i<NOF_ITEMS; i++)
    sort[i]=i;
  b_todo=1;
  while(b_todo)
    {
      b_todo=0;
      for (i=1; i<NOF_ITEMS; i++)
	{
	  if (lts->items[sort[i]] > lts->items[sort[i-1]])
	    {
	      k=sort[i];
	      sort[i]=sort[i-1];
	      sort[i-1]=k;
	      b_todo=1;
	    }
	}
    }

  if (cols<0) cols=3;
  c=cols;
  if (cols) w=100/cols;
  /* display the stuff */
  for (i=0; i<NOF_ITEMS; i++)
    {
      j=sort[i];
      if (a==0 && lts->items[j]<1) break;
      fprintf(fp, "<td width=%i%%>%s</td><td width=%i%%>%li</td>\n",
	      w-5, c_items_nice[j], 5, lts->items[j]);
      c--;
      if (c<1) {
	c=cols;
	fprintf(fp, "</tr>\n<tr>");
      }
    }
  fprintf(fp, "</tr>\n");
}


/* results for ALL GAMES in queue */
void write_ag_stats(FILE *fp, t_lts *lts, char *hc)
{
  if (hc) fprintf(fp, "<tr bgcolor=%s>\n", hc);
  else fprintf(fp, "<tr>");
  fprintf(fp, "<th>Time played</th><th>Kills</th><th>Team-Kills</th><th>Suicides</th><th>Frags</th><th>Deaths</th><th>Pickups</th><th>Says</th></tr>\n<tr>");
  fprintf(fp, "  <td align=center>%02li:%02li:%02li</td>\n",
	  lts->secs/3600, (lts->secs%3600)/60, lts->secs%60);
  fprintf(fp, "  <td align=center>%li</td>\n", lts->nof_kills);
  fprintf(fp, "  <td align=center>%li</td>\n", lts->nof_tkills);
  fprintf(fp, "  <td align=center>%li</td>\n", lts->nof_suicides);
  fprintf(fp, "  <td align=center>%li</td>\n", lts->nof_frags);
  fprintf(fp, "  <td align=center>%li</td>\n", lts->nof_deaths);
  fprintf(fp, "  <td align=center>%li</td>\n", lts->nof_items);
  fprintf(fp, "  <td align=center>%li</td>\n", lts->nof_says);
  fprintf(fp, "</tr>\n");
}

void write_ag_ctfstats(FILE *fp, t_lts *lts, char *hc)
{
  if (hc) fprintf(fp, "<tr bgcolor=%s>\n", hc);
  else fprintf(fp, "<tr>");
  fprintf(fp, "<th>CTF-Games</th><th>Steals</th><th>Pickups</th><th>Loss</th>");
  fprintf(fp, "<th>Suicide</th><th>Captures</th><th>Carrier-Kills</th><th>Returns</th>");
  fprintf(fp, "<th>Auto-Ret</th><th>Score</th></tr>\n<tr>");

  fprintf(fp, "  <td align=center>%li</td>\n", lts->nof_ctfgames);
  fprintf(fp, "  <td align=center>%li</td>\n", lts->ctf_steals);
  fprintf(fp, "  <td align=center>%li</td>\n", lts->ctf_pickups);
  fprintf(fp, "  <td align=center>%li</td>\n", lts->ctf_loss);
  fprintf(fp, "  <td align=center>%li</td>\n", lts->ctf_suic);
  fprintf(fp, "  <td align=center>%li</td>\n", lts->ctf_captures);
  fprintf(fp, "  <td align=center>%li</td>\n", lts->ctf_kills);
  fprintf(fp, "  <td align=center>%li</td>\n", lts->ctf_returns);
  fprintf(fp, "  <td align=center>%li</td>\n", lts->ctf_autoret);
  fprintf(fp, "  <td align=center>%li</td>\n", lts->ctf_score);
  fprintf(fp, "</tr>\n");
}






/*
 *
 *
 FUNCTIONS FOR WRITING THE ALL-TIME PLAYER-STATS
 *
 *
 */
/* This is a little bit more complicated because of gfx-writing */
void write_any_weapons_graph(FILE *fp, long int *weaps, char *pixdir,
			     int   compact, int  all,
			     int   cols, int width, int height)
{
  int         i,j,sum, max, x, c, w=1;
  double      fact;
  hpj_iarray *ia=iarray_new(2), *in=iarray_new(2), *is=NULL;

  for (i=0; i<NOF_WEAPS; i++)
    {
      if (compact && (i==5 || i==7 || i==9 || i==13))
	continue;
      
      sum=weaps[i];
      if (compact && (i==4 || i==6 || i==8 || i==12))
	sum+=weaps[i+1];

      if (all!=0 || sum>0)
	{
 	  iarray_append(ia, sum);
	  iarray_append(in, i);
	}
    }
  if (iarray_elements(ia)<1) {
    fprintf(fp, "no weapon used");
    iarray_del(ia);
    iarray_del(in);
    return;
  }
  is=iarray_bubblesortIndex(ia, false);
  
  max=iarray_getMax(ia);
  fact=(double)width/(double)max;
  if (cols<0) cols=3;
  c=cols;
  if (cols) w=100/(cols*2);
  for(i=0; i<iarray_elements(is);i++)
    {
      j=iarray_get(is,i);
      x=(int) iarray_get(ia, j) * fact;
      fprintf(fp, "<td width=%i%% align=right>%s &nbsp; %02i</td>",
	      w, c_weaps[iarray_get(in,j)], iarray_get(ia,j));

      fprintf(fp, "<td align=left width=%i%%>", w);
      fprintf(fp, "<img src=\"pix/%s/line.png\" width=%i height=%i><br></td>",
	      (pixdir)?(pixdir):(""), x, height);
      c--;
      if (c<1) {
	c=cols;
	fprintf(fp, "</tr><tr>\n");
      }
    }
  while(c>0){
    fprintf(fp, "<td></td><td></td>");
    c--;
  }
  if (i%2) fprintf(fp, "</tr>");
  iarray_del(is);
  iarray_del(ia);
  iarray_del(in);
}


/* writes all-time (single) player info */
void write_any_weapons(FILE *fp, long int *weaps, int cols,
		       int all, int compact)
{
  int          i, sum ,j, c, w=1;
  hpj_iarray *ia=iarray_new(2), *in=iarray_new(2), *is=NULL;


  for (i=0; i<NOF_WEAPS; i++)
    {
      if (compact && (i==5 || i==7 || i==9 || i==13))
	continue;
      
      sum=weaps[i];
      if (compact && (i==4 || i==6 || i==8 || i==12))
	sum+=weaps[i+1];

      if (all!=0 || sum>0)
	{
 	  iarray_append(ia, sum);
	  iarray_append(in, i);
	}
    }
  if (iarray_elements(ia)<1) {
    fprintf(fp, "no weapon used");
    iarray_del(ia);
    iarray_del(in);
    return;
  }
  is=iarray_bubblesortIndex(ia, false);

  /* normal weapon-use*/
  if (cols<0) cols=3;
  c=cols;
  if (cols) w=100/cols;
  for (i=0; i<iarray_elements(is); i++)
    {
      j=iarray_get(is, i);
      fprintf(fp, "<td width=%i%%>%s</td><td width=%i%%>%i</td>\n",
	      w-8,c_weaps[iarray_get(in,j)], 8, iarray_get(ia,j));
      c--;
      if (c<1 && i+1<iarray_elements(is)) {
	c=cols;
	fprintf(fp, "</tr><tr>\n");
      }
    }
  /*
    while(c>0){
    fprintf(fp, "<td widht=%i%%></td><td widht=%i%%></td>", w-8, 8);
    c--;
    }*/
  if (c<1) fprintf(fp, "</tr>\n");
  iarray_del(is);
  iarray_del(ia);
  iarray_del(in);
}


/* writes the pickup-table into the file*/
void write_any_items(FILE *fp, long int *items, int cols, int a)
{
  int      i,c,w=1;
  long int sort[NOF_ITEMS];

  sort_items(items, sort);
  if (items[sort[0]]<1)
    {
      fprintf(fp, "No pickups during battle");
      return ;
    }

  if (cols<0) cols=3;
  c=cols;
  if (cols) w=100/cols;
  for (i=0; i<NOF_ITEMS; i++)
    {
      if (a==0 && items[sort[i]]<1) break;
      fprintf(fp, "<td width=%i%%>%s</td><td width=%i%%>%li</td>\n",
	      w-8, c_items_nice[sort[i]], 8, items[sort[i]]);
      c--;
      if (c<1) {
	c=cols;
	fprintf(fp, "</tr><tr>\n");
      }
    }
  fprintf(fp, "</tr>\n");
}












void write_agp_allstats(FILE *fp, t_lts *lts, char *hc, char *sc, char **todo,
			char **todo_t, char **todo_p, int *sp,
			int    sortorder, int humanonly, int tablelines,
			hpj_config *cfg)
{
  int      i, j, t, *sort, nof_players;
  char     fname[MAXNAMELENGTH], b_todo;
  t_ltp   *ltp;
  hpj_iarray *ia_frags, *ia_sort, *tformat;

  if (sortorder==SORT_NAME)
    {
      /* Names we sort manually */
      sort=(int *)malloc(sizeof(int) * lts->nof_players);
      for(i=0; i<lts->nof_players; i++)
	sort[i]=i;
      b_todo=1;
      nof_players=lts->nof_players;
      while(b_todo)
	{
	  b_todo=0;
	  for(i=1;i<lts->nof_players; i++)
	    if (strcmp(lts->ltplayers[sort[i]]->name,
		       lts->ltplayers[sort[i-1]]->name)<0)
	      {
		t        =sort[i];
		sort[i]  =sort[i-1];
		sort[i-1]=t;
		b_todo=1;
	      }
	}
    }
  else
    {
      ia_frags=iarray_new(4);
      for(i=0; i<lts->nof_players; i++)
	{
	  switch(sortorder){
	  case SORT_DEATHS:
	    iarray_append(ia_frags, lts->ltplayers[i]->nof_deaths);
	    break;
	  case SORT_KILLS:
	    iarray_append(ia_frags, lts->ltplayers[i]->nof_kills);
	    break;
	  case SORT_TIME:
	    iarray_append(ia_frags, lts->ltplayers[i]->secs);
	    break;
	  case SORT_SUICIDES:
	    iarray_append(ia_frags, lts->ltplayers[i]->nof_suicides);
	    break;
	  case SORT_EFFICENCY:
	    iarray_append(ia_frags, (int)(lts->ltplayers[i]->effect*100.0));
	    break;
	  case SORT_FPH:
	    iarray_append(ia_frags, (int)(lts->ltplayers[i]->fph*100.0));
	    break;
	  case SORT_TTL:
	    iarray_append(ia_frags, lts->ltplayers[i]->ttl);
	    break;
	  case SORT_FRAGS:
	    iarray_append(ia_frags, lts->ltplayers[i]->nof_frags);
	    break;
	  case SORT_CTFSCORE:
	    iarray_append(ia_frags, lts->ltplayers[i]->ctf_score);
	    break;
	  default:
	    fprintf(stderr, " Unknown sort-mode for all_player_stats\n");
	    iarray_append(ia_frags, lts->ltplayers[i]->nof_frags);
	    break;
	  }  
	}
      ia_sort=iarray_bubblesortIndex(ia_frags, false);
      sort=iarray_cloneIntPtr(ia_sort);
      nof_players=iarray_elements(ia_sort);
      iarray_del(ia_sort);
      iarray_del(ia_frags);
    }


  if (cfg->b_forcemyformat || cfg->templateformat==NULL)
    tformat=cfg->tableformat;
  else
    tformat=cfg->templateformat;
  fprintf(stderr, "s ");
  if (hc) fprintf(fp, "<tr bgcolor=\"%s\">", hc);
  else fprintf(fp, "<tr>");
  for (i=0; i<iarray_elements(tformat); i++)
    {
      t=iarray_get(tformat, i);
      fprintf(fp, "<th>%s</th>", html_apth[t]);
    }
  fprintf(fp, "\n");

  for (i=0; i<nof_players; i++)
    {
      if (tablelines>0 && i>=tablelines)
	break;
      ltp=lts->ltplayers[sort[i]];

      /* We remove useless informations as soon as possible. */
      if (cfg->b_kick && (ltp->nof_kills + ltp->nof_deaths == 0) )
	continue;
      if (ltp->skill>=0 && humanonly)
	continue;
      if ( (ltp->nof_games < cfg->game_minimum) ||
	   (ltp->secs < cfg->time_minimum) ||
	   ((cfg->pause_maximum>-1) && (ltp->nonactive > cfg->pause_maximum)) )
	continue;


      sprintf(fname, "PLAYERID=%03i", sort[i]);
      todo  [*sp]=strdup("ap_player.html");
      todo_p[*sp]=strdup(fname);
      sprintf(fname, "alltime_%i.html", sort[i]);
      todo_t[*sp]=strdup(fname);
      sp[0]++;

      //fprintf(stderr, "writing %s\n", fname);
      fprintf(fp, "\n<tr>");
      for(j=0; j<iarray_elements(tformat); j++)
	{
	  t=iarray_get(tformat, j);

	  switch (t) {
	  case FORMAT_NAME:
	    if (sortorder==SORT_NAME && sc)
	      fprintf(fp, "<td align=right bgcolor=\"%s\">", sc);
	    else
	      fprintf(fp, "<td align=right>");
	    fprintf(fp, "<a href=\"%s\">",fname);
	    fprintf(fp, "%s</a></td>\n", make_funname(ltp->name,1));
	    break;
	  case FORMAT_TIME:
	    if (sortorder==SORT_TIME && sc)
	      fprintf(fp, "<td align=center bgcolor=\"%s\">", sc);
	    else
	      fprintf(fp, "<td align=center>");
	    fprintf(fp, "%li:%02li:%02li</td>", ltp->secs/3600,\
		    (ltp->secs%3600)/60, ltp->secs%60);
	    break;
	  case FORMAT_GAMES:
	    fprintf(fp, "<td align=center>%li</td>", ltp->nof_games);
	    break;
	  case FORMAT_GAMESWON:
	    fprintf(fp, "<td align=center>%li</td>", ltp->nof_wins);
	    break;
	  case FORMAT_KILLS:
	    if (sortorder==SORT_KILLS && sc)
	      fprintf(fp, "<td align=center bgcolor=\"%s\">", sc);
	    else
	      fprintf(fp, "<td align=center>");
	    fprintf(fp, "%li</td>", ltp->nof_kills);
	    break;
	  case FORMAT_SUICIDES:
	    if (sortorder==SORT_SUICIDES && sc)
	      fprintf(fp, "<td align=center bgcolor=\"%s\">", sc);
	    else
	      fprintf(fp, "<td align=center>");
	    fprintf(fp, "%li</td>", ltp->nof_suicides);
	    break;
	  case FORMAT_TEAMKILLS:
	    fprintf(fp, "<td align=center>%li</td>", ltp->nof_tkills);
	    break;
	  case FORMAT_DEATHS:
	    if (sortorder==SORT_DEATHS && sc)
	      fprintf(fp, "<td align=center bgcolor=\"%s\">", sc);
	    else
	      fprintf(fp, "<td align=center>");
	    fprintf(fp, "%li</td>", ltp->nof_deaths);
	    break;
	  case FORMAT_FRAGS:
	    if (sortorder==SORT_FRAGS && sc)
	      fprintf(fp, "<td align=center bgcolor=\"%s\">", sc);
	    else
	      fprintf(fp, "<td align=center>");
	    fprintf(fp, "%li</td>", ltp->nof_frags);
	    break;
	  case FORMAT_FPH:
	    if (sortorder==SORT_FPH && sc)
	      fprintf(fp, "<td align=center bgcolor=\"%s\">", sc);
	    else
	      fprintf(fp, "<td align=center>");
	    fprintf(fp, "%2.2f</td>", ltp->fph);
	    break;
	  case FORMAT_EFF:
	    if (sortorder==SORT_EFFICENCY && sc)
	      fprintf(fp, "<td align=center bgcolor=\"%s\">", sc);
	    else
	      fprintf(fp, "<td align=center>");
	    fprintf(fp, "%2.2f</td>", ltp->effect);
	    break;
	  case FORMAT_TTL:
	    if (sortorder==SORT_TTL && sc)
	      fprintf(fp, "<td align=center bgcolor=\"%s\">", sc);
	    else
	      fprintf(fp, "<td align=center>");
	    fprintf(fp, "%2.2f</td>", ltp->ttl);
	    break;
	  case FORMAT_ITEMS:
	    fprintf(fp, "<td align=center>%li</td>", ltp->nof_items);
	    break;
	  case FORMAT_TALKS:
	    fprintf(fp, "<td align=center>%li</td>", ltp->nof_says);
	    break;
	  case FORMAT_SOS:
	    fprintf(fp, "<td align=center>%2.0f</td>",
		    (ltp->nof_says)?((double)ltp->secs/ltp->nof_says):(ltp->secs));
	    break;
	  case FORMAT_CTFSCORE:
	    if (sortorder==SORT_CTFSCORE && sc)
	      fprintf(fp, "<td align=center bgcolor=\"%s\">", sc);
	    else
	      fprintf(fp, "<td align=center>");
	    fprintf(fp, "%li</td>", ltp->ctf_score);
	    break;
	  case FORMAT_FSTEALS:
	    fprintf(fp, "<td align=center>%li</td>", ltp->ctf_steals);
	    break;
	  case FORMAT_FPICKUPS:
	    fprintf(fp, "<td align=center>%li</td>", ltp->ctf_pickups);
	    break;
	  case FORMAT_FLOSS:
	    fprintf(fp, "<td align=center>%li</td>", ltp->ctf_loss);
	    break;
	  case FORMAT_FSUICIDE:
	    fprintf(fp, "<td align=center>%li</td>", ltp->ctf_suic);
	    break;
	  case FORMAT_FAUTORET:
	    fprintf(fp, "<td align=center>%li</td>", ltp->ctf_autoret);
	    break;
	  case FORMAT_FCAPTURE:
	    fprintf(fp, "<td align=center>%li</td>", ltp->ctf_captures);
	    break;
	  case FORMAT_FKILLS:
	    fprintf(fp, "<td align=center>%li</td>", ltp->ctf_kills);
	    break;
	  case FORMAT_FRETURN:
	    fprintf(fp, "<td align=center>%li</td>", ltp->ctf_returns);
	    break;
	  case FORMAT_CTFGAMES:
	    fprintf(fp, "<td align=center>%li</td>", ltp->nof_ctfgames);
	    break;
	  case FORMAT_CTFGAMESWON:
	    fprintf(fp, "<td align=center>%li</td>", ltp->nof_ctfwins);
	    break;
	  default:
	    fprintf(fp, "<td align=center>!ERR!</td>");
	  }
	}
      fprintf(fp, "</tr>\n");  
    }
  free(sort);
}



void write_ap_stats(FILE *fp, t_ltp *ltp, char *hc)
{
  if (hc) fprintf(fp, "<tr bgcolor=%s>\n", hc);
  else fprintf(fp, "<tr>");
  fprintf(fp, "<th>Time played</th><th>Games</th><th>Games won</th><th>Kills</th><th>Suicides</th><th>TKills</th><th>Deaths</th><th>Frags</th><th>FPH</th><th>Eff.</th><th>TTL</th><th>Pickups</th><th>Says</th></tr>\n<tr>");

  fprintf(fp, "  <td align=center>%02li:%02li:%02li</td>\n",
	  ltp->secs/3600, (ltp->secs%3600)/60, ltp->secs%60);
  fprintf(fp, "  <td align=center>%li</td>\n", ltp->nof_games);
  fprintf(fp, "  <td align=center>%li</td>\n", ltp->nof_wins);
  fprintf(fp, "  <td align=center>%li</td>\n", ltp->nof_kills);
  fprintf(fp, "  <td align=center>%li</td>\n", ltp->nof_suicides);
  fprintf(fp, "  <td align=center>%li</td>\n", ltp->nof_tkills);
  fprintf(fp, "  <td align=center>%li</td>\n", ltp->nof_deaths);
  fprintf(fp, "  <td align=center>%li</td>\n", ltp->nof_frags);
  fprintf(fp, "  <td align=center>%2.2f</td>", ltp->fph);
  fprintf(fp, "  <td align=center>%2.2f</td>", ltp->effect);
  fprintf(fp, "  <td align=center>%2.2f</td>", ltp->ttl);

  fprintf(fp, "  <td align=center>%li</td>\n", ltp->nof_items);
  fprintf(fp, "  <td align=center>%li</td>\n", ltp->nof_says);
  fprintf(fp, "</tr>\n");
}

void write_ap_ctfstats(FILE *fp, t_ltp *ltp, char *hc)
{
  double ctfeff;

  if (hc) fprintf(fp, "<tr bgcolor=%s>\n", hc);
  else fprintf(fp, "<tr>");
  fprintf(fp, "<th>CTF-Games</th><th>CTF-Games won</th>\n");
  fprintf(fp, "<th>Steals</th>\n");
  fprintf(fp, "<th>FPickups</th>\n");
  fprintf(fp, "<th>FLoss</th>\n");
  fprintf(fp, "<th>Suicides</th>\n");
  fprintf(fp, "<th>Captures</th>\n");
  fprintf(fp, "<th>FKill</th>\n");
  fprintf(fp, "<th>FReturn</th>\n");
  fprintf(fp, "<th>AutoRet</th>\n");
  fprintf(fp, "<th>Eff.</th>\n");
  fprintf(fp, "<th>Score</th>\n");
  fprintf(fp, "</tr><tr>\n");

  fprintf(fp, "<td align=center>%li</td>\n", ltp->nof_ctfgames);
  fprintf(fp, "<td align=center>%li</td>\n", ltp->nof_ctfwins);
  fprintf(fp, "<td align=center>%li</td>\n", ltp->ctf_steals);
  fprintf(fp, "<td align=center>%li</td>\n", ltp->ctf_pickups);
  fprintf(fp, "<td align=center>%li</td>\n", ltp->ctf_loss);
  fprintf(fp, "<td align=center>%li</td>\n", ltp->ctf_suic);
  fprintf(fp, "<td align=center>%li</td>\n", ltp->ctf_captures);
  fprintf(fp, "<td align=center>%li</td>\n", ltp->ctf_kills);
  fprintf(fp, "<td align=center>%li</td>\n", ltp->ctf_returns);
  fprintf(fp, "<td align=center>%li</td>\n", ltp->ctf_autoret);
  if (ltp->ctf_pickups+ltp->ctf_steals)
    {
      ctfeff = 100.0  * (double)ltp->ctf_captures /\
	(double)(ltp->ctf_pickups+ltp->ctf_steals);
    } else ctfeff = 0.0;
  fprintf(fp, "<td align=center>%02.2f</td>\n", ctfeff);

  fprintf(fp, "  <td align=center>%li</td>\n", ltp->ctf_score);
  fprintf(fp, "</tr>\n");
}
