/*
  Simple functions, used for putting the desired info to a HTML-file.

  $Id: html_writers.h,v 2.7 2000/03/02 09:03:35 jacobs Exp jacobs $

  $Log: html_writers.h,v $
  Revision 2.7  2000/03/02 09:03:35  jacobs
  Chat-Viewer builtin

  Revision 2.6  2000/02/14 11:02:13  jacobs
  *** empty log message ***

  Revision 2.5  2000/02/06 20:18:43  jacobs
  *** empty log message ***

  Revision 2.4  2000/01/29 21:41:12  jacobs
  *** empty log message ***

  Revision 2.3  2000/01/25 22:53:37  jacobs
  *** empty log message ***

  Revision 2.2  2000/01/22 22:32:47  jacobs
  *** empty log message ***

  Revision 2.1  2000/01/18 22:50:53  jacobs
  *** empty log message ***

  Revision 1.6  2000/01/14 21:49:15  jacobs
  *** empty log message ***

  Revision 1.5  2000/01/11 23:25:53  jacobs
  *** empty log message ***

  Revision 1.4  2000/01/09 02:32:17  jacobs
  *** empty log message ***

  Revision 1.3  2000/01/07 13:43:42  jacobs
  *** empty log message ***

  Revision 1.2  2000/01/05 03:43:25  jacobs
  *** empty log message ***

  Revision 1.1  2000/01/03 16:04:02  jacobs
  Initial revision


*/
#ifndef __HTML_WRITERS__
#define __HTML_WRITERS__

#include <stdio.h>
#include "config.h"
#include "game.h"
#include "lt_stats.h"
#include "tools/hpj_image.h"

#define SORT_FRAGS     0
#define SORT_DEATHS    1
#define SORT_KILLS     2
#define SORT_TIME      3
#define SORT_SUICIDES  4
#define SORT_FPH       5
#define SORT_NAME      6
#define SORT_EFFICENCY 7
#define SORT_TTL       8
#define SORT_CTFSCORE  9

/*
 *
 *
 Single-game statistics
 *
 *
 */
void write_sg_table(FILE *fp, t_game **games, int nof_games,\
		    char **todo, char **todo_t, char **todo_p, int *sp,\
		    int cols, int gametype, int plimit);
void write_sg_stats(FILE *fp, t_game *game, char *hc);
void write_sg_stats_all(FILE *fp, t_game *game, char *hc, char b_sgtalks,
			char **todo, char **todo_t, char **todo_p, int *sp);
void write_sg_chattable(FILE *fp, t_game *game, char *rc, char *bc, char *hc, char b_humanonly);

/* Team-based scores for a Single Game*/
void write_sg_teamwinner(FILE *fp, t_game *game);
void write_sg_teamtimeline(FILE *fp, t_game *game,\
			   int offx, int offy, int deltax, int deltay,\
			   char *outdir, hpj_image *bgimg, int zcompression,
			   char steps);
void write_sg_teamstats(FILE *fp, t_game *game, char *rc, char *bc, char *hc);
void write_sg_ctftimeline(FILE *fp, t_game *game,\
			  int offx, int offy, int deltax, int deltay,\
			  char *outdir, hpj_image *bgimg, int zcompression,
			  char steps);
void write_sg_ctfstats(FILE *fp, t_game *game, char *rc, char *bc, char *hc);
void write_sg_ctfdetails(FILE *fp, t_game *game, char *rc, char *bc, char *hc,
			 char *nc, char b_kick, char b_humanonly);

/* Kill-stats */
void write_sg_fragtimeline(FILE *fp, t_game *game,\
			   int   offx, int offy, int deltax, int deltay,\
			   char *outdir, hpj_image *bgimg, int zcompression,\
			   char  steps, int humanonly, char b_kick);
void write_sg_ranks(FILE *fp, t_game *game,\
		    char **todo, char **todo_t, char **todo_p, int *sp,\
		    char *bc, char *rc, char *nc, char *hc,\
		    hpj_image *bgimg, int humanoly, hpj_config *cfg);

void write_sg_killtab(FILE *fp, t_game *game,
		      char *bc, char *rc, char *nc, char *sc,
		      char  b_kick, int time_minimum);


/*
 *
 *
 Single Game - single player
 *
 *
 */
void write_sp_playername(FILE *fp, t_game *game, int pid);
void write_sp_killtable(FILE  *fp, t_game *game, int pid, char *rc,\
			char  *bc, char *nc, char *hc, int showall);


/*
 *
 *
 All time stats
 *
 *
 */
void write_ag_stats(FILE *fp, t_lts *lts, char *hc);
void write_ag_pickups(FILE *fp, t_lts *lts, int cols, int a);
void write_ag_ctfstats(FILE *fp, t_lts *lts, char *hc);
void write_agp_allstats(FILE  *fp, t_lts *lts, char *hc, char *sc,\
			char **todo, char **todo_t, char **todo_p, int *sp,\
			int    sortorder, int humanonly, int tablelines,
			hpj_config *cfg);
void write_ap_stats(FILE *fp, t_ltp *ltp, char *hc);
void write_ap_ctfstats(FILE *fp, t_ltp *ltp, char *hc);



/* for any weapon, item output you should use one of the following calls */
void write_any_weapons(FILE *fp, long int *weaps, int cols, int a,
		       int compact);
void write_any_weapons_graph(FILE *fp, long int *weaps, char *templatedir,
			     int   compact, int  cols,
			     int   all,     int  width, int height);
void write_any_items(FILE *fp, long int *items, int cols, int a);



/*
 *
 *
 commonly used statistics
 *
 *
 */
void write_HPJ(FILE *fp);

/* date and time */
void write_date(FILE *fp);
void write_time(FILE *fp);

/* Writes the frag-counter */
void write_counter(FILE *fp, int counter);
void write_counter_gfx(FILE *fp, int counter, char *pre, char *post);

#endif
