/*
  This is the file containing the *long-time* stats for players
  and played games.
  Later I will add here some stats-add/load/save/merge-functions !!

  $Id: lt_stats.h,v 2.6 2000/03/02 09:03:35 jacobs Exp jacobs $

  $Log: lt_stats.h,v $
  Revision 2.6  2000/03/02 09:03:35  jacobs
  fixed player-name==NULL - bug

  Revision 2.5  2000/02/14 11:02:13  jacobs
  *** empty log message ***

  Revision 2.4  2000/02/06 20:18:43  jacobs
  *** empty log message ***

  Revision 2.3  2000/01/29 21:41:12  jacobs
  *** empty log message ***

  Revision 2.2  2000/01/22 22:32:47  jacobs
  *** empty log message ***

  Revision 2.1  2000/01/18 22:50:53  jacobs
  *** empty log message ***

  Revision 1.5  2000/01/14 21:49:15  jacobs
  *** empty log message ***

  Revision 1.4  2000/01/11 23:25:53  jacobs
  *** empty log message ***

  Revision 1.3  2000/01/03 16:04:02  jacobs
  *** empty log message ***

  Revision 1.2  1999/12/31 02:21:41  jacobs
  *** empty log message ***

  Revision 1.1  1999/12/30 01:26:21  jacobs
  Initial revision


*/

#ifndef __LONG_TIME_STATS_H__
#define __LONG_TIME_STATS_H__

#define MAX_LT_PLAYERS 8192


#include "game.h"
#include "tools/hpj_cstack.h"

typedef struct {
  char *name;

  long int   secs, skill, pid;
  long int   nof_frags, nof_kills, nof_suicides, nof_tkills, nof_deaths;
  long int   nof_says, nof_items, nof_games, nof_wins, nonactive;

  long int   nof_ctfgames, nof_ctfwins;
  long int   ctf_score;
  long int   ctf_steals, ctf_captures;
  long int   ctf_pickups, ctf_returns;
  long int   ctf_autoret, ctf_suic;
  long int   ctf_loss, ctf_kills;
  
  long int   items[NOF_ITEMS];
  long int   weaps[NOF_WEAPS], wsui[NOF_WEAPS];
  long int   wtkill[NOF_WEAPS], wdeath[NOF_WEAPS];

  double effect, ttl, fph;
}t_lt_player, t_ltp;


typedef struct {
  long int   nof_players, secs;
  long int   nof_games, nof_kills, nof_tkills, nof_suicides;
  long int   nof_items, nof_frags, nof_deaths, nof_says;

  long int   nof_ctfgames, ctf_score;
  long int   ctf_steals, ctf_captures;
  long int   ctf_pickups, ctf_returns;
  long int   ctf_autoret, ctf_suic;
  long int   ctf_loss, ctf_kills;

  long int   items[NOF_ITEMS];
  long int   weaps[NOF_WEAPS], wsui[NOF_WEAPS], wtkill[NOF_WEAPS];

  t_ltp **ltplayers;
}t_lt_stats, t_lts;


/* extern we just want to create whole stats, players are handled
   just intern*/
t_lts *new_ltStat(void);
t_lts *del_ltStat(t_lts *lts);

long int size_ltStat(t_lts *lts);

/* And a simple function for adding a whole game to the stats */
int add_game(t_lts *lts, t_game *game, hpj_cstack *s1);

/* Save and Load-function for the all-time stats */
t_lts *load_stats(char *fname, hpj_cstack *s1);
int    save_stats(t_lts *lts, char *fname);

#endif
