/*
  This tool generates some HTML-output from the Quake3 - "game.log"
  It has been written completely in C, starting with the free
  LCC-Win32 Compiler (GREAT !)

  This code can be reused or improved, but you have to keep all these remarks.
  And please update the versions-information and send the code back to me,
  so I can release another "official" release.

  Its a free project, but its not okay to make money with code or tool !

  !!!!!!!!!
  If you want to put the code or the tool on any electronical media to
  make money you have to ask me first !
  !!!!!!!!!

  Hans-Peter Jacobs <mailto: hanspete@cs.tu-berlin.de>

  $Id: main.c,v 2.7 2000/03/02 09:03:35 jacobs Exp jacobs $

  $Log: main.c,v $
  Revision 2.7  2000/03/02 09:03:35  jacobs
  *** empty log message ***

  Revision 2.6  2000/02/14 11:02:13  jacobs
  *** empty log message ***

  Revision 2.5  2000/02/06 20:18:43  jacobs
  *** empty log message ***

  Revision 2.4  2000/01/29 21:41:12  jacobs
  *** empty log message ***

  Revision 2.3  2000/01/25 22:53:37  jacobs
  ..

  Revision 2.2  2000/01/22 22:32:47  jacobs
  *** empty log message ***

  Revision 2.1  2000/01/18 22:50:53  jacobs
  *** empty log message ***

  Revision 1.10  2000/01/14 21:49:15  jacobs
  *** empty log message ***

  Revision 1.9  2000/01/11 23:25:53  jacobs
  *** empty log message ***

  Revision 1.8  2000/01/09 23:09:44  jacobs
  new option "-r"

  Revision 1.7  2000/01/09 02:32:17  jacobs
  *** empty log message ***

  Revision 1.6  2000/01/05 03:43:25  jacobs
  *** empty log message ***

  Revision 1.5  2000/01/03 16:04:02  jacobs
  *** empty log message ***

  Revision 1.4  1999/12/31 02:21:41  jacobs
  *** empty log message ***

  Revision 1.3  1999/12/30 01:26:21  jacobs
  *** empty log message ***

  Revision 1.2  1999/12/28 22:38:05  jacobs
  *** empty log message ***

  Revision 1.1  1999/12/28 22:33:36  jacobs
  Initial revision

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "tool.h"
#include "game.h"
#include "html_creator_tpl.h"
#include "text_creator.h"
#include "tools/hpj_string.h"
#include "config.h"

#ifdef DEBUG_MTRACE
#include "mcheck.h"
#endif

/* needed for counting the lines in the files */
int         linecounter=0;
hpj_config *cfg;

/*
 *
 *
 Here we go !! Its gonna be a mess -> you've been warned !
 *
 *
 *
 *
 *
 *
 */
/* The "kill"-keyword is the most complex, we have to count frags, deaths,
   suicides, team-kills and flag-losses */
int parse_kill(t_event *event, t_game *game)
{
  int  cl, vic, weap, color, t;

  if (game->complete) return 1;  
  sscanf(event->text, "%i %i %i:", &t, &vic, &weap);
  if (t!=1022)
    cl=getPlayerID(game, t);
  else cl=1022;
  vic=getPlayerID(game, vic);
  if (vic<0 || cl<0)
    {
      fprintf(stderr, "** unknown/unconnected client %i kills %i @line %i\n",
	      t, vic, linecounter);
      return 1;
    }

  /* check for the loss of enemies flag */
  if (game->type==GAMETYPE_CTF)
    {
      for (color=1; color<3; color++)
	{
	  if (vic==game->flag_carrier[color])
	    {
	      //fprintf(stderr,"Flag_%i carrier(%i) killed by %i\n",color,vic,cl);
	      if (weap!=16 && weap!=17 && weap!=22)
		game->flag_carrier[color]=CTF_LEVEL;
	      else
		{
		  game->flag_carrier[color]=CTF_BASE;
		  game->ctf_autoret[game->player[vic]->team]++;
		  game->player[vic]->ctf_autoret++;
		}
	      
	      if (cl<game->nof_players && cl!=vic)
		{
		  game->ctf_loss[game->player[vic]->team]++;
		  game->player[vic]->ctf_loss++;
		  game->ctf_kills[color]++;
		  game->player[cl]->ctf_kills++;
		} else {
		  game->ctf_suic[game->player[vic]->team]++;
		  game->player[vic]->ctf_suic++;		  
		}
	    }
	}
    }

  /* check for suicide */
  //fprintf(stderr, "KILL  -> %i -> %i with %i\n", cl, vic, weap);
  if (weap>NOF_WEAPS)
    {
      fprintf(stderr, "unknown weap : %i\n", weap);
      weap=0;
    }
  if (cl < game->nof_players && cl!=vic)
    {
      game->player[cl]->nof_kills++;
      game->player[cl]->nof_frags++;
      game->player[cl]->lst_kills[vic]++;
      game->player[vic]->nof_deaths++;
      game->player[vic]->wdeath[weap]++;
      game->weaps[weap]++;
      game->player[cl]->weaps[weap]++;

      game->nof_deaths++;
      game->nof_frags++;
      game->nof_kills++;

      /* check a team-kill */
      if (game->type > 2)
	{
	  color=game->player[cl]->team;
	  if (color<0 || color>=MAX_TEAMS)
	    fprintf(stderr, "** team-range is strange : %i @line %i\n",
		    color, linecounter);
	  if ((game->player[vic]->team == game->player[cl]->team))
	    {
	      /* we just killed a friend */
	      game->player[cl]->nof_tkills++;
	      game->player[cl]->nof_frags-=2;
	      game->player[cl]->nof_kills--;
	      game->team_frags[color]--;
	      game->nof_frags-=2;
	      game->nof_kills--;
	      game->nof_tkills++;

	      game->weaps[weap]--;
	      game->player[cl]->weaps[weap]--;
	      game->wtkill[weap]++;
	      game->player[cl]->wtkill[weap]++;


	      game->team_tkills[color]++;
	    } else {
	      game->team_kills[color]++;
	      game->team_frags[color]++;
	    }
	  /* timeline-update for the team */
	  iarray_append(game->tl_team[color], game->team_frags[color]);
	  iarray_append(game->tl_teamsec[color],event->time-game->startsec);
	}
      /* timeline-update for the player who caused the mess */
      iarray_append(game->player[cl]->tl_frags,game->player[cl]->nof_frags);
      iarray_append(game->player[cl]->tl_fragsec, event->time-game->startsec);
      iarray_append(game->player[cl]->tl_weaps, weap);
      iarray_append(game->player[cl]->tl_whom, vic);
    } else {
      /* The idiot killed himself (or jumped into something very deadly)*/
      game->player[vic]->lst_kills[vic]++;
      game->player[vic]->nof_suicides++;
      game->player[vic]->nof_deaths++;
      game->player[vic]->nof_frags--;
      game->wsui[weap]++;
      game->player[vic]->wsui[weap]++;
      game->player[vic]->wdeath[weap]++;
      game->nof_suicides++;
      game->nof_deaths++;
      game->nof_frags--;

      /* check the suicide for the team */
      if (game->type > 2)
	{
	  color=game->player[vic]->team;
	  if (color<0 || color>=MAX_TEAMS)
	    fprintf(stderr, "** team-range is strange : %i @line %i\n",\
		    color,linecounter);
	  game->team_suic[color]++;
	  game->team_frags[color]--;
	  iarray_append(game->tl_team[color],game->team_frags[color]);
	  iarray_append(game->tl_teamsec[color],event->time-game->startsec);
	}

      /* the suicide will also be logged in the timeline */
      iarray_append(game->player[vic]->tl_frags,game->player[vic]->nof_frags);
      iarray_append(game->player[vic]->tl_fragsec,event->time-game->startsec);
      iarray_append(game->player[vic]->tl_weaps,weap);
      iarray_append(game->player[vic]->tl_whom,vic);
    }
  return 1;
}



/* Somebody picked up a item. Thats not very interesting, the only
   important item is the "flag" for CTF*/
int parse_item(t_event *event, t_game *game)
{
  int cl, i, player, flag, eflag;

  if (game->complete) return 1;
  game->nof_items++;
  sscanf(event->text, "%i", &cl);
  cl=getPlayerID(game, cl);
  if (cl<0)
    {
      fprintf(stderr, "Unknown client - line %i\n", linecounter);
      return 1;
    }

  for (i=0; i<NOF_ITEMS; i++)
    if (strstr(event->text, c_items[i])!=NULL)
      break;

  game->player[cl]->nof_items++;
  if (i>=NOF_ITEMS && strstr(event->text,"team_CTF") ==NULL)
    {
      fprintf(stderr, "Unknown item - %s - line %i\n",\
	      event->text, linecounter);
      return 1;
    }
  if (strstr(event->text, "team_CTF")!=NULL)
    {
      /* we touched a flag !!!*/
      if (strstr(event->text, "redflag")!=NULL)
	flag=1;
      else flag=2;
      if (flag==2) eflag=1; else eflag=2;
      player=game->player[cl]->team;
      /* now we know the color of the player and the flag */
      
      if (flag!=player)
	{
	  /* enemy flag taken from base or level */
	  if (game->flag_carrier[flag]==CTF_BASE)
	    {
	      //fprintf(stderr, "%i flag stolen by %i\n", flag, cl);
	      game->ctf_steals[eflag]++;
	      game->player[cl]->ctf_steals++;
	    }
	  else
	    {
	      //fprintf(stderr, "%i flag picked up by %i\n", flag, cl);
	      game->ctf_pickups[eflag]++;
	      game->player[cl]->ctf_pickups++;
	    }
	  game->flag_carrier[flag]=cl;
	} else {
	  if (game->flag_carrier[flag]==CTF_LEVEL)
	    {
	      //fprintf(stderr, "%i flag returned by %i\n", flag, cl);
	      game->flag_carrier[flag]=CTF_BASE;
	      game->ctf_returns[flag]++;
	      game->player[cl]->ctf_returns++;
	    } else if (game->flag_carrier[eflag]==cl)
	      {
		//fprintf(stderr, "%i flag touchdown by %i\n", eflag, cl);
		game->flag_carrier[eflag]=CTF_BASE;
		
		game->ctf_captures[flag]++;
		game->player[cl]->ctf_captures++;
		iarray_append(game->tl_ctfsec[flag],\
			      event->time - game->startsec);
		iarray_append(game->tl_ctf[flag], game->ctf_captures[flag]);
	      }
	}
    }
  else
    {
      game->player[cl]->lst_items[i]++;
      game->lst_items[i]++;
    }
  return 1;
}




/* A player just connected, we set the initial time and the frags ... */
int parse_connection(t_event *event, t_game *game)
{
  int cl, pid;
  t_player **tmp;

  sscanf(event->text, "%i", &cl);
  pid=getPlayerID(game, cl);
  if (pid>=0)
    {
      //fprintf(stderr, "reconnect_%i_line_%i ",cl,linecounter);
      //game->player[pid]->nof_frags=0;
      return 1;
    }
  //fprintf(stderr, "%s -> *%s* (%i)\n", event->event, event->text, cl);
  pid=game->nof_players;

  if (game->nof_players==0 && game->startsec==0)
    game->startsec=event->time;
  tmp=(t_player **)realloc(game->player, sizeof(t_player *) * (pid+1));
  if (tmp==NULL) exit_error("REALLOC failed\n");
  game->player=tmp;
  //game->nof_players=pid+1;
  game->nof_players++;
  game->player[pid]=new_player();
  game->player[pid]->c_id=cl;
  game->player[pid]->b_fresh=1;
  game->player[pid]->b_active=1;

  game->player[pid]->startsec=event->time;
  iarray_append(game->player[pid]->tl_fragsec, event->time - game->startsec);
  iarray_append(game->player[pid]->tl_frags, 0);
  iarray_append(game->player[pid]->tl_whom, -1);
  iarray_append(game->player[pid]->tl_weaps, -1);
#if (DEBUG_LEVEL>0)
  fprintf(stderr, " client %i for player %i added -- ", cl, pid);
#endif
  return 1;
}


/* A Player said "good-bye" */
int parse_disconnection(t_event *event, t_game *game)
{
  int cl, pid;
  sscanf(event->text, "%i", &cl);
  pid=getPlayerID(game, cl);
  if (pid>=0)
    {
      game->player[pid]->c_id=-2;
      game->player[pid]->secs+=event->time - game->player[pid]->startsec;
      if (game->player[pid]->startsec < game->startsec)
	game->player[pid]->secs+=0;
      game->player[pid]->b_active=0;
    }
  else fprintf(stderr, "client %i disconnected before connecting\n", cl);
  return 1;
}


/* Before any action can start you have to begin, but I do not understand
   what this info should be good for, client-connect is enough !!!??? */
int parse_begin(t_event *event, t_game *game)
{
  int cl, pid;
  t_player *player;
  
  sscanf(event->text, "%i", &cl);
  pid=getPlayerID(game, cl);
  if (pid<0) {fprintf(stderr, "Unknown client - line %i\n", linecounter);exit;}

  player=game->player[pid];
  if (player->b_active==0)
    {
      player->startsec=event->time;
      iarray_append(player->tl_fragsec, event->time - game->startsec);
      iarray_append(player->tl_frags, 0);
      iarray_append(player->tl_whom, -1);
      iarray_append(player->tl_weaps, -1);
    }
  return 1;
}


/* This should normally be found short after a "ClientConnect". All infos
   about a player are included. If a player changes the name (mesh, skin,..)
   this keyword appears also.*/
int parse_uinfochanged(t_event *event, t_game *game)
{
  int       cl, team, skill, pid, i;
  char     *name, c;
  t_player *player;
  
  sscanf(event->text, "%i", &cl);
  pid=getPlayerID(game, cl);
  if (pid<0) {fprintf(stderr, "  UINFO: Unknown client %i\n",cl);exit(-1);}

  player=game->player[pid];

  if (strstr(event->text, " n\\")!=NULL)
    {
      if (player->name!=NULL)
	free(player->name);
      if (player->i_name!=NULL)
	free(player->i_name);
      player->name=get_Keyword_char(event->text, "n\\");
      for (i=0; i<strlen(player->name);i++)
	c=player->name[i];
      player->i_name=get_Keyword_char(event->text, "n\\");
      //fprintf(stderr, "%s\n", player->name);
    }
  else fprintf(stderr, "** uinfo_strange : %s @line %i\n", event->text,linecounter);

  /* HERE WE GO TO CHECK FOR DUPLICATE NAMES */
  for (i=0; i<game->nof_players; i++)
    {
      if (i==pid) continue;
      if (strcmp(game->player[i]->name, game->player[pid]->name)==0)
	{
	  if (game->player[i]->b_active && game->player[pid]->b_active)
	    {
	      fprintf(stderr, "duplicate_names_@line_%i\n", linecounter);
	      continue;
	    }
	  if(!game->player[pid]->b_fresh)
	    {
	      fprintf(stderr, "player_name_collision_@line_%i\n", linecounter);
	      continue;
	    }
	  player=game->player[i];
	  player->c_id=cl;
	  player->startsec=event->time;
	  player->b_active=1;
	  game->player[pid]=del_player(game->player[pid]);
	  game->nof_players--;
	  if (game->nof_players > pid)
	    {
	      game->player[pid]=game->player[game->nof_players];
	      game->player[game->nof_players]=NULL;
	    }
	  if (i==game->nof_players)
	    player=game->player[pid];
	  break;
	}
    }

  team=get_Keyword_int(event->text, "\\t\\");
  player->handicap=get_Keyword_int(event->text+4, "\\hc\\");
  skill=get_Keyword_int(event->text+4, "\\skill\\");

  /* If skill-tag found, then its a bot */
  if (skill>-1 && skill<10)
    {
      name=(char *)malloc(strlen(player->name)+6);
      sprintf(name, "%s_[%i]", player->name, skill);
      free(player->name);
      player->name=name;
      player->skill=skill;
    }
  else player->skill=-1;

  if (team==1) player->b_red=1;
  if (team==2) player->b_blue=1;

  player->team=team;
  if (!game->complete)
    {
      /* OBSERVER ! */
      if (player->team==3)
	player->nof_frags=0;

      /* team changed, set frags to 0 */
      if (player->team!=player->oldteam)
	{
	  if (player->nof_frags>0)
	    player->nof_frags=0;
	  iarray_append(player->tl_fragsec,\
			event->time - game->startsec);
	  iarray_append(player->tl_frags,
			player->nof_frags);
	  iarray_append(player->tl_whom, -1);
	  iarray_append(player->tl_weaps, -1);
	}

    }
  player->oldteam=player->team;

#if (DEBUG_LEVEL>1)
  fprintf(stderr, "Player %s changed\n",player->name);
#endif
  player->b_fresh=0;
  return 1;
}


/* Somebody said something -> now we store the message and just increase the
   counters */
int parse_say(t_event *event, t_game *game)
{
  int  i;
  char who[256];
  hpj_string *name, *message;

  sscanf(event->text+1, "%s", who);
  who[strlen(who)-1]=0;
  game->nof_says++;
  for (i=0; i<game->nof_players; i++)
    if ((game->player[i]->i_name) && (strcmp(who, game->player[i]->i_name)==0))
      {
	game->player[i]->nof_says++;
	iarray_append(game->chat_skill, game->player[i]->skill);
	if (strstr(event->event, "sayteam")!=NULL)
	  iarray_append(game->chat_team, game->player[i]->team);
	else
	  iarray_append(game->chat_team, 0);
	break;
      }

  iarray_append(game->chat_secs, event->time - game->startsec);
  name=string_new_char(who);
  parray_append(game->chat_name, name);
  message=string_new_char(&event->text[strlen(who)+3]);
  parray_append(game->chat_message, message);
  return 1;
}


/* This parses the scores from the teams -> in CTF frags differ from score !*/
int parse_teamscore(t_event *event, t_game *game)
{
  sscanf(event->text, "%li blue:%li", &game->team_score[1],
	 &game->team_score[2]);
  return 1;
}



/* this keyword can just be found if the game was "complete", ended by a
   time-, capture- or fraglimithit */
int parse_score(t_event *event, t_game *game)
{
  int   cl, ping, score;
  char *t;

  t=strstr(event->text,"ping:");
  sscanf(t+strlen("ping:"), "%i ", &ping);

  sscanf(event->text, "%i ", &score);

  t=strstr(event->text,"client:");
  sscanf(t+strlen("client:"), "%i ", &cl);

  //fprintf(stderr, "%i : %i points %i ping\n", cl, score, ping);
  cl=getPlayerID(game, cl);

  if (cl<0)
    {
      fprintf(stderr, "  SCORE: Unknown client %i @line %i\n",
	      cl, linecounter);
      exit;
    }

  game->player[cl]->ping=ping;
  game->player[cl]->score=score;
  if ((score!=game->player[cl]->nof_frags) && (game->type!=4))
    {
      fprintf(stderr,\
	      " _score_mismatch_(q3:%i-%i)_%i_line_%i_\n",
	      score, game->player[cl]->nof_frags,\
	      game->player[cl]->c_id, linecounter+1);
    }
  return 1;
}



/* This is just for getting the EndOfGame-reason */
void parse_exit(t_game *game, t_event *event)
{
  if (strstr(event->text, "Fraglimit hit.")!=NULL)
    game->exit_state=EXIT_FRAG;
  if (strstr(event->text, "Capturelimit hit.")!=NULL)
    game->exit_state=EXIT_CAPTURE;
  if (strstr(event->text, "Timelimit hit.")!=NULL)
    game->exit_state=EXIT_TIME;  
}


/* This is called after "Exit", "ShutdownGame" and "-"*/
void game_end(t_game *game, int time)
{
  int       i;
  t_player *player;

  game->secs=time - game->startsec;

  if (game->complete==1) return;

  for (i=0; i<game->nof_players; i++)
    {
      player=game->player[i];
      //if (player->secs==0)
      if (player->b_active) player->secs+=time - player->startsec;
      if (player->name==NULL)
	fprintf(stderr,\
		"<null>-name ---> client %i on map %s @line %i\n",\
		player->c_id, game->mapname, linecounter);
      //fprintf(stderr, "\nplayer(%i):%i ", i, player->nof_frags);
      iarray_append(player->tl_frags,\
		    iarray_get(player->tl_frags,\
			       iarray_elements(player->tl_frags)-1));
      //player->nof_frags);
      iarray_append(player->tl_fragsec,game->secs);
      iarray_append(player->tl_whom, -1);
      iarray_append(player->tl_weaps,-1);
      
      iarray_append(game->tl_ctf[1],game->ctf_captures[1]);
      iarray_append(game->tl_ctf[2],game->ctf_captures[2]);
      iarray_append(game->tl_ctfsec[1],game->secs);
      iarray_append(game->tl_ctfsec[2],game->secs); //time ??
      
      iarray_append(game->tl_team[1],game->team_frags[1]);
      iarray_append(game->tl_team[2],game->team_frags[2]);
      iarray_append(game->tl_teamsec[1],game->secs);
      iarray_append(game->tl_teamsec[2],game->secs);
    }
}



/*
 *
 *
 The following lines are the main-loop for parsing a game to the end
 *
 *
 */
t_game *parse_game(FILE *fp)
{
  t_game     *game=NULL;
  t_event    *event=NULL;
  hpj_string *s, *s1, *s2;
  char       *line=NULL, end=0;
  int         lasttime;
  
  /* We start with finding the InitGame - Line */
  line=get_Line(fp);
  linecounter++;
  if (line!=NULL)
    {
      event=get_Event(line);
      free(line);
    }
  while(event!=NULL && strcmp(event->event, "InitGame")!=0)
    {
      //printf("%i %s\n", event->time, event->event);
      event=del_event(event);
      line=get_Line(fp);
      linecounter++;
      if (line!=NULL)
	{
	  event=get_Event(line);
	  free(line);
	}
    }
  if (event==NULL) return NULL;

  /* Now we can parse the InitGame - Line */
  game=new_game();
  s=string_new_char(event->text);
  s1=string_token_left(s, '\\');
  string_shiftLeft(s,string_length(s1)+1);
  s1=string_del(s1);
  while(string_length(s)>0 && string_count_char(s, '\\')>0 )
    {
      s1=string_token_left(s, '\\');
      string_shiftLeft(s,string_length(s1)+1);
      if (string_count_char(s,'\\')<1)
	{
	  s2=string_clone(s);
	}
      else
	{
	  s2=string_token_left(s, '\\');
	  string_shiftLeft(s, string_length(s2)+1);
	}

      if (string_compare_charptr(s1, "mapname", false)==0)
	game->mapname=string_clone_charptr(s2);
      if (string_compare_charptr(s1, "sv_hostname", false)==0)
	game->servername=string_clone_charptr(s2);
      if (string_compare_charptr(s1, "gamename", false)==0)
	game->gamename=string_clone_charptr(s2);
      if (string_compare_charptr(s1, "fs_game", false)==0)
	game->fs_game=string_clone_charptr(s2);

      if (string_compare_charptr(s1, "fraglimit", false)==0)
	game->fraglimit=atoi(string_charptr(s2));
      if (string_compare_charptr(s1, "timelimit", false)==0)
	game->timelimit=atoi(string_charptr(s2));
      if (string_compare_charptr(s1, "capturelimit", false)==0)
	game->capturelimit=atoi(string_charptr(s2));
      if (string_compare_charptr(s1, "g_gametype", false)==0)
	game->type=atoi(string_charptr(s2));

      //fprintf(stderr, "%s -> %s\n", string_charptr(s1), string_charptr(s2));
      s1=string_del(s1);
      s2=string_del(s2);
    }
  s=string_del(s);

  /* setting the game up right now */
  game->startsec=event->time;
  game->flag_carrier[1]=CTF_BASE;
  game->flag_carrier[2]=CTF_BASE;

  iarray_append(game->tl_ctf[1],0);
  iarray_append(game->tl_ctf[2],0);
  iarray_append(game->tl_ctfsec[1],0);
  iarray_append(game->tl_ctfsec[2],0);

  iarray_append(game->tl_team[1],0);
  iarray_append(game->tl_team[2],0);
  iarray_append(game->tl_teamsec[1],0);
  iarray_append(game->tl_teamsec[2],0);

  lasttime=event->time;
  /* run till "ShutDownGame" or "-" : "-" indicates a server-crash */
  while (!end)
    {
      line=get_Line(fp);
      linecounter++;
      event=del_event(event);
      if (line!=NULL)
	{
	  event=get_Event(line);
	  free(line);
	}
      if (line==NULL || event==NULL) {
	  game_end(game, lasttime);
	  end=1;break;
	}

      /* if we want to see all line, uncomment teh following
        fprintf(stderr, "%s\n", line);*/
      //fprintf(stderr, "%i\n", linecounter);

      /* nice exist: time-, frag- or capturelimit hit */
      if (strcmp(event->event, "Exit")==0)
	{
	  parse_exit(game, event);
	  game_end(game, event->time);
	  game->complete=1;
	  continue;
	}
      /* game is going down *now*, hopefully we got "exit" before */
      if (strcmp(event->event, "ShutdownGame")==0)
	{
	  game_end(game, event->time);
	  end=1;
	  continue;
	}
      /* something is wrong here -> not shutdown !!!*/
      if (strcmp(event->event, "-")==0)
	{
	  //fprintf(stderr, "corrupt game ");
	  game_end(game, lasttime);
	  end=1;
	  continue;
	}
      /* brutal exist -> server crashed (or file is corrupt)
         we simply end the current game and rewind the file one line */
      if (strcmp(event->event, "InitGame")==0)
	{
	  //fprintf(stderr, "corrupt game ");
	  game_end(game, lasttime);
	  rewind_Line(fp);
	  end=1;
	  continue;
	}

      lasttime=event->time;
      //fprintf(stdout, "+%s+ -%s-\n", event->event, event->text);
      if (strcmp(event->event, "Kill")==0)
	{parse_kill(event, game); continue;}
      if (strcmp(event->event, "Item")==0)
	{parse_item(event, game); continue;}
      if (strcmp(event->event, "ClientConnect")==0)
	{parse_connection(event, game);	continue;}
      if (strcmp(event->event, "ClientDisconnect")==0)
	{parse_disconnection(event, game); continue;}
      if (strcmp(event->event, "ClientBegin")==0)
	{parse_begin(event, game); continue;}
      if (strcmp(event->event, "ClientUserinfoChanged")==0)
	{parse_uinfochanged(event, game); continue;}
      if (strcmp(event->event, "Warmup")==0)
	{game->warmup=1; game->exit_state=EXIT_WARMUP; continue;}
      if (strcmp(event->event, "red")==0)
	{parse_teamscore(event, game);continue;}
      if (strcmp(event->event, "score")==0)
	{parse_score(event, game); continue;}

      if (strcmp(event->event, "say")==0 || strcmp(event->event, "sayteam")==0)
	{parse_say(event, game); continue;}

      if (strcmp(event->event, "tell")==0)
	continue; // nothing to do, tells are private
      fprintf(stderr, "Unknown Key-Word : %s - line %i\n",\
	      event->event, linecounter);
    }
  event=del_event(event);
  return game;
}



/*
 *
 *
 This stuff parses the whole file
 *
 *
 */
int parse_log_files(char **fnames)
{
  int         j, k;
  int         oldcounter=0, fcounter=0, gcounter=0;
  long int    sum;
  t_game    **game;
  FILE       *fp=NULL;
  hpj_cstack *s1=NULL;
  t_lts      *lts=NULL;


  sum=0;

  /* parse score-calculation */
  s1=parse_string(cfg->calculation);
  if (s1==NULL)
    {
      fprintf(stderr, "  calculation for effectiveness was messed up\n");
      return 0;
    } else fprintf(stderr, "  effectiveness-string was parsed\n");

  /* load maps */
  mapname_load(cfg->mapfile);

  /* create the longtime stats */
  if (cfg->b_ltstats) lts=load_stats(cfg->lt_file, s1);
  else {
    fprintf(stderr, "  ignoring existing long term stats\n");
    lts=new_ltStat();
  }

  /* create the game-structs, load any existing game */
  game=(t_game **)malloc(sizeof(t_game *) * MAXGAMES);

  /* for all files parse the games */
  while (fnames[fcounter]!=NULL)
    {
      fp=fopen(fnames[fcounter], "rb");
      if (fp==NULL)
	{
	  fprintf(stderr, "failed to open '%s'\n", fnames[fcounter]);
	  fcounter++;
	  continue;
	}

      while (!feof(fp) && gcounter<MAXGAMES)
	{
	  game[gcounter]=parse_game(fp);
	  if (game[gcounter]==NULL)
	    break;
	  game[gcounter]->gid=gcounter;
	  
	  if (game[gcounter]->complete==1 && game[gcounter]->warmup==0)
	    fprintf(stderr, "%02i ", gcounter);
	  else
	    {
	      if (game[gcounter]->warmup)
		{
		  if (!cfg->b_warmup)
		    {
		      game[gcounter]=del_game(game[gcounter]);
		      gcounter--;
		    } else
		      fprintf(stderr, "%02iw ", gcounter);
		}
	      else if (game[gcounter]->complete<1)
		{
		  if (cfg->b_showall==0)
		    {
		      game[gcounter]=del_game(game[gcounter]);
		      gcounter--;
		    } else
		      fprintf(stderr, "%02ia ", gcounter);
		}
	    }
	  gcounter++;
	}
      fprintf(stderr, "\n  parsed %i games in file %i (%i lines)\n",\
	      gcounter-oldcounter,fcounter, linecounter-1);
      fclose(fp);
      fcounter++;
      oldcounter=gcounter;
    }

  
  /* for all games we are calculating the player-results*/
  for (j=0; j<gcounter; j++)
    {
      sum+=size_game(game[j]);
      for(k=0; k<game[j]->nof_players; k++)
	{
	  game[j]->player[k]->effect=sp_effectiveness(game[j]->player[k], s1);
	  if (game[j]->player[k]->secs)
	    game[j]->player[k]->fph=3600.0/
	      (double)game[j]->player[k]->secs*
	      (double)game[j]->player[k]->nof_frags;
	  else game[j]->player[k]->fph=0.0;

	  game[j]->player[k]->ttl=game[j]->player[k]->secs/
	    ((double)game[j]->player[k]->nof_deaths+1.0);

	  /* before calling this, effectiveness *must* be calculated*/
	  game[j]->player[k]->b_winner=check_winner(game[j], k);
	}
      add_game(lts, game[j], s1);
    }

  sum+=size_ltStat(lts);
  fprintf(stderr, "  loaded %i files, %i games\n", fcounter, gcounter);
  fprintf(stderr, "  found %li players\n", lts->nof_players);
  fprintf(stderr, "  using %li MB %06li bytes of memory\n",\
	  sum/1000000, sum%1000000);
  
  /* HTML-output */
  if (gcounter>0 || lts->nof_players>0)
    {
      if (!cfg->b_puretext)
	{
	  fprintf(stderr, "  writing HTML-pages and png-images\n");
	  generate_HTML_TPL(game, gcounter, lts, cfg);
	  //calculation,  outdir, templdir, line_limit, zcompression, b_kick, game_mimimum);
	} else {
	  fprintf(stderr, "  writing pure TEXT\n");
	  generate_Text(game, gcounter, lts, cfg->calculation, cfg->outdir, cfg->templdir);
	}
    } else {
      fprintf(stderr, "  nothing to write\n");
    }
  
  /* if enabled, we save now the lt-stats */
  if (cfg->b_savestats)
    {
      fprintf(stderr, "\n  writing long term stats\n");
      save_stats(lts, cfg->lt_file);
    }

  /* free everything we used */
  for (j=0; j<gcounter; j++)
    if (game[j]!=NULL) game[j]=del_game(game[j]);
  free(game);
  lts=del_ltStat(lts);
  game=NULL;
  s1=cstack_del(s1);
  mapname_free();
  fprintf(stderr, "  done\n");
  return 1;
}






/*
 *
 *
 Main-stuff, mainly created by LCC-Win32 (great Compiler !)
 *
 *
 */
void Usage(char *programName)
{
  char *t=NULL, self=0;
#ifndef GNU_C
  t=strrchr(programName, '\\');
#else
  t=strrchr(programName, '/');
#endif
  if (t==NULL)
    {
      t=strdup("q3_loggen");
      self=1;
    }
  else t++;
  fprintf(stderr,"usage  : %s [switches] <file1>..<fileX>\n", t);
  fprintf(stderr, "  the following switches are available:\n");
  fprintf(stderr, "  -a       - enables HTML-generation for *all* (interupted) games\n");
  fprintf(stderr, "  -c <a+b> - calculation-string for effectiveness\n");
  fprintf(stderr, "  -f       - turns fun-name colors off\n");
  fprintf(stderr, "  -g <c>   - players with less than <c> games will not be listed\n");
  fprintf(stderr, "  -I       - ignore existing long-term stats\n");
  fprintf(stderr, "  -k       - kick players with no frags/deaths\n");
  fprintf(stderr, "  -l <xy>  - sets the global linelimit for all-time stats\n");
  fprintf(stderr, "  -m <file>- name of the mapname-file (default: \"maps.txt\")\n");
  fprintf(stderr, "  -o <path>- output directory (must exist, pix-dir too)\n");
  fprintf(stderr, "  -p       - pure text-output into \"gamestats.txt\"\n");
  fprintf(stderr, "  -S       - saves the LongTimeStats to disk\n");
  fprintf(stderr, "  -t <path>- sets the template-directory\n");
  fprintf(stderr, "  -v       - displays the version\n");
  fprintf(stderr, "  -w       - count warmups as regular game\n");
  fprintf(stderr, "  -z <0..2>- sets the png-compression to fast, default or best\n");
  fprintf(stderr, "  <file>   - complete path to a \"games.log\" - file\n");
  fprintf(stderr, "             (e.g. C:\\Quake3\\baseq3\\games.log)\n");
#ifndef GNU_C
  getchar();
#endif
  if (self && t!=NULL) free(t);
  exit(-1);
}



/* returns the index of the first argument that is not an option; i.e.
   does not start with a dash or a slash*/
int HandleOptions(int argc,char *argv[])
{
  int i,firstnonoption=0;
  
  for (i=1; i< argc;i++) {
    if (argv[i][0] == '-') {
      switch (argv[i][1]) {
        /* An argument -? means help is requested */
      case '?':
        Usage(argv[0]);
        return 0;
      case 'a':
      case 'A':
	cfg->b_showall=1;
	break;
      case 'c':
	if (argv[i+1])
	  {
	    if (cfg->calculation) free(cfg->calculation);
	    cfg->calculation=strdup(argv[++i]);
	  }
	break;

      case 'C':
	if (argv[i+1]!=NULL)
	  {
	    i++;
	    cfg=config_del(cfg);
	    cfg=config_new_load(argv[i]);
	  }
	break;
      case 'f':
      case 'F':
	cfg->b_funname=0;
	break;
      case 'g':
      case 'G':
	if (argv[i+1]!=NULL)
	  {
	    i++;
	    cfg->game_minimum=atoi(argv[i]);
	  }
	break;
      case 'h':
      case 'H':
          Usage(argv[0]);
          return 0;
      case 'I':
	cfg->b_ltstats=0;
	break;
      case 'k':
      case 'K':
	cfg->b_kick=1;
	break;
      case 'l':
      case 'L':
	if (argv[i+1]!=NULL)
	  {
	    cfg->linelimit=atoi(argv[++i]);
	  }
	break;
      case 'm':
      case 'M':
	if (argv[i+1])
	  {
	    if (cfg->mapfile) free(cfg->mapfile);
	    cfg->mapfile=strdup(argv[++i]);
	  }
	break;
      case 'o':
      case 'O':
	if (argv[i+1])
	  {
	    if (cfg->outdir) free(cfg->outdir);
	    cfg->outdir=strdup(argv[++i]);
	  }
	break;
      case 'p':
      case 'P':
	cfg->b_puretext=1;
	break;
      case 'S':
	cfg->b_savestats=1;
	break;
      case 't':
      case 'T':
	cfg->templdir=strdup(argv[++i]);
	break;
      case 'v':
      case 'V':
	fprintf(stderr, "Version %s\n", Q3L_MAIN_VERSION);
	exit(0);
      case 'w':
      case 'W':
	cfg->b_warmup=1;
	break;
      case 'z':
      case 'Z':
	if (argv[i+1]!=NULL)
	  {
	    i++;
	    cfg->zcompression=atoi(argv[i]);
	  }
	break;
      default:
        fprintf(stderr,"unknown option %s\n",argv[i]);
        return 0;
      }
    }
    else
      if (firstnonoption==0)
	firstnonoption = i;
  }
  return firstnonoption;
}




/*
 *
 *
 just a small function :-)
 *
 *
 */
int main(int argc,char *argv[])
{
  int  pos=0;

#ifdef DEBUG_MTRACE
  mtrace();
#endif

  if (argc < 2)
    Usage(argv[0]);

  cfg=config_new_load("q3_loggen.cfg");

  /* handle the program options, get the position of the path-string */
  pos=HandleOptions(argc,argv);
  config_show(cfg);

  //  if (pos>0) {
  if (cfg->templdir==NULL)
    cfg->templdir=strdup("Templates/bright");
  if (cfg->outdir==NULL)
    cfg->outdir=strdup("Html_log");
  if (cfg->calculation==NULL)
    //calculation=strdup("F-((D/2)+(S))");
    cfg->calculation=strdup("(100*K)/(K+D+S)");
  if (cfg->mapfile==NULL)
    cfg->mapfile=strdup("maps.txt");
  if (cfg->lt_file==NULL)
    cfg->mapfile=strdup("longterm.dat");
  if (cfg->tableformat==NULL)
    cfg->tableformat=config_parseTableFormat("NaTiGaGwKiSuTkDeFrFhEfTtCtItTaSo");

  if (cfg->b_ltstats == 1 || pos<argc)
    parse_log_files(&argv[pos]);
#ifndef GNU_C
  getchar();
#endif
  //  }

#if (DEBUG_LEVEL>0)
  /* Size of some used structs :*/
  fprintf(stderr, "Sizes of the structs :\n");
  fprintf(stderr, "t_player : %i\nt_game   : %i\n",\
	  sizeof(t_player),sizeof(t_game));
  fprintf(stderr, "t_lt_pla : %i\nlt_game  : %i\n",\
	  sizeof(t_lt_player),sizeof(t_lt_stats));
#endif

  cfg=config_del(cfg);
  return 0;
}
