/*
  Implementation of all the little helpers and parsers.

  $Id: tool.c,v 2.6 2000/03/02 09:03:35 jacobs Exp jacobs $

  $Log: tool.c,v $
  Revision 2.6  2000/03/02 09:03:35  jacobs
  get_line rewritten for reading chars < 0x20

  Revision 2.5  2000/02/06 20:18:43  jacobs
  *** empty log message ***

  Revision 2.4  2000/01/29 21:41:12  jacobs
  *** empty log message ***

  Revision 2.3  2000/01/25 22:53:37  jacobs
  *** empty log message ***

  Revision 2.2  2000/01/22 22:32:47  jacobs
  *** empty log message ***

  Revision 2.1  2000/01/18 22:50:53  jacobs
  *** empty log message ***

  Revision 1.7  2000/01/14 21:49:15  jacobs
  *** empty log message ***

  Revision 1.6  2000/01/09 23:09:44  jacobs
  new option "-r"

  Revision 1.5  2000/01/09 02:32:17  jacobs
  *** empty log message ***

  Revision 1.4  2000/01/05 03:43:25  jacobs
  *** empty log message ***

  Revision 1.3  2000/01/03 16:04:02  jacobs
  *** empty log message ***

  Revision 1.2  1999/12/30 01:26:21  jacobs
  *** empty log message ***

  Revision 1.1  1999/12/28 22:34:38  jacobs
  Initial revision

*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef GNU_C
#include <unistd.h>
#include <sys/types.h>
#include <dirent.h>
#else
#include <direct.h>
#endif
#include "tools/hpj_string.h"
#include "tools/hpj_tfile.h"
#include "tool.h"
#include "game.h"


char team_name[MAX_TEAMS][10]={"Both Teams", "Red Team", "Blue Team"};
char team_color[MAX_TEAMS][8]={"#550055", "#550000", "#000055"};
char color_suicide[8]="#440044";

char color_bgt_items[8]="#442200";
char color_bgt_weaps[8]="#442200";
char color_bgt_stats[8]="#000022";
char color_bgt_heads[8]="#000000";

char color_bgt_allweaps[8]="#000022";

char color_bg_index[8]="#000000";
char color_text_index[8]="#FFFFBB";
char color_link_index[8]="#FFFFAA";
char color_vlink_index[8]="#DDDDAA";

char color_bg_game[8]="#000000";
char color_text_game[8]="#DDDD99";
char color_bg_allgame[8]="#000000";
char color_text_allgame[8]="#DDDD99";
char color_bg_allplayers[8]="#000000";
char color_text_allplayers[8]="#DDDD99";

char color_bg_killtable[8]="#222222";



const char *html_colors[8] = {"#000000", "#FF0000", "#00FF00", "#FFFF00",
			      "#0000FF", "#00FFFF", "#FF00FF", "#FFFFFF"};


hpj_parray *maps_longname=NULL;
hpj_parray *maps_shortname=NULL;

char funname[MAXFUNNAMELENGTH];
char b_funname=1;


/*
 *
 *
 First, some very often needed helpers ..
 *
 *
 */
char *my_strndup(char *mem, int len)
{
  char *m=(char *)malloc(len+1);
  strncpy(m, mem, len);
  m[len]=0;
  return m;
}

char *get_Line(FILE *fp)
{
  int             pos=1;
  unsigned char  *line=(unsigned char *)malloc(MAXLINELENGTH);

  if (line==NULL) exit_error("MALLOC failed");

  memset(line,0,sizeof(unsigned char) * MAXLINELENGTH);
  while(line[0]<32 && !feof(fp))
    fread(&line[0],1,1,fp);
  
  while(pos<MAXLINELENGTH && line[pos-1]!=10 &&line[pos-1]!=13 && !feof(fp))
    {
      fread(&line[pos],1,1,fp);
      pos++;
    }

  line[pos-1]=0;
  if (feof(fp))
    {if (line!=NULL) free(line);
    return NULL;}
  return (char *)line;
}

void rewind_Line(FILE *fp)
{
  char a=32;

  while(a>15 && ftell(fp)>1)
    {
      fseek(fp,-2,1);
      fread(&a,1,1,fp);
    }
  if (ftell(fp)<1)
    {
      fseek(fp,0,0);
      return;
    }
}


char *get_Keyword_char(char *mem, char *keyword)
{
  char *pos, *tmp;
  pos=strstr(mem, keyword);
  if (pos==NULL) return NULL;
  pos+=strlen(keyword);

  tmp=pos;
  while(*tmp!='\\' && *tmp!=0) tmp++;
  return my_strndup(pos, tmp-pos);
}


int get_Keyword_int(char *mem, char *keyword)
{
  char *pos, *tmp, *m;
  int   val;
  
  pos=strstr(mem, keyword);
  if (pos==NULL) return -1;
  pos+=strlen(keyword);
  
  tmp=pos;
  while(*tmp!='\\' && *tmp!=0) tmp++;
  m=my_strndup(pos, tmp-pos);
  sscanf(m,"%i", &val);
  if (m!=NULL) free(m);
  return val;
}


t_event *get_Event(char *mem)
{
  char    *a, *b;
  int      min=0, sec=-1;
  t_event *event;

  if (mem==NULL) return NULL;

  a=mem;

  /* cut away leading trash */
  while(*a==32 && *a!=0)
    a++;

  /* look for the magic ":" */
  min=0;
  while(*a!=':' && *a!=0)
    {min=min*10 + (*a-'0'); a++;}

  if (*a==0) return NULL;
  a++;

  /* now we check for one or two -> digit seconds (Q3 writes no leading 0)*/
  sec=*(a)-'0';
  if (*(a+1)>='0' && *(a+1)<='9')
    {
      sec=sec*10 + (*(a+1)-'0');
      a++;
    }

  a++;
  if (*a==0) return NULL;
  if (*a==32) a++;

  /* now we have the time ... */
  b=a;
  while(*b!=':' && *b!=0) b++;
  if (*b==0) b=a+1;//return NULL;

  event=(t_event *)malloc(sizeof(t_event));
  memset(event,0,sizeof(t_event));

  event->event=my_strndup(a, b-a);
  if (*(b+1) != 0)
    event->text=strdup(b+1);
  else
    event->text=NULL;
  event->time=min*60+sec;

#if (DEBUG_LEVEL > 1)
  fprintf(stderr, "%02i:%02i (%i) - *%s* -> %s\n", min, sec,
	  event->time, event->event, event->text);
#endif
  return event;
}




/*
 *
 *
 MAPNAME - loader and generator
 *
 *
 */
int mapname_load(char *filename)
{
  hpj_tfile *t=tfile_new(filename);
  hpj_string *s, *s1, *s2;

  maps_shortname=parray_new(4);
  maps_longname=parray_new(4);

  if (tfile_open(t)!=true)
    {
      fprintf(stderr, "  Cant load any long mapnames\n");
      return -1;
    }
  while(!tfile_eof(t))
    {
      s=tfile_getLine(t);
      if (string_length(s)>0 && string_char(s,0)!='#' && string_char(s,0)!='/')
	{
	  s2=NULL;
	  s1=NULL;
	  if (string_count_char(s,'|')==1)
	    {
	      /* its gamespy-like */
	      //fprintf(stderr, "Game-spy map \n");
	      s1=string_token_left(s,'|');
	      s2=string_token_right(s,'|');
	    }
	  else
	    {
	      /* my own format */
	      s1=string_getSiS(s, '"');
	      if (s1!=NULL)
		{
		  //fprintf(stderr, "__1: %s\n", string_charptr(s1));
		  /* we got it - now we shift it left (length + 2 delimiters)*/
		  string_shiftLeft(s,string_length(s1)+2);
		  s2=string_getSiS(s, '"');
		}
	    }
	  if (s1==NULL || s2==NULL)
	    {
	      fprintf(stderr, "  MAPNAME_LOADER: cant parse line : %s\n",\
		      string_charptr(s));
	      if (s1!=NULL) s1=string_del(s1);
	      if (s2!=NULL) s2=string_del(s2);
	    }
	  else
	    {
	      /*fprintf(stderr, "%s-%s\n",\
		string_charptr(s1), string_charptr(s2));*/
	      parray_append(maps_shortname, P2VOIDP(s1));
	      parray_append(maps_longname, P2VOIDP(s2));
	    }
	}
      string_del(s);
    }
  tfile_del(t);
  fprintf(stderr, "  loaded %i map-names\n", parray_elements(maps_longname));
  return 1;
}

char *mapname_generate(char *sname)
{
  int   i;

  for(i=0; i<parray_elements(maps_longname);i++)
    {
      if (string_compare_charptr(V2STRP(parray_get(maps_shortname,i)),
				 sname, true)==0)
	break;
    }
  if (i>=parray_elements(maps_longname))
    return sname;
  return string_charptr(V2STRP(parray_get(maps_longname,i)));
}

void mapname_free()
{
  int i;
  for(i=0; i<parray_elements(maps_longname); i++)
    {
      string_del(parray_get(maps_longname, i));
      string_del(parray_get(maps_shortname, i));
    }
  maps_shortname=parray_del(maps_shortname);
  maps_longname=parray_del(maps_longname);
}


int parse_dir(char *d, char *e, hpj_parray *mapname, hpj_parray *mapimg)
{
  hpj_string *map, *mapn;
  DIR        *dir;
  struct dirent *dent;

  dir=opendir(d);
  if (dir==NULL)
    {
      fprintf(stderr, "  Cant find the \"%s\"-directory for the map-images\n",
	      d);
      return 0;
    }

  while((dent=readdir(dir))!=NULL)
    {
#ifndef __WIN32__
      map=string_new_char(dent->d_name);
#else
      /* a bug in win32-egcs112 ???? It wont work in another way :-( */
      map=string_new_char(dir->dd_dta.name);
#endif
      mapn=string_token_right(map, '.');
      //fprintf(stderr, "%s ---- ", string_charptr(mapn));
      if (string_length(mapn)>0 && string_compare_charptr(mapn, e, true)==0)
	{
	  string_del(mapn);
	  mapn=string_token_left(map, '.');
	  parray_append(mapname, mapn);
	  parray_append(mapimg, map);
	} else {
	  string_del(mapn);
	  string_del(map);
	}
    }
  closedir(dir);
  fprintf(stderr, "  found %i images for the maps\n",parray_elements(mapname));
  return parray_elements(mapname);
}







/*
 *
 *
 SORTING
 *
 *
 *
   I did not get it working with an additional text[][] - param, else
   the sort_weaps, sort_things could be wasted
*/
void sort_things(int *thing, int *sort, int len)
{
  int i,j, todo;

  for (i=0; i<len; i++)
    sort[i]=i;

  todo=1;
  while(todo)
    {
      todo=0;
      for (i=0; i<len-1; i++)
	{
	  if (thing[sort[i]]>thing[sort[i+1]]) continue;

	  if (thing[sort[i]]<thing[sort[i+1]])
	    {
	      j=sort[i];
	      sort[i]=sort[i+1];
	      sort[i+1]=j;
	      todo=1;
	    }
	}
    }
}

void sort_weaps(long int weaps[NOF_WEAPS], long int sort[NOF_WEAPS])
{
  int      i, todo;
  long int j;

  for (i=0; i<NOF_WEAPS; i++)
    sort[i]=i;

  todo=1;
  while(todo)
    {
      todo=0;
      for (i=0; i<NOF_WEAPS-1; i++)
	{
	  if (weaps[sort[i]]>weaps[sort[i+1]]) continue;

	  if ( (weaps[sort[i]]<weaps[sort[i+1]]) ||
	       (strcmp(c_weaps[sort[i]], c_weaps[sort[i+1]])>0) )
	    {
	      j=sort[i];
	      sort[i]=sort[i+1];
	      sort[i+1]=j;
	      todo=1;
	    }
	}
    }
}


void sort_items(long int items[NOF_ITEMS], long int sort[NOF_ITEMS])
{
  int       i, todo;
  long int  j;

  for (i=0; i<NOF_ITEMS; i++)
    sort[i]=i;

  todo=1;
  while(todo)
    {
      todo=0;
      for (i=0; i<NOF_ITEMS-1; i++)
	{
	  if (items[sort[i]]>items[sort[i+1]]) continue;

	  if ( (items[sort[i]]<items[sort[i+1]]) ||
	       (strcmp(c_items_nice[sort[i]], c_items_nice[sort[i+1]])>0) )
	    {
	      j=sort[i];
	      sort[i]=sort[i+1];
	      sort[i+1]=j;
	      todo=1;
	    }
	}
    }
}









/*
 *
 *
 FUN-NAMEs should keep their color
 *
 *
 */
const char *make_funname(char *name, int fun)
{
  int   i=0, lastcolor=-1, color=7;
  char *b, *mem;

  memset(funname, 0, MAXFUNNAMELENGTH);
  if (name==NULL) return funname;
  mem=(char *)malloc(MAXFUNNAMELENGTH);
  memset(mem,0,MAXFUNNAMELENGTH);

  /* also if fun-names are not used, so we still want to get "<"">" for HTML*/
  b=mem;
  for (i=0; i<strlen(name)+1;i++)
    {
      while(*b!=0) b++;
      if(name[i]=='<')
	strcat(b,"&laquo;");
      else {
	if (name[i]=='>')
	  strcat(b,"&raquo;");
	else
	  *b=name[i];
      }
    }
  *b=0;

  //fprintf(stderr, "%s -> %s\n", name, mem);
  /* no funname used, exit now */
  if (strchr(mem, '^')==NULL)
    {
      strcpy(funname, mem);
      free(mem);
      return funname;
    }


  /* if people dont like fun-names, remove color-infos */
  if (!b_funname || !fun)
    {
      b=funname;
      for (i=0; i<strlen(mem); i++)
	{
	  if(mem[i]=='^')
	    { i++; continue;}
	  *(b++)=mem[i];
	}
      free(mem);
      *b=0;
      return funname;
    }

  i=0;
  /* lets start the color-coding */
  if(mem[0]!='^' || mem[1]<'0' || mem[1]>'9')
    strcpy(funname, "<font color=\"#FFFFFF\">");
  else
    {
      color=mem[1]-'0';
      if (color<0 || color>7) color=7;
      sprintf(funname, "<font color=\"%s\">",html_colors[color]);
      lastcolor=color;
      i=2;
    }
  b=funname;
  for(; i<strlen(mem); i++)
    {
      if (mem[i]=='^' && (mem[i+1]>='0' && mem[i+1]<='9'))
	{color=mem[i+1]-'0'; i++; continue;}
      while(*b!=0)
	b++;
      if (mem[i]==0) break;
      if (color!=lastcolor && color<8 && color>-1)
	{
	  sprintf(b, "</font><font color=\"%s\">", html_colors[color]);
	  lastcolor=color;
	}
      while(*b!=0)
	b++;
      sprintf(b, "%c", mem[i]);
    }
  strcat(b, "</font>");
  free(mem);
  return funname;
}











/*
 *
 *
 *
 Some helpers for the effectiveness-calculation
 *
 *
 */
int isValid(char m)
{
  if (m=='F') return 1;
  if (m=='D') return 1;
  if (m=='T') return 1;
  if (m=='S') return 1;
  if (m=='t') return 1;
  if (m=='K') return 1;
  return 0;
}

hpj_cstack *parse_string(char *c)
{
  hpj_cstack *s1=cstack_new(1);
  hpj_cstack *s2=cstack_new(1);
  char     mem[100], *t;
  int      p;

  //fprintf(stderr, "IN : %s\n", c);
  while(*c!=0)
    {
      //fprintf(stderr, " %c ", *c);
      if (*c==')')
	{
	  if (s2->sp<1)
	    fprintf(stderr, "ERROR in calculation\n");
	  else
	    {
	      t=cstack_pop(s2);
	      cstack_push(s1,t);
	      free(t);
	    }
	}
      if (*c=='+') cstack_push_char(s2,*c);
      if (*c=='*') cstack_push_char(s2,*c);
      if (*c=='-') cstack_push_char(s2,*c);
      if (*c=='/') cstack_push_char(s2,*c);
      if (isValid(*c)) cstack_push_char(s1,*c);
      if (*c>='0' && *c<='9')
	{
	  p=0;
	  while ((*c>='0' && *c<='9') || *c=='.')
	    {
	      mem[p]=*c;
	      p++;
	      c++;
	    }
	  mem[p]=0;
	  cstack_push(s1, mem);
	  c--;
	}
      c++;
    }
  while(s2->sp>0)
    {
      t=cstack_pop(s2);
      cstack_push(s1,t);
      free(t);
    }
  //fprintf(stderr,"\n");
  //stack_show(s1);
  s2=cstack_del(s2);
  //printf("\n");
  return s1;
}


double eval_stack_ap(hpj_cstack *s, t_lt_player *ltp)
{
  char    *p;
  double   l,r;

  while(s->sp>=0)
    {
      p=cstack_pop(s);
      //fprintf(stderr, "-->%s<--\n", p);
      switch(p[0])
	{
	case '+':
	  r=eval_stack_ap(s, ltp);
	  l=eval_stack_ap(s, ltp);
	  free(p);
	  return l+r;
	  break;
	case '*':
	  r=eval_stack_ap(s, ltp);
	  l=eval_stack_ap(s, ltp);
	  free(p);
	  return l*r;
	  break;
	case '-':
	  r=eval_stack_ap(s, ltp);
	  l=eval_stack_ap(s, ltp);
	  free(p);
	  return l-r;
	  break;
	case '/':
	  r=eval_stack_ap(s, ltp);
	  l=eval_stack_ap(s, ltp);
	  free(p);
	  if (r!=0.0)
	    return l/r;
	  else return 0.0;
	  break;
	case 'F':
	  free(p);
	  return ltp->nof_frags;
	  break;
	case 'S':
	  free(p);
	  return ltp->nof_suicides;
	  break;
	case 'D':
	  free(p);
	  return ltp->nof_deaths;
	  break;
	case 'T':
	  free(p);
	  return ltp->nof_tkills;
	  break;
	case 't':
	  free(p);
	  return ltp->secs;
	  break;
	case 'K':
	  free(p);
	  return ltp->nof_kills;
	  break;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	  //fprintf(stderr, "---ii->%s<--\n", p);
	  sscanf(p,"%lf", &l);
	  //fprintf(stderr, "--%f--\n", l);
	  free(p);
	  return (double)l;
	  break;
	default:
	  fprintf(stderr, "UNKNOWN item on stack : %s !\n", p);
	  free(p);
	  break;
	}
    }
  return -100.0;
}



double eval_stack_sp(hpj_cstack *s, t_player *sp)
{
  char    *p;
  double   l,r;

  while(s->sp>=0)
    {
      p=cstack_pop(s);
      //fprintf(stderr, "-->%s<--\n", p);
      switch(p[0])
	{
	case '+':
	  r=eval_stack_sp(s, sp);
	  l=eval_stack_sp(s, sp);
	  free(p);
	  return l+r;
	  break;
	case '*':
	  r=eval_stack_sp(s, sp);
	  l=eval_stack_sp(s, sp);
	  free(p);
	  return l*r;
	  break;
	case '-':
	  r=eval_stack_sp(s, sp);
	  l=eval_stack_sp(s, sp);
	  free(p);
	  return l-r;
	  break;
	case '/':
	  r=eval_stack_sp(s, sp);
	  l=eval_stack_sp(s, sp);
	  free(p);
	  if (r!=0.0)
	    return l/r;
	  else return 0.0;
	  break;
	case 'F':
	  free(p);
	  return sp->nof_frags;
	  break;
	case 'S':
	  free(p);
	  return sp->nof_suicides;
	  break;
	case 'D':
	  free(p);
	  return sp->nof_deaths;
	  break;
	case 'T':
	  free(p);
	  return sp->nof_tkills;
	  break;
	case 't':
	  free(p);
	  return sp->secs;
	  break;
	case 'K':
	  free(p);
	  return sp->nof_kills;
	  break;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	  //fprintf(stderr, "---ii->%s<--\n", p);
	  sscanf(p,"%lf", &l);
	  //fprintf(stderr, "--%f--\n", l);
	  free(p);
	  return (double)l;
	  break;
	default:
	  fprintf(stderr, "UNKNOWN item on stack : %s !\n", p);
	  free(p);
	  break;
	}
    }
  return -100.0;
}






double ltp_effectiveness(t_lt_player *ltp, hpj_cstack *stack)
{
  double   retcode=0.0;
  hpj_cstack *s2;

  if (stack==NULL)
    {
      retcode=(double)ltp->nof_frags - (double)ltp->nof_deaths/10.0;
      if (ltp->secs) retcode/=(double)ltp->secs/60.0;
      else retcode=0.0;
      return retcode;
    }

  s2=cstack_clone(stack);
  retcode=eval_stack_ap(s2, ltp);
  s2=cstack_del(s2);
  return retcode;
}

double sp_effectiveness(t_player *sp, hpj_cstack *stack)
{
  double   retcode=0.0;
  hpj_cstack *s2;

  if (stack==NULL)
    {
      retcode=(double)sp->nof_frags - (double)sp->nof_deaths/10.0;
      if (sp->secs) retcode/=(double)sp->secs/60.0;
      else retcode=0.0;
      return retcode;
    }

  s2=cstack_clone(stack);
  retcode=eval_stack_sp(s2, sp);
  s2=cstack_del(s2);
  return retcode;
}


/* displays the error and jumps out - not very nice, but sometimes .. */
void exit_error(char *msg)
{
  fprintf(stderr, msg);
  exit(-1);
}
