/*
  Usefull functions for parsing the file and teh events.

  $Id: tool.h,v 2.4 2000/01/29 21:41:12 jacobs Exp jacobs $

  $Log: tool.h,v $
  Revision 2.4  2000/01/29 21:41:12  jacobs
  *** empty log message ***

  Revision 2.3  2000/01/25 22:53:37  jacobs
  *** empty log message ***

  Revision 2.2  2000/01/22 22:32:47  jacobs
  *** empty log message ***

  Revision 2.1  2000/01/18 22:50:53  jacobs
  *** empty log message ***

  Revision 1.6  2000/01/14 21:49:15  jacobs
  *** empty log message ***

  Revision 1.5  2000/01/09 02:32:17  jacobs
  *** empty log message ***

  Revision 1.4  2000/01/05 03:43:25  jacobs
  *** empty log message ***

  Revision 1.3  2000/01/03 16:04:02  jacobs
  *** empty log message ***

  Revision 1.2  1999/12/31 02:21:41  jacobs
  *** empty log message ***

  Revision 1.1  1999/12/28 22:34:38  jacobs
  Initial revision

*/
#ifndef __TOOL_H__
#define __TOOL_H__

/* This can be static, because its simply exist just one time */
#ifndef MAXFUNNAMELENGTH
#define MAXFUNNAMELENGTH 4096
#endif

#include "tools/hpj_cstack.h"
#include "tools/hpj_parray.h"
#include "game.h"
#include "lt_stats.h"
#include <stdio.h>

extern char team_name[MAX_TEAMS][10];
extern char team_color[MAX_TEAMS][8];
extern char color_suicide[8];

extern char color_bgt_items[8];
extern char color_bgt_weaps[8];
extern char color_bgt_stats[8];
extern char color_bgt_heads[8];

extern char color_bgt_allweaps[8];

extern char color_bg_index[8];
extern char color_text_index[8];
extern char color_link_index[8];
extern char color_vlink_index[8];

extern char color_bg_game[8];
extern char color_text_game[8];
extern char color_bg_allgame[8];
extern char color_text_allgame[8];
extern char color_bg_allplayers[8];
extern char color_text_allplayers[8];

extern char color_bg_killtable[8];

extern hpj_parray *maps_longname;
extern hpj_parray *maps_shortname;

/* This can be used to set funname-support to FALSE (0) or TRUE (1-default)*/
extern char b_funname;


#ifndef strndup
char  *my_strndup(char *mem, int len);
#endif

/*
 *
 *
 This are the functions for parsing the log-file
 *
 *
 */
char  *get_Line(FILE *fp);
void   rewind_Line(FILE *fp);
char  *get_Keyword_char(char *mem, char *keyword);
int    get_Keyword_int(char *mem, char *keyword);

t_event *get_Event(char *mem);


/*
 *
 *
 now some functions for reading and generating map-names
 *
 *
 */
int  mapname_load(char *filename);
/* Generates a new string -> YOU MUST NOT free() the returned pointer !!! */
char *mapname_generate(char *shortname);
void mapname_free();
/* This looks in the pix/maps - dir for files */
int  parse_dir(char *dir, char *end, hpj_parray *mapname, hpj_parray *mapimg);


/*
 *
 *
 Sort-functions for HTML-output
 *
 *
 */
void sort_things(int *thing, int *sort, int len);
void sort_weaps(long int weaps[NOF_WEAPS], long int sort[NOF_WEAPS]);
void sort_items(long int items[NOF_ITEMS], long int sort[NOF_ITEMS]);


/** Fun-name stuff -> do not free the returned pointer, its static */
const char *make_funname(char *input, int fun);

/** Very usefull things for effectiveness-calculation */
hpj_cstack *parse_string(char *c);
double ltp_effectiveness(t_lt_player *ltp, hpj_cstack *stack);
double sp_effectiveness(t_player *sp, hpj_cstack *stack);

void exit_error(char *msg);

#endif
