/* Basic collection of Image-ops.
   For now its just a container for the image-dats.
   Imag-dats must be 8-bit.<br>
   Its used for palettes (256 * (R+G+B)) and images.<br>

   @author Hans-Peter Jacobs
   @version $Id$

   @name hpj_image

*/
#ifndef __HPJ_IMAGE_H__
#define __HPJ_IMAGE_H__

#ifndef INT32
#define INT32 int
#endif

#ifndef CHAR
#define CHAR char
#endif

#ifndef UCHAR
#define UCHAR unsigned char
#endif

typedef struct{
  CHAR   *filename;
  UCHAR  *mem;
  UCHAR  *palmem;
  CHAR    rrggbb[7];
  INT32   width, height;
  INT32   palnums;
}hpj_image;

hpj_image *image_new();
hpj_image *image_del(hpj_image *image);
INT32 image_createData(hpj_image *i, int dx, int dy);
INT32 image_setFilename(hpj_image *i, char *fname);

CHAR *image_copyData(hpj_image *image);

INT32 image_loadPal(hpj_image *image, CHAR *filename);
void  image_getPal(hpj_image *image, hpj_image *source);

/*INT32 image_loadPNG(hpj_image *image, CHAR *filename);
  INT32 image_savePNG(hpj_image *image, CHAR *filename);*/

CHAR *image_palRefToRRGGBB(hpj_image *image, INT32 index);

#endif
