/** This is now my first try to get all the usefull and really
    often needed code into one file

    $Id$

    $Log$

*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "hpj_tfile.h"


#ifndef __FILE__
#define __FILE__ "hpj_tfile.c"
#endif

/** Creates a new file-struct.*/
hpj_tfile *tfile_new(CHAR *filename)
{
  hpj_tfile *f;

  if (filename==NULL)
    {
      fprintf(stderr, "  %s : new : NULL-Ptr\n", __FILE__);
      return NULL;
    }
  f=(hpj_tfile *)malloc(sizeof(hpj_tfile));
  f->filename=strdup(filename);
  f->fp=NULL;
  return f;
}

/** This closes the file if needed.*/
hpj_tfile *tfile_del(hpj_tfile *f)
{
  if (f==NULL)
    {
      fprintf(stderr, "  %s : del : NULL-Ptr\n", __FILE__);
      return NULL;
    }
  if (f->fp) fclose(f->fp);
  f->fp=NULL;
  free(f->filename);
  free(f);
  return NULL;
}


/** Opens a file */
boolean tfile_open(hpj_tfile *f)
{
  f->fp=fopen(f->filename, "r+b");
  if (f->fp==NULL) return false;
  return true;
}


/** Closes a file */
boolean tfile_close(hpj_tfile *f)
{
  if (f->fp) fclose(f->fp);
  f->fp=NULL;
  return true;
}

/** Returns the state of the file */
boolean tfile_eof(hpj_tfile *f)
{
  if (feof(f->fp)) return true;
  return false;
}


/** Forwards to the next character */
void tfile_forward(hpj_tfile *f)
{
  if (f->fp==NULL)
    {
      fprintf(stderr, "  %s : getLine : no open file\n", __FILE__);
      return;
    }
  f->a=0;
  while (f->a<=32 && !feof(f->fp))
    fread(&f->a,1,1,f->fp);
  if (!feof(f->fp)) fseek(f->fp,-1,1);
  return;
}


/** Gets a line from Input-file */
hpj_string *tfile_getLine(hpj_tfile *f)
{
  hpj_string *line=string_new();
  if (line==NULL)
    {
      fprintf(stderr, "  %s : getLine : MALLOC\n", __FILE__);
      return NULL;
    }
  if (f->fp==NULL)
    {
      fprintf(stderr, "  %s : getLine : no open file\n", __FILE__);
      return NULL;
    }

  tfile_forward(f);

  f->a='a';
  while(!feof(f->fp) && f->a>=32)
    {
      fread(&f->a,1,1,f->fp);
      //fprintf(stderr, "%c", f->a);
      if (f->a>=32 && !feof(f->fp)) string_append_single_char(line, f->a);
    }

  return line;
}
